/**
 * \file
 *
 * \brief SAM D20/D21/R21s ײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "nvm.h"
#include <system.h>
#include <system_interrupt.h>
#include <string.h>

/**
 * \internal ޲̍\
 *
 * ̍\̂͊e֐ɂēxXgpNVMPʕɂĂ̏܂݂܂B
 * nvm_init()֐ō\̂ɐݒ肳܂B
 */
struct _nvm_module {
	uint16_t page_size;			/**< ߰ނɊ܂܂޲Đ */
	uint16_t number_of_pages;	/**< NVMؓ̑߰ސ */
	bool manual_page_write;		/**< \c falseȂA߰ޏݎw߂߰ފɏՊ햞tɎIɔs܂B */
};

/**
 * \internal ޲̎̍\
 */
static struct _nvm_module _nvm_dev;

/**
 * \internal NVM MEMORŸJnڽւ̈ʒuwq
 */
#define NVM_MEMORY			((volatile uint16_t *)FLASH_ADDR)

/**
 * \internal NVM USER MEMORŸJnڽւ̈ʒuwq
 */
#define NVM_USER_MEMORY		((volatile uint16_t *)NVMCTRL_USER)


/**
 * \brief `ԐݒɊÂNVMʰ޳Pʕ\ݒ
 *
 * NVM`Ԑݒ̗^ꂽ`Ԑݒʰ޳Pʕɏē޲\
 * 
 *
 * \param[in]  config NVMp`Ԑݒ̐ݒ
 *
 * \note ̊֐肭g߂ɕیޯĂ͉Ȃ΂Ȃ܂B
 *       ߏɂĂ̂ݍs܂B
 *
 * \return `Ԑݒ葱̏
 *
 * \retval STATUS_OK     ꍇ
 * \retval STATUS_BUSY   ݂ɒPʕZꍇ
 * \retval STATUS_ERR_IO EEPROM⏕Ԃ̌`Ԑݒς邱Ƃh
 *                       یޯĂݒ肳Ăꍇ
 */
enum status_code nvm_set_config(
		const struct nvm_config *const config)
{
	/*  */
	Assert(config);

	/* Pʕʰ޳̂ւ̈ʒuwq */
	Nvmctrl *const nvm_module = NVMCTRL;

	/* ޼ ̪ ۯON */
	system_apb_clock_set_mask(SYSTEM_CLOCK_APB_APBB, PM_APBBMASK_NVMCTRL);

	/* ُ׸މ */
	nvm_module->STATUS.reg |= NVMCTRL_STATUS_MASK;

	/* PʕZ */
	if (!nvm_is_ready()) {
		return STATUS_BUSY;
	}

	/* CTRLBڼ޽Ɍ`Ԑݒ菑 */
	nvm_module->CTRLB.reg =
			NVMCTRL_CTRLB_SLEEPPRM(config->sleep_power_mode) |
			((config->manual_page_write & 0x01) << NVMCTRL_CTRLB_MANW_Pos) |
			NVMCTRL_CTRLB_RWS(config->wait_states) |
			((config->disable_cache & 0x01) << NVMCTRL_CTRLB_CACHEDIS_Pos) |
			NVMCTRL_CTRLB_READMODE(config->cache_readmode);


	/* ޲\̏ */
	_nvm_dev.page_size         = (8 << nvm_module->PARAM.bit.PSZ);
	_nvm_dev.number_of_pages   = nvm_module->PARAM.bit.NVMP;
	_nvm_dev.manual_page_write = config->manual_page_write;

	/* یޯĐݒ̏ꍇA⏕Ԃ͏܂B */
	if (nvm_module->STATUS.reg & NVMCTRL_STATUS_SB) {
		return STATUS_ERR_IO;
	}

	return STATUS_OK;
}

/**
 * \brief NVMŎwߎs
 *
 * NVM߰ޓǂݍ݂⏑ݑ̂悤ȗvꂽs邽߂ɁANVM
 * Ŕ񓯊w߂s܂B
 *
 * \note ֐͗^ꂽw߂OɕԂ܂B
 *
 * \param[in]  command   NVMɔsw
 * \param[in]  address   NVM؋ԂNVMɓnڽ
 * \param[in]  parameter ײނɑ΂ĕsgpNVMɓnҰ
 *
 * \return wߎs݂̎̏
 *
 * \retval STATUS_OK              w߂󂯓Ďsi
 * \retval STATUS_BUSY            VwߔsNVM킪ɎwߎsZ
 *                                ꍇ
 * \retval STATUS_ERR_IO          ؂܂͕ی̎{̂ߎw߂ꍇ
 * \retval STATUS_ERR_INVALID_ARG ^ꂽw߂xꍇ
 * \retval STATUS_ERR_BAD_ADDRESS ^ڽꍇ
 */
enum status_code nvm_execute_command(
		const enum nvm_command command,
		const uint32_t address,
		const uint32_t parameter)
{
	uint32_t temp;

	/* ^ꂽڽL */
	if (address > ((uint32_t)_nvm_dev.page_size * _nvm_dev.number_of_pages)){
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* Pʕʰ޳̂ւ̈ʒuwq */
	Nvmctrl *const nvm_module = NVMCTRL;

	/* ׯwߔsOɷOFF */
	temp = nvm_module->CTRLB.reg;
	nvm_module->CTRLB.reg = temp | NVMCTRL_CTRLB_CACHEDIS;

	/* ُ׸މ */
	nvm_module->STATUS.reg |= NVMCTRL_STATUS_MASK;

	/* PʕZ */
	if (!nvm_is_ready()) {
		return STATUS_BUSY;
	}

	switch (command) {

		/* (ی삳ꂽ)ڽKvƂw */
		case NVM_COMMAND_ERASE_AUX_ROW:
		case NVM_COMMAND_WRITE_AUX_ROW:

			/* یޯĂݒ̏ꍇɕ⏕Ԃͱs\ */
			if (nvm_module->STATUS.reg & NVMCTRL_STATUS_SB) {
				return STATUS_ERR_IO;
			}

			/* ڽݒAw߂͑̏ꏊŔs */
			nvm_module->ADDR.reg = (uintptr_t)&NVM_MEMORY[address / 4];
			break;

		/* (ی삳Ȃ)ڽKvƂw */
		case NVM_COMMAND_ERASE_ROW:
		case NVM_COMMAND_WRITE_PAGE:
		case NVM_COMMAND_LOCK_REGION:
		case NVM_COMMAND_UNLOCK_REGION:

			/* ڽݒAw߂͑̏ꏊŔs */
			nvm_module->ADDR.reg = (uintptr_t)&NVM_MEMORY[address / 4];
			break;

		/* ڽKvƂȂw */
		case NVM_COMMAND_PAGE_BUFFER_CLEAR:
		case NVM_COMMAND_SET_SECURITY_BIT:
		case NVM_COMMAND_ENTER_LOW_POWER_MODE:
		case NVM_COMMAND_EXIT_LOW_POWER_MODE:
			break;

		default:
			return STATUS_ERR_INVALID_ARG;
	}

	/* wߐݒ */
	nvm_module->CTRLA.reg = command | NVMCTRL_CTRLA_CMDEX_KEY;

	/* ɂȂ邽߂NVM҂ */
	while (!nvm_is_ready()) {
	}

	/* ݒ蕜 */
	nvm_module->CTRLB.reg = temp;

	return STATUS_OK;
}

/**
 * \brief Vް߰ނ̔Cӗ̈XV
 *
 * ߰ނŊɊi[ꂽύXȂް擾ĊɏՕNVM̗ؓ^
 * ߰ނɏ
 *
 * \warning ٰ݂ްSdvȏꍇɈSł͂ȂAXV̼ ؾ
 *          Ăް̍ő1̌ʂł傤B(d⼽ ؾĂ܂)S
 *          Ă̏󋵂ŕsȂ΂ȂȂꍇÅ֐͎gp
 *          ł͂܂B
 *
 * \param[in]  destination_address ߰ޱڽ
 * \param[in]  buffer              ްi[ĂɏՕւ̈ʒuwq
 * \param[in]  offset              ߰ޓްψʂ܂ł޲Đ
 * \param[in]  length              ߰ޓ̍XV޲Đ
 *
 * \return ߰ނXV鎎݂̏
 *
 * \retval STATUS_OK              vNVM ߰ނɓǂ܂ꂽB
 * \retval STATUS_BUSY            ݂NVM킪ZB
 * \retval STATUS_ERR_BAD_ADDRESS vڽNVMؗ̈̎󂯓\͈͊O
 *                                B
 * \retval STATUS_ERR_INVALID_ARG ƕψʂB
 */
enum status_code nvm_update_buffer(
		const uint32_t destination_address,
		uint8_t *const buffer,
		uint16_t offset,
		uint16_t length)
{
	enum status_code error_code = STATUS_OK;
	uint8_t row_buffer[NVMCTRL_ROW_PAGES][NVMCTRL_PAGE_SIZE];

	/* ǂݍ݂߰ނ̑傫ȂƂۏ */
	if ((offset + length) > _nvm_dev.page_size) {
		return STATUS_ERR_INVALID_ARG;
	}

	/* XV߰ނ̊JnڽvZ */
	uint32_t row_start_address =
			destination_address & ~((_nvm_dev.page_size * NVMCTRL_ROW_PAGES) - 1);

	/* ݂̗eǂݍ */
	for (uint32_t i = 0; i < NVMCTRL_ROW_PAGES; i++) {
		do
		{
			error_code = nvm_read_buffer(
					row_start_address + (i * _nvm_dev.page_size),
					row_buffer[i], _nvm_dev.page_size);
		} while (error_code == STATUS_BUSY);

		if (error_code != STATUS_OK) {
			return error_code;
		}
	}

	/* XV̊Jn߰ނvZ */
	uint8_t page_in_row =
			(destination_address % (_nvm_dev.page_size * NVMCTRL_ROW_PAGES)) /
			_nvm_dev.page_size;

	/* ߰ފɏՕŎw肵޲ĂXV */
	for (uint32_t i = 0; i < length; i++) {
		row_buffer[page_in_row][offset + i] = buffer[i];
	}

	system_interrupt_enter_critical_section();

	/*  */
	do
	{
		error_code = nvm_erase_row(row_start_address);
	} while (error_code == STATUS_BUSY);

	if (error_code != STATUS_OK) {
		return error_code;
	}

	/* ֍XVe */
	for (uint32_t i = 0; i < NVMCTRL_ROW_PAGES; i++) {
		do
		{
			error_code = nvm_write_buffer(
					row_start_address + (i * _nvm_dev.page_size),
					row_buffer[i], _nvm_dev.page_size);
		} while (error_code == STATUS_BUSY);

		if (error_code != STATUS_OK) {
			return error_code;
		}
	}

	system_interrupt_leave_critical_section();

	return error_code;
}

/**
 * \brief NVMؗ̈ő޲Ă߰ނɏ
 *
 * ɏՕNVM؂̗^ꂽ߰ ڽɏ
 *
 * \param[in]  destination_address ߰ޱڽ
 * \param[in]  buffer              ްi[ꂽɏՕւ̈ʒuwq
 * \param[in]  length              ߰ޓ̏޲Đ
 *
 * \note ȑOɏꂽ߰ނɏꍇAVް߰ނɏ݂̂O
 *       (\ref nvm_erase_row()oR)߰ނ̗͏ׂłB
 *
 * \return ߰ޏ݂݂̎̏
 *
 * \retval STATUS_OK              vNVM؂ɓǂ܂ꂽB
 * \retval STATUS_BUSY            삪݂ꂽNVM킪ZB
 * \retval STATUS_ERR_BAD_ADDRESS vڽNVMؗ̈̎󂯓\͈͊O
 *                                B
 * \retval STATUS_ERR_INVALID_ARG ꂽݒB
 */
enum status_code nvm_write_buffer(
		const uint32_t destination_address,
		const uint8_t *buffer,
		uint16_t length)
{
	/* ]ڽL */
	if (destination_address >
			((uint32_t)_nvm_dev.page_size * _nvm_dev.number_of_pages)) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* ݱڽ߰ނ̎n߂ɐ񂳂ĂȂ */
	if (destination_address & (_nvm_dev.page_size - 1)) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* ݒNVM߰ނ */
	if (length > _nvm_dev.page_size) {
		return STATUS_ERR_INVALID_ARG;
	}

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Nvmctrl *const nvm_module = NVMCTRL;

	/* PʕZ */
	if (!nvm_is_ready()) {
		return STATUS_BUSY;
	}

	/* VްɏՂO߰ފɏՕ */
	nvm_module->CTRLA.reg = NVM_COMMAND_PAGE_BUFFER_CLEAR | NVMCTRL_CTRLA_CMDEX_KEY;

	/* PʕZ */
	while (!nvm_is_ready()) {
		/* ɏՕҋ@ */
	}

	/* ُ׸މ */
	nvm_module->STATUS.reg |= NVMCTRL_STATUS_MASK;

	uint32_t nvm_address = destination_address / 2;

	/* NVM͈A16ޯČƂıȂ΂Ȃ炸Aۏ؂邽߂Ɏ
	 * ʂs */
	for (uint16_t i = 0; i < length; i += 2) {
		uint16_t data;

		/* 16ޯĉ̐擪޲ĂꎞɏՕ֕ */
		data = buffer[i];

		/* ޲Čvŏݗv̍ŌłȂꍇAXް̎޲Ăi[ */
		if (i < (length - 1)) {
			data |= (buffer[i + 1] << 8);
		}

		/* 16ޯĉNVM؋ԂɊi[ */
		NVM_MEMORY[nvm_address++] = data;
	}

	/* sׂް̒߰ނ̑傫ȂɎ蓮NVM݂
	 * s */
	if (length < NVMCTRL_PAGE_SIZE) {
		return nvm_execute_command(NVM_COMMAND_WRITE_PAGE,
				destination_address, 0);
	}

	return STATUS_OK;
}

/**
 * \brief NVMؗ̈߰ނ瑽޲Ăǂݍ
 *
 * NVM؋Ԃ̗^ꂽ߰ ڽɏՕ֗^ꂽ޲Đǂݍ
 *
 * \param[in]   source_address ǂތ߰ ڽ
 * \param[out]  buffer         ǂ߰ނ̓ei[ɏՕւ̈ʒuwq
 * \param[in]   length         ߰ޓ̓ǂ޲Đ
 *
 * \return ߰ޓǂݍݎs̏
 *
 * \retval STATUS_OK              vNVM ߰ނɓǂ܂ꂽB
 * \retval STATUS_BUSY            삪݂ꂽNVM킪ZB
 * \retval STATUS_ERR_BAD_ADDRESS vڽNVMؗ̈̎󂯓\͈͊O
 *                                B
 * \retval STATUS_ERR_INVALID_ARG ꂽǂݍݒB
 */
enum status_code nvm_read_buffer(
		const uint32_t source_address,
		uint8_t *const buffer,
		uint16_t length)
{
	/* ]ڽL */
	if (source_address >
			((uint32_t)_nvm_dev.page_size * _nvm_dev.number_of_pages)) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* ǂݍݱڽ߰ނ̎n߂ɐ񂳂ĂȂ */
	if (source_address & (_nvm_dev.page_size - 1)) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* ǂݍݒNVM߰ނe */
	if (length > _nvm_dev.page_size) {
		return STATUS_ERR_INVALID_ARG;
	}

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Nvmctrl *const nvm_module = NVMCTRL;

	/* PʕZ */
	if (!nvm_is_ready()) {
		return STATUS_BUSY;
	}

	/* ُ׸މ */
	nvm_module->STATUS.reg |= NVMCTRL_STATUS_MASK;

	uint32_t page_address = source_address / 2;

	/* NVM͈A16ޯČƂıȂ΂Ȃ炸Aۏ؂邽߂Ɏ
	 * ʂs */
	for (uint16_t i = 0; i < length; i += 2) {
		/* NVM؋Ԃ玟16ޯĉ擾 */
		uint16_t data = NVM_MEMORY[page_address++];

		/* 16ޯĉ̐擪޲Ă]ɏՕɕ */
		buffer[i] = (data & 0xFF);

		/* ޲Čvœǂݍݗv̍ŌłȂꍇAXް̎޲Ăi[ */
		if (i < (length - 1)) {
			buffer[i + 1] = (data >> 8);
		}
	}

	return STATUS_OK;
}

/**
 * \brief NVM؋Ԃŗ
 *
 * NVMؗ̈ŗ^ꂽ܂B
 *
 * \param[in]  row_address ̱ڽ
 *
 * \return NVM݂̎̏
 *
 * \retval STATUS_OK              vNVMؗ񂪐ɏꂽB
 * \retval STATUS_BUSY            삪݂ꂽNVM킪ZB
 * \retval STATUS_ERR_BAD_ADDRESS vڽNVMؗ̈̎󂯓\͈͊O
 *                                ܂͗̎n߂ɐ񂵂ĂȂB
 */
enum status_code nvm_erase_row(
		const uint32_t row_address)
{
	/* ڽL */
	if (row_address >
			((uint32_t)_nvm_dev.page_size * _nvm_dev.number_of_pages)) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* ڽ̎n߂ɐ񂳂Ă邩 */
	if (row_address & ((_nvm_dev.page_size * NVMCTRL_ROW_PAGES) - 1)) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Nvmctrl *const nvm_module = NVMCTRL;

	/* PʕZy */
	if (!nvm_is_ready()) {
		return STATUS_BUSY;
	}

	/* ُ׸މ */
	nvm_module->STATUS.reg |= NVMCTRL_STATUS_MASK;

	/* ڽƎw߂ݒ */
	nvm_module->ADDR.reg  = (uintptr_t)&NVM_MEMORY[row_address / 4];
	nvm_module->CTRLA.reg = NVM_COMMAND_ERASE_ROW | NVMCTRL_CTRLA_CMDEX_KEY;

	return STATUS_OK;
}

/**
 * \brief NVMҰǂݍ
 *
 * NVM̈߰ޗeʁA߰ސA`Ԑݒ̐ݒ擾܂B
 *
 * \param[out]  parameters NVM؂߰ޗeʂ߰ސێҰ\
 */
void nvm_get_parameters(
		struct nvm_parameters *const parameters)
{
	/* Ұ */
	Assert(parameters);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Nvmctrl *const nvm_module = NVMCTRL;

	/* ُ׸މ */
	nvm_module->STATUS.reg |= NVMCTRL_STATUS_MASK;

	/* PARAMڼ޽ǂݏo */
	uint32_t param_reg = nvm_module->PARAM.reg;

	/* ߰ޗeʎwՕ޲Đϊ */
	parameters->page_size =
			8 << ((param_reg & NVMCTRL_PARAM_PSZ_Msk) >> NVMCTRL_PARAM_PSZ_Pos);

	/* ߰ތvԍՕ */
	parameters->nvm_number_of_pages =
			(param_reg & NVMCTRL_PARAM_NVMP_Msk) >> NVMCTRL_PARAM_NVMP_Pos;

	/* USER񂩂猻݂EEPROM˭ޒlǂݍ */
	uint16_t eeprom_fuse_value =
			(NVM_USER_MEMORY[NVMCTRL_FUSES_EEPROM_SIZE_Pos / 16] &
			NVMCTRL_FUSES_EEPROM_SIZE_Msk) >> NVMCTRL_FUSES_EEPROM_SIZE_Pos;

	/* EEPROM˭ޒlNVM߰ސɕϊ */
	if (eeprom_fuse_value == 7) {
		parameters->eeprom_number_of_pages = 0;
	}
	else {
		parameters->eeprom_number_of_pages =
				NVMCTRL_ROW_PAGES << (6 - eeprom_fuse_value);
	}

	/* USER񂩂猻݂BOOTSZ˭ޒlǂݍ */
	uint16_t boot_fuse_value =
			(NVM_USER_MEMORY[NVMCTRL_FUSES_BOOTPROT_Pos / 16] &
			NVMCTRL_FUSES_BOOTPROT_Msk) >> NVMCTRL_FUSES_BOOTPROT_Pos;

	/* BOOTSZ˭ޒlNVM߰ސɕϊ */
	if (boot_fuse_value == 7) {
		parameters->bootloader_number_of_pages = 0;
	}
	else {
		parameters->bootloader_number_of_pages =
				NVMCTRL_ROW_PAGES << (7 - boot_fuse_value);
	}
}

/**
 * \brief ߰ޗ̈悪{Ă邩ǂ
 *
 * ^炦߰ނ̈𒊏oĂ̗̈悪{Ăǂ𒲂ׂ܂B
 *
 * \param[in]  page_number ׂ߰ޔԍ
 *
 * \return ߰ގ{
 *
 * \retval true  ߰ނ͎{Ă܂B
 * \retval false ߰ނ͎{Ă܂B
 *
 */
bool nvm_is_page_locked(uint16_t page_number)
{
	uint16_t pages_in_region;
	uint16_t region_number;

	/* ʕʰ޳̂ւ̈ʒuwq擾 */
	Nvmctrl *const nvm_module = NVMCTRL;

	/* ̈߰ސ擾 */
	pages_in_region = _nvm_dev.number_of_pages / 16;

	/* ^ꂽ߰ނɑ΂̈擾 */
	region_number = page_number / pages_in_region;

	return !(nvm_module->LOCK.reg & (1 << region_number));
}

///@cond INTERNAL

/**
 * \internal
 *
 * \brief ˭ ޯČ\̓eɕϊ
 *
 */
static void _nvm_translate_raw_fusebits_to_struct (
		uint32_t *raw_user_row,
		struct nvm_fusebits *fusebits)
{

	fusebits->bootloader_size = (enum nvm_bootloader_size)
			((raw_user_row[0] & NVMCTRL_FUSES_BOOTPROT_Msk)
			>> NVMCTRL_FUSES_BOOTPROT_Pos);

	fusebits->eeprom_size = (enum nvm_eeprom_emulator_size)
			((raw_user_row[0] & NVMCTRL_FUSES_EEPROM_SIZE_Msk)
			>> NVMCTRL_FUSES_EEPROM_SIZE_Pos);

	fusebits->bod33_level = (uint8_t)
			((raw_user_row[0] & SYSCTRL_FUSES_BOD33USERLEVEL_Msk)
			>> SYSCTRL_FUSES_BOD33USERLEVEL_Pos);

	fusebits->bod33_enable = (bool)
			((raw_user_row[0] & SYSCTRL_FUSES_BOD33_EN_Msk)
			>> SYSCTRL_FUSES_BOD33_EN_Pos);

	fusebits->bod33_action = (enum nvm_bod33_action)
			((raw_user_row[0] & SYSCTRL_FUSES_BOD33_ACTION_Msk)
			>> SYSCTRL_FUSES_BOD33_ACTION_Pos);

	fusebits->wdt_enable = (bool)
			((raw_user_row[0] & WDT_FUSES_ENABLE_Msk) >> WDT_FUSES_ENABLE_Pos);

	fusebits->wdt_always_on = (bool)
			((raw_user_row[0] & WDT_FUSES_ALWAYSON_Msk) >> WDT_FUSES_ALWAYSON_Pos);

	fusebits->wdt_timeout_period = (uint8_t)
			((raw_user_row[0] & WDT_FUSES_PER_Msk) >> WDT_FUSES_PER_Pos);

	/* WDTԂUSER232ޯČԂɒu܂B01ޯĂu
	   ߁Aɂ邽߂Ɍ1ޯĂ1ړȂ΂Ȃ܂B */
	fusebits->wdt_window_timeout = (enum nvm_wdt_window_timeout)
			(((raw_user_row[0] & WDT_FUSES_WINDOW_0_Msk) >> WDT_FUSES_WINDOW_0_Pos) |
			((raw_user_row[1] & WDT_FUSES_WINDOW_1_Msk) << 1));

	fusebits->wdt_early_warning_offset = (enum nvm_wdt_early_warning_offset)
			((raw_user_row[1] & WDT_FUSES_EWOFFSET_Msk) >> WDT_FUSES_EWOFFSET_Pos);

	fusebits->wdt_window_mode_enable_at_poweron = (bool)
			((raw_user_row[1] & WDT_FUSES_WEN_Msk) >> WDT_FUSES_WEN_Pos);

	fusebits->lockbits = (uint16_t)
			((raw_user_row[1] & NVMCTRL_FUSES_REGION_LOCKS_Msk)
			>> NVMCTRL_FUSES_REGION_LOCKS_Pos);

}

///@endcond

/**
 * \brief USER񂩂˭ގ擾
 *
 * USER񂩂˭ސݒǂݏo܂B
 *
 * \param[in]  fusebits nvm_fusebits\̌^64ޯĕ؊ɏՕւ̈ʒuwqS
 *
 * \return ˭ޓǂݍݎs̏
 *
 * \retval STATUS_OK ̊֐͏STATUS_OKԂ܂B
 */
enum status_code nvm_get_fuses (
		struct nvm_fusebits *fusebits)
{
	enum status_code error_code = STATUS_OK;
	uint32_t raw_fusebits[2];

	/* PʕmF */
	while (!nvm_is_ready()) {
	};

	/* USER64ޯĂ˭ސݒǂݍ */
	((uint16_t*)&raw_fusebits)[0] = (uint16_t)NVM_MEMORY[NVMCTRL_USER / 2];
	((uint16_t*)&raw_fusebits)[1] = (uint16_t)NVM_MEMORY[(NVMCTRL_USER / 2) + 1];
	((uint16_t*)&raw_fusebits)[2] = (uint16_t)NVM_MEMORY[(NVMCTRL_USER / 2) + 2];
	((uint16_t*)&raw_fusebits)[3] = (uint16_t)NVM_MEMORY[(NVMCTRL_USER / 2) + 3];

	_nvm_translate_raw_fusebits_to_struct(raw_fusebits, fusebits);

	return error_code;
}
