/**
 * \file
 *
 * \brief SAM D20/D21/R21 GPIO߰ ײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <port.h>

/**
 *  \brief ߰ ݌`Ԑݒʰ޳Pʕɏ
 *
 *  ߰ ݌`Ԑݒ̗^ꂽ`Ԑݒʰ޳Pʕɏo܂B
 *
 *  \note ݕo͂ƂĐݒ肳ꍇAٱ/޳ݓ͌`Ԑݒ肪
 *        ܂B
 *
 *  \param[in]  gpio_pin `Ԑݒ肷GPIO݂̎wW
 *  \param[in]  config   ݂̌`Ԑݒ̐ݒ
 */
void port_pin_set_config(
		const uint8_t gpio_pin,
		const struct port_config *const config)
{
	/*  */
	Assert(config);

	struct system_pinmux_config pinmux_config;
	system_pinmux_get_config_defaults(&pinmux_config);

	pinmux_config.mux_position = SYSTEM_PINMUX_GPIO;
	pinmux_config.direction    = (enum system_pinmux_pin_dir)config->direction;
	pinmux_config.input_pull   = (enum system_pinmux_pin_pull)config->input_pull;
	pinmux_config.powersave    = config->powersave;

	system_pinmux_pin_set_config(gpio_pin, &pinmux_config);
}

/**
 *  \brief ߰ČQ`ԐݒQʰ޳Pʕɏ
 *
 *  ߰ČQ`Ԑݒ̗^ꂽ`Ԑݒʰ޳Pʕɏo܂B
 *
 *  \note ݕo͂ƂĐݒ肳ꍇAٱ/޳ݓ͌`Ԑݒ肪
 *        ܂B
 *
 *  \param[out]  port   PORTPʕ̊
 *  \param[in]   mask   `Ԑݒ肷߰ ݂̎Օ
 *  \param[in]   config ݌Qp`Ԑݒ̐ݒ
 */
void port_group_set_config(
		PortGroup *const port,
		const uint32_t mask,
		const struct port_config *const config)
{
	/*  */
	Assert(port);
	Assert(config);

	struct system_pinmux_config pinmux_config;
	system_pinmux_get_config_defaults(&pinmux_config);

	pinmux_config.mux_position = SYSTEM_PINMUX_GPIO;
	pinmux_config.direction    = (enum system_pinmux_pin_dir)config->direction;
	pinmux_config.input_pull   = (enum system_pinmux_pin_pull)config->input_pull;
	pinmux_config.powersave    = config->powersave;

	system_pinmux_group_set_config(port, mask, &pinmux_config);
}
