/**
 * \file
 *
 * \brief SAM D20ʸۯ ײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include <gclk.h>
#include <clock.h>
#include <system_interrupt.h>

/**
 * \brief GCLKײޏ
 *
 * ʸۯPʕASĂ̊Ȉʸۯق̓dONl
 * ɋ֎~ؾĂɂ܂B
 */
void system_gclk_init(void)
{
	/* ޼ ̪ ۯON */
	system_apb_clock_set_mask(SYSTEM_CLOCK_APB_APBA, PM_APBAMASK_GCLK);

	/* ď̂ۏ؂邽߂ɿĳPʕؾ */
	GCLK->CTRL.reg = GCLK_CTRL_SWRST;
	while (GCLK->CTRL.reg & GCLK_CTRL_SWRST) {
		/* ؾĊ҂ */
	}
}

/**
 * \brief ʸۯ`Ԑݒʰ޳Pʕɏ
 *
 * ʸۯ`Ԑݒ̗^ꂽ`Ԑݒʰ޳Pʕɏo܂B
 *
 * \note (sĂ鐶ł)}ȸۯύX̸͂ۯvɉĂ
 *       s悤(ONDEMANDޯĂݒ)Ɍ`Ԑݒ肳AꂪݑsĂ
 *       (Ӌ@\̸ۯvĂȂ)ꍇɒǉ̎Ԃ蓾
 *       B̏ꍇAGCLK͐VۯvŐVۯ̏
 *       ܂ŌÂKւ̗v𖢂ۂ܂B
 *
 * \note ̊֐͖sĂȂJnA̐Jnɂ
 *       ̌`Ԑݒ\ref system_gclk_gen_enable()ĂłB
 *
 * \param[in]  generator `Ԑݒ肷ʸۯwW
 * \param[in]  config    p`Ԑݒ̐ݒ
 */
void system_gclk_gen_set_config(
		const uint8_t generator,
		struct system_gclk_gen_config *const config)
{
	/*  */
	Assert(config);

	/* Kvŏɂ邽߁AVo^`Ԑݒ𷬯 */
	uint32_t new_genctrl_config = (generator << GCLK_GENCTRL_ID_Pos);
	uint32_t new_gendiv_config  = (generator << GCLK_GENDIV_ID_Pos);

	/* ɑ΂ėvۯI */
	new_genctrl_config |= config->source_clock << GCLK_GENCTRL_SRC_Pos;

	/* ֎~ɸۯHigh܂LoŵǂɌ`Ԑݒ */
	if (config->high_when_disabled) {
		new_genctrl_config |= GCLK_GENCTRL_OOV;
	}

	/* I/O݂ւ̸ۯo͂ׂꍇɌ`Ԑݒ */
	if (config->output_enable) {
		new_genctrl_config |= GCLK_GENCTRL_OE;
	}

	/* Wݒ */
	if (config->division_factor > 1) {
		/* W2ׂ̂悩 */
		if (((config->division_factor & (config->division_factor - 1)) == 0)) {
			/* ڼ޽ɐݒ肳Ȃ΂ȂȂW擾̂ɐݒ肳
			 * ŏޯĂ̎wW */

			uint32_t div2_count = 0;

			uint32_t mask;
			for (mask = (1UL << 1); mask < config->division_factor;
						mask <<= 1) {
				div2_count++;
			}

			/* 2ׂ̂敪W2ݒ */
			new_gendiv_config  |= div2_count << GCLK_GENDIV_DIV_Pos;
			new_genctrl_config |= GCLK_GENCTRL_DIVSEL;
		} else {
			/* Wݒ */

			new_gendiv_config  |=
					(config->division_factor) << GCLK_GENDIV_DIV_Pos;

			/* ޭè ِx2 */
			new_genctrl_config |= GCLK_GENCTRL_IDC;
		}

	}

	/* ޲Ÿۯ܂͋֎~ */
	if (config->run_in_standby) {
		new_genctrl_config |= GCLK_GENCTRL_RUNSTDBY;
	}

	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	system_interrupt_enter_critical_section();

	/* I */
	*((uint8_t*)&GCLK->GENDIV.reg) = generator;

	/* V`Ԑݒ菑 */
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};
	GCLK->GENDIV.reg  = new_gendiv_config;

	while (system_gclk_is_syncing()) {
		/* ҂ */
	};
	GCLK->GENCTRL.reg = new_genctrl_config | (GCLK->GENCTRL.reg & GCLK_GENCTRL_GENEN);

	system_interrupt_leave_critical_section();
}

/**
 * \brief Ɍ`Ԑݒ肳ꂽʸۯ
 *
 * \ref system_gclk_gen_set_config()ĂяooRŐɌ`Ԑݒ肵ʸۯ
 * ̸ۯJn܂B
 *
 * \param[in]  generator ʸۯwW
 */
void system_gclk_gen_enable(
		const uint8_t generator)
{
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	system_interrupt_enter_critical_section();

	/* vI */
	*((uint8_t*)&GCLK->GENCTRL.reg) = generator;
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	/* 틖 */
	GCLK->GENCTRL.reg |= GCLK_GENCTRL_GENEN;

	system_interrupt_leave_critical_section();
}

/**
 * \brief ɋʸۯ֎~
 *
 * ref system_gclk_gen_enable()ĂяooRŐɊJnꂽʸۯ̸ۯ
 * ~܂B
 *
 * \param[in]  generator ֎~ʸۯwW
 */
void system_gclk_gen_disable(
		const uint8_t generator)
{
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	system_interrupt_enter_critical_section();

	/* vI */
	*((uint8_t*)&GCLK->GENCTRL.reg) = generator;
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	/* Disable generator */
	GCLK->GENCTRL.reg &= ~GCLK_GENCTRL_GENEN;
	while (GCLK->GENCTRL.reg & GCLK_GENCTRL_GENEN) {
		/* ֎~ɂȂۯ҂ */
	}

	system_interrupt_leave_critical_section();
}

/**
 * \brief w肵ʸۯ킪Ă邩f
 *
 * \param[in]  generator ׂʸۯwW
 *
 * \return 
 * \retval true  ʸۯ͋Ă܂B
 * \retval false ʸۯ͋֎~Ă܂B
 */
bool system_gclk_gen_is_enabled(
		const uint8_t generator)
{
	bool enabled;

	system_interrupt_enter_critical_section();

	/* vꂽI */
	*((uint8_t*)&GCLK->GENCTRL.reg) = generator;
	/* 擾 */
	enabled = (GCLK->GENCTRL.reg & GCLK_GENCTRL_GENEN);

	system_interrupt_leave_critical_section();

	return enabled;
}

/**
 * \brief ʸۯ̸ۯg擾
 *
 * ʸۯ ْPʕւ̋ƂĎgpw肵ʸۯ̸ۯ
 * g(Hz)肵܂B
 *
 * \param[in]  generator ʸۯwW
 *
 * \return Hzł̈ʸۯ̎g
 */
uint32_t system_gclk_gen_get_hz(
		const uint8_t generator)
{
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	system_interrupt_enter_critical_section();

	/* K؂ȐI */
	*((uint8_t*)&GCLK->GENCTRL.reg) = generator;
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	/* GCLKɐڑꂽ̎g擾 */
	uint32_t gen_input_hz = system_clock_source_get_hz(
			(enum system_clock_source)GCLK->GENCTRL.bit.SRC);

	*((uint8_t*)&GCLK->GENCTRL.reg) = generator;

	uint8_t divsel = GCLK->GENCTRL.bit.DIVSEL;

	/* K؂Ȑ핪ڼ޽I */
	*((uint8_t*)&GCLK->GENDIV.reg) = generator;
	while (system_gclk_is_syncing()) {
		/* ҂ */
	};

	uint32_t divider = GCLK->GENDIV.bit.DIV;

	system_interrupt_leave_critical_section();

	/* 킪܂2i̕gp */
	if (!divsel && divider > 1) {
		gen_input_hz /= divider;
	} else if (divsel) {
		gen_input_hz >>= (divider+1);
	}

	return gen_input_hz;
}

/**
 * \brief ʸۯ`Ԑݒʰ޳Pʕɏ
 *
 * ʸۯ`Ԑݒ̗^ꂽ`Ԑݒʰ޳Pʕɏo܂Bۯ
 * ݑsĂꍇA͒~܂B
 *
 * \note UĂ΂ꂽۯ͑sĂ炸AۯJnɂ͸ۯ ٌ`Ԑݒ
 *       \ref system_gclk_chan_enable()ǂłB
 *
 * \param[in]  channel `Ԑݒ肷ʸۯ 
 * \param[in]  config  ۯɑ΂`Ԑݒ̐ݒ
 *
 */
void system_gclk_chan_set_config(
		const uint8_t channel,
		struct system_gclk_chan_config *const config)
{
	/*  */
	Assert(config);

	/* ̕Kv炷߂ɐV`Ԑݒ𷬯 */
	uint32_t new_clkctrl_config = (channel << GCLK_CLKCTRL_ID_Pos);

	/* ]񂾈ʸۯI */
	new_clkctrl_config |= config->source_generator << GCLK_CLKCTRL_GEN_Pos;

	/* ʸۯ ق֎~ */
	system_gclk_chan_disable(channel);

	/* V`Ԑݒ */
	GCLK->CLKCTRL.reg = new_clkctrl_config;
}

/**
 * \brief Ɍ`Ԑݒ肵ʸۯ
 *
 * \ref system_gclk_chan_set_config()ĂяooRŐɌ`Ԑݒ肵ʸۯ̸ۯ
 * Jn܂B
 *
 * \param[in]  channel ʸۯ 
 */
void system_gclk_chan_enable(
		const uint8_t channel)
{
	system_interrupt_enter_critical_section();

	/* vقI */
	*((uint8_t*)&GCLK->CLKCTRL.reg) = channel;

	/* ʸۯ */
	GCLK->CLKCTRL.reg |= GCLK_CLKCTRL_CLKEN;

	system_interrupt_leave_critical_section();
}

/**
 * \brief ɋꂽʸۯ֎~
 *
 * \ref system_gclk_chan_enable()ĂяooRŐɊJnꂽʸۯ̸ۯ
 * ~܂B
 *
 * \param[in]  channel ֎~ʸۯ 
 */
void system_gclk_chan_disable(
		const uint8_t channel)
{
	system_interrupt_enter_critical_section();

	/* vꂽقI */
	*((uint8_t*)&GCLK->CLKCTRL.reg) = channel;

	/* WRTLOCK */
	Assert(!GCLK->CLKCTRL.bit.WRTLOCK);

	/* ق֎~ł悤Ɋm̓Ă鋟ɐ؂ւ */
	uint32_t prev_gen_id = GCLK->CLKCTRL.bit.GEN;
	GCLK->CLKCTRL.bit.GEN = 0;

	/* ʸۯ֎~ */
	GCLK->CLKCTRL.reg &= ~GCLK_CLKCTRL_CLKEN;
	while (GCLK->CLKCTRL.reg & GCLK_CLKCTRL_CLKEN) {
		/* ֎~ɂȂۯ҂ */
	}

	/* Ɍ`Ԑݒ肳ꂽۯ𕜌 */
	GCLK->CLKCTRL.bit.GEN = prev_gen_id;

	system_interrupt_leave_critical_section();
}

/**
 * \brief w肵ʸۯ قĂ邩f
 *
 * \param[in]  channel ʸۯ َwW
 *
 * \return 
 * \retval true  ʸۯ ق͋Ă܂B
 * \retval false ʸۯ ق͋֎~Ă܂B
 */
bool system_gclk_chan_is_enabled(
		const uint8_t channel)
{
	bool enabled;

	system_interrupt_enter_critical_section();

	/* vꂽʸۯ قI */
	*((uint8_t*)&GCLK->CLKCTRL.reg) = channel;
	enabled = GCLK->CLKCTRL.bit.CLKEN;

	system_interrupt_leave_critical_section();

	return enabled;
}

/**
 * \brief XȂ`Ԑݒ菑݂ʸۯ ق{
 *
 * XȂ`Ԑݒ菑݂ʸۯ ق{܂BdONؾĂʂ
 * `Ԑݒ邱Ƃ\łB
 *
 * \param[in]  channel {ʸۯ 
 */
void system_gclk_chan_lock(
		const uint8_t channel)
{
	system_interrupt_enter_critical_section();

	/* vꂽقI */
	*((uint8_t*)&GCLK->CLKCTRL.reg) = channel;

	/* ʸۯ */
	GCLK->CLKCTRL.reg |= GCLK_CLKCTRL_CLKEN;

	system_interrupt_leave_critical_section();
}

/**
 * \brief w肵ق{Ă邩f
 *
 * \param[in]  channel ʸۯ َwW
 *
 * \return {
 * \retval true  ʸۯ ق͎{Ă܂B
 * \retval false ʸۯ ق͎{Ă܂B
 */
bool system_gclk_chan_is_locked(
		const uint8_t channel)
{
	bool locked;

	system_interrupt_enter_critical_section();

	/* vꂽʸۯ قI */
	*((uint8_t*)&GCLK->CLKCTRL.reg) = channel;
	locked = GCLK->CLKCTRL.bit.WRTLOCK;

	system_interrupt_leave_critical_section();

	return locked;
}

/**
 * \brief ʸۯ ق̸ۯg擾
 *
 * ޲Ӌ@\Pʕւ̋ƂĎgpw肵ʸۯ ق̸ۯ
 * g(Hz)肵܂B
 *
 * \param[in]  channel ʸۯ َwW
 *
 * \return Hzł̈ʸۯ ق̎g
 */
uint32_t system_gclk_chan_get_hz(
		const uint8_t channel)
{
	uint8_t gen_id;

	system_interrupt_enter_critical_section();

	/* vꂽʸۯ قI */
	*((uint8_t*)&GCLK->CLKCTRL.reg) = channel;
	gen_id = GCLK->CLKCTRL.bit.GEN;

	system_interrupt_leave_critical_section();

	/* gGCLK̸ۯxԂB */
	return system_gclk_gen_get_hz(gen_id);
}
