/**
 * \file
 *
 * \brief SAM D20/D21/R21ъ荞ײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "system_interrupt.h"

/**
 * \brief 荞ݐۗ
 *
 * v荞޸ۗ܂B
 *
 * \param[in]  vector ׂ銄荞޸ԍ
 *
 * \returns v荞޸ۗްْl
 *
 * \retval true  荞޸ۗB
 * \retval false 荞޸ۗłȂƂB
 *
 */
bool system_interrupt_is_pending(
		const enum system_interrupt_vector vector)
{
	bool result;

	if (vector >= _SYSTEM_INTERRUPT_EXTERNAL_VECTOR_START) {
		result = ((NVIC->ISPR[0] & (1 << vector)) != 0);
	} else if (vector == SYSTEM_INTERRUPT_SYSTICK) {
		result = ((SCB->ICSR & SCB_ICSR_PENDSTSET_Msk) != 0);
	} else {
		Assert(false);
		result = false;
	}

	return result;
}

/**
 * \brief 荞޸ۗƂĐݒ
 *
 * v荞޸ۗƂĐݒ(Aw肵޸ɑ΂Ŀĳ
 * ݗv𔭍s)܂Bĳ(Ă)޸ԍɊÂD
 * ƌ`Ԑݒ肳ꂽD挠ݒŏ܂B
 *
 * \param[in]  vector ۗƂĐݒ肳銄荞޸ԍ
 *
 * \returns ޸ۗƂĐɐݒ肳ꂽԕ
 *
 * \retval STATUS_OK          ُ킪SoȂꍇ
 * \retval STATUS_INVALID_ARG x޸ԍ^ꂽꍇ
 */
enum status_code system_interrupt_set_pending(
		const enum system_interrupt_vector vector)
{
	enum status_code status = STATUS_OK;

	if (vector >= _SYSTEM_INTERRUPT_EXTERNAL_VECTOR_START) {
		NVIC->ISPR[0] = (1 << vector);
	} else if (vector == SYSTEM_INTERRUPT_NON_MASKABLE) {
		/* :NMIōD挠̂߁Aꂪۗɐݒ肳ꂽ㒼Ɏs
		 * B */
		SCB->ICSR = SCB_ICSR_NMIPENDSET_Msk;
	} else if (vector == SYSTEM_INTERRUPT_SYSTICK) {
		SCB->ICSR = SCB_ICSR_PENDSTSET_Msk;
	} else {
		/* gp҂͕ۗƂĖx̉̐ݒ] */
		Assert(false);
		status = STATUS_ERR_INVALID_ARG;
	}

	return status;
}

/**
 * \brief ۗ荞޸
 *
 * ĳ@sȂ悤ɕۗ̊荞޸܂B
 *
 * \param[in]  vector 銄荞޸ԍ
 *
 * \returns 荞ݕۗԂɉꂽԕ
 *
 * \retval STATUS_OK          ُ킪SoȂꍇ
 * \retval STATUS_INVALID_ARG x޸ԍ^ꂽꍇ
 */
enum status_code system_interrupt_clear_pending(
		const enum system_interrupt_vector vector)
{
	enum status_code status = STATUS_OK;

	if (vector >= _SYSTEM_INTERRUPT_EXTERNAL_VECTOR_START) {
		NVIC->ICPR[0] = (1 << vector);
	} else if (vector == SYSTEM_INTERRUPT_NON_MASKABLE) {
		/* :ۗNMI荞݂̉͂ꂪōD挠łꂪݒ肳ꂽuԂ
		 * s邽߁AӖ𐬂A޲ɂĎx܂B */
		return STATUS_ERR_INVALID_ARG;
	} else if (vector == SYSTEM_INTERRUPT_SYSTICK) {
		SCB->ICSR = SCB_ICSR_PENDSTCLR_Msk;
	} else {
		Assert(false);
		status = STATUS_ERR_INVALID_ARG;
	}

	return status;
}

/**
 * \brief 荞޸Dِݒ
 *
 * O荞݂܂͗O̗Dقݒ肵܂B
 *
 * \param[in]  vector         ύX銄荞޸
 * \param[in]  priority_level ݒ肷V޸D
 *
 * \returns 荞݂̗Dقɐݒ肳ꂽԕ
 *
 * \retval STATUS_OK          ُ킪SoȂꍇ
 * \retval STATUS_INVALID_ARG x޸ԍ^ꂽꍇ
 */
enum status_code system_interrupt_set_priority(
		const enum system_interrupt_vector vector,
		const enum system_interrupt_priority_level priority_level)
{
	enum status_code status = STATUS_OK;

	if (vector >= _SYSTEM_INTERRUPT_EXTERNAL_VECTOR_START) {
		uint8_t register_num = vector / 4;
		uint8_t priority_pos = ((vector % 4) * 8) + (8 - __NVIC_PRIO_BITS);

		NVIC->IP[register_num] =
				(NVIC->IP[register_num] & ~(0x3 << priority_pos)) |
				(priority_level << priority_pos);

	} else if (vector == SYSTEM_INTERRUPT_SYSTICK) {
		SCB->SHP[1] = (priority_level << _SYSTEM_INTERRUPT_SYSTICK_PRI_POS);
	} else {
		Assert(false);
		status = STATUS_ERR_INVALID_ARG;
	}

	return status;
}

/**
 * \brief 荞޸Dق擾
 *
 * vO荞݂܂͗O̗Dق擾
 *
 * \param[in]  vector D޳Rǂ܂銄荞޸
 *
 * \return ^ꂽ荞޸̌݌`Ԑݒ肳Ă銄荞ݗD
 */
enum system_interrupt_priority_level system_interrupt_get_priority(
		const enum system_interrupt_vector vector)
{
	uint8_t register_num = vector / 4;
	uint8_t priority_pos = ((vector % 4) * 8) + (8 - __NVIC_PRIO_BITS);

	enum system_interrupt_priority_level priority = SYSTEM_INTERRUPT_PRIORITY_LEVEL_0;

	if (vector >= 0) {
		priority = (enum system_interrupt_priority_level)
				((NVIC->IP[register_num] >> priority_pos) & _SYSTEM_INTERRUPT_PRIORITY_MASK);
	} else if (vector == SYSTEM_INTERRUPT_SYSTICK) {
		priority = (enum system_interrupt_priority_level)
				((SCB->SHP[1] >> _SYSTEM_INTERRUPT_SYSTICK_PRI_POS) & _SYSTEM_INTERRUPT_PRIORITY_MASK);
	}

	return priority;
}

