/**
 * \file
 *
 * \brief SAM D21/R21 TCײޑJn
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

/**
 * \page asfdoc_sam0_tc_dma_use_case TCDMAg߂̑Jn̎
 *
 * xĈꗗ:
 *    - SAM D21/R21 Xplained Pro
 *
 * ̎gpʂŁATCPWMM𐶐̂Ɏgp܂Błٽ͎
 * 1/4ɐݒ肳܂BUvlr/ߊllڼ޽̒lƈvƁADMA-
 * ]̂߂ɎۂN܂B
 * TCPʕ͎̗lɍ\ݒ肳܂B:
 *
 * \li GCLK0(GCLK)ۯ
 * \li vł16ޯĕ\
 * \li OuȂ
 * \li WPWMg`
 * \li GCLKĐݒ芈
 * \li ޲ősȂB
 * \li g`o͂̔]Ȃ
 * \li ߊlȂ
 * \li ㏸v
 * \li PsȂ
 * \li ۓ͂Ȃ
 * \li ۊȂ
 * \li ېȂ
 * \li 0ŌvJn
 * \li r/ߊl00xFFFF/4ɐݒ
 *
 * DMAPʕ͈ȉɌ`Ԑݒ肳܂B:
 *  \li ؂؂ްړ
 *  \li TC6rv0̎Ӌ@\Ngp
 *  \li DMAD0gp
 * \section asfdoc_sam0_tc_dma_use_case_setup Jn
 *
 * \subsection asfdoc_sam0_tc_dma_use_case_prereq OKv
 * ̎gpʂɂĎOKv͂܂B
 *
 * \subsection asfdoc_sam0_tc_dma_use_case_setup_code 
 *
 * gp鷯Ăɏ]āAǂ̊֐ɂ旧Ď剞p ̧Ɉȉǉ܂B:
 * - SAM D21 Xplained Pro
 *   \snippet samd21_xplained_pro/conf_quick_start.h definition_pwm
 *   \snippet samd21_xplained_pro/conf_quick_start.h definition_dma
 * - SAM R21 Xplained Pro
 *   \snippet samr21_xplained_pro/conf_quick_start.h definition_pwm
 *   \snippet samr21_xplained_pro/conf_quick_start.h definition_dma
 *
 * ̊֐̊Oňȉ剞p ̧قɒǉ܂B:
 * \snippet qs_tc_dma.c module_inst
 * \snippet qs_tc_dma.c dma_resource
 * \snippet qs_tc_dma.c transfer_length
 * \snippet qs_tc_dma.c transfer_counter
 * \snippet qs_tc_dma.c source_memory
 * \snippet qs_tc_dma.c destination_memory
 * \snippet qs_tc_dma.c transfer_done_flag
 * \snippet qs_tc_dma.c example_descriptor
 *
 * ȉ̍\ݒ躰ނgp҉pɕ/\t܂B:
 * \snippet qs_tc_dma.c setup
 *
 * gp҉p(ʓI\c main()̎n)ɒǉ܂B
 * \snippet qs_tc_dma.c setup_init
 *
 * \subsection asfdoc_sam0_tc_dma_use_case_setup_flow Ƃ̗
 * \subsubsection asfdoc_sam0_tc_dma_use_case_setup_flow_inst ϐ쐬
 * -# ꂪgpԂTCײނ̏Ԃi[邽߂TCPʕpPʕĳ
 *    ̍\̂쐬܂B
 *    \snippet qs_tc_dma.c module_inst
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 *
 * -# ꂪgpԂDMȀԂi[邽߂DMApPʕĳ
 *    ̍\̂쐬܂B
 *    \snippet qs_tc_dma.c dma_resource
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 *
 * \subsubsection asfdoc_sam0_tc_dma_use_case_setup_flow_tc TC`Ԑݒ
 * -# ITCӋ@\̌`Ԑݒ𒲐邽߂ɋL邱ƂłTCPʕ
 *    `Ԑݒ\̂쐬܂B
 *    \snippet qs_tc_dma.c setup_config
 * -# Pʕ̊lTC`Ԑݒ\̂܂B
 *    \snippet qs_tc_dma.c setup_config_defaults
 *    \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *          ݒ\̂ĝɐ旧ďɎsׂłB
 *
 * -# v핝Ag`Ar0l`Ԑݒ肷悤TCݒς
 *    B
 *    \snippet qs_tc_dma.c setup_change_config
 * -# ޲ ݂łPWMo͂`Ԑݒ肷悤TCݒς܂B
 *    \snippet qs_tc_dma.c setup_change_config_pwm
 * -# ]ސݒTCPʕ`Ԑݒ肵܂B
 *    \snippet qs_tc_dma.c setup_set_config
 * -# vJnPWMMn߂邽߂TCPʕ܂B
 *    \snippet qs_tc_dma.c setup_enable
 *
 * \subsubsection asfdoc_sam0_tc_dma_use_case_setup_flow_dma DMA`Ԑݒ
 * -# PDMA]̌`Ԑݒ𒲐邽߂ɋL邱ƂłDMA`Ԑݒ
 *    \΂쐬܂B
 *    \snippet qs_tc_dma.c dma_setup_1
 *
 * -# Pʕ̊lDMA`Ԑݒ\̂܂B
 *    \snippet qs_tc_dma.c dma_setup_2
 *     \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *           ݒ\̂ĝɐ旧ďɎsׂłB
 *
 * -# `ԐݒDMA蓖Ă܂B
 *    \snippet qs_tc_dma.c dma_setup_3
 *
 * -# PDMA]̌`Ԑݒ𒲐邽߂ɋL邱ƂłDMALqq`Ԑ
 *    \̂쐬܂B
 *    \snippet qs_tc_dma.c dma_setup_4
 *
 * -# Pʕ̊lDMALqq`Ԑݒ\̂܂B
 *    default values.
 *    \snippet qs_tc_dma.c dma_setup_5
 *     \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *           ݒ\̂ĝɐ旧ďɎsׂłB
 *
 * -# ]ʁA]ڽA]ڽDAM]pwҰݒ肵܂B
 *    \snippet qs_tc_dma.c dma_setup_6
 *
 * -# DMA]Lqq쐬܂B
 *    \snippet qs_tc_dma.c dma_setup_7
 *
 * -# DMA]Lqq蓖ĂDMAɒǉ܂B
 *    \snippet qs_tc_dma.c add_descriptor_to_resource
 *
 * -# ]Ԃ߂ɌĂі߂o^܂B
 *    \snippet qs_tc_dma.c setup_callback_register
 *
 * -# o^Ăі߂֐œ]I׸ނݒ肳܂B
 *    \snippet qs_tc_dma.c _transfer_done
 *
 * \subsubsection asfdoc_sam0_tc_dma_use_case_setup_flow_data ް
 * -# ]mF邽߂ؓe܂B
 *    \snippet qs_tc_dma.c setup_source_memory_content
 *
 * \section asfdoc_sam0_tc_dma_use_case_main gp
 *
 * \subsection asfdoc_sam0_tc_dma_use_case_main_code 
 * ȉ̺ނgp҉pɕ/\t܂B:
 * \snippet qs_tc_dma.c main
 *
 * \subsection asfdoc_sam0_tc_dma_use_case_main_flow Ƃ̗
 * -# ]pJԂJn܂B
 *    \snippet qs_tc_dma.c main_transfer_loop
 *
 * -# ]I׸ނfalseƂĐݒ肵܂B
 *    \snippet qs_tc_dma.c main_1
 *
 * -# ]ƂJn܂B
 *    \snippet qs_tc_dma.c main_2
 *
 * -# ]I҂܂B
 *    \snippet qs_tc_dma.c main_3
 *
 * -# ̓]̂߂ɓ]Ɠ]̱ڽXV܂B
 *    \snippet qs_tc_dma.c main_4
 *
 * -# IȂJԂɓ܂B
 *    \snippet qs_tc_dma.c endless_loop
 */
