/**
 * \file
 *
 * \brief SAM EEPROM͕핔޽Jn
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

/**
 * \page asfdoc_sam0_eeprom_basic_use_case ͕EEPROMPʕpJn̎ - {IȎgp
 *
 * ̎gpʂŁAEEPROM͕Pʕ͌`Ԑݒ肳ް̎߰ނǂݏ
 * ܂BŏEEPROM߰ނ̐擪޲Ăݐ؂ւALED͐VԂ𔽉f
 * 悤ON܂OFFɐ؂ւ܂B޲ؾĂxLED͐
 * sLƎ擾߂ɈႤԂɐ؂ւׂłB
 *
 * \section asfdoc_sam0_eeprom_basic_use_case_prereq OKv
 * ޲˭ނͻ޽gp꓾OEEPROM͕핔޽ɂĎgp邽
 * ߂ɏ[ׯ ؗ񐔂\񂷂悤Ɍ`Ԑݒ肳Ȃ΂Ȃ܂B
 *
 * \section asfdoc_sam0_eeprom_basic_use_case_setup \ݒ
 *
 * \subsection asfdoc_sam0_eeprom_basic_use_case_setup_prereq OKv
 * ̎gpʂɑ΂ēʂȍ\ݒKv͂܂B
 *
 * \subsection asfdoc_sam0_eeprom_basic_use_case_setup_code 
 * ȉ̍\ݒ躰ނgp҉pɕ/\t܂B
 * \snippet qs_emulator_basic.c setup
 *
 * gp҉p(ʓI\c main()̎n)ɒǉ܂B:
 * \snippet qs_emulator_basic.c setup_init
 *
 * \subsection asfdoc_sam0_eeprom_basic_use_case_setup_flow Ƃ̗
 * -# ֐ُ̈필ꎞϐɊi[EEPROM͕핔޽̏
 *    ݂܂B
 *    \snippet qs_emulator_basic.c init_eeprom_service
 * -# ޲ ˭ނ͕EEPROMgp̂߂ɏ[Ȏׯ ؗ\񂷂悤Ɍ`
 *    Ԑݒ肳ĂȂߖ͕핔s𒲂ׁA˭ނČ`
 *    ݒ肳ꂽꍇɒf܂B
 *    \snippet qs_emulator_basic.c check_init_ok
 * -# ͕핔޽(͕핔؂̫ϯĂ܂͕sŏ/Ďŝ悤
 *    ɐ肷ꍇ̂悤)̉ꂩ̗R̂߂ɏs𒲂ׂ
 *    B
 *    \snippet qs_emulator_basic.c check_re-init
 *
 *
 * \section asfdoc_sam0_eeprom_basic_use_case_main gp
 *
 * \subsection asfdoc_sam0_eeprom_basic_use_case_main_code 
 * ȉ̺ނgp҉pɕ/\t܂B:
 * \snippet qs_emulator_basic.c main
 *
 * \subsection asfdoc_sam0_eeprom_basic_use_case_main_flow Ƃ̗
 * -# ؂̒P͕EEPROM߰ނێ邽߂̊ɏՕ쐬A_EEPROM߰0
 *    ɓǂݏo܂B
 *    \snippet qs_emulator_basic.c read_page
 * -# ǂ߰ނ̐擪޲Ă𔽓]܂B
 *    \snippet qs_emulator_basic.c toggle_first_byte
 * -# LEDŐ؂ւLEDԂo͂܂B
 *    \snippet qs_emulator_basic.c set_led
 * -# ҏW߰ނ_EEPROM߰0ɏ߂AꂪɕIȕs
 *    ؂ɏ̂ۏ؂邽߁Ǎɓ͕핔ݷfo
 *    B
 *    \snippet qs_emulator_basic.c write_page
 */
