/**
 * \file
 *
 * \brief EVSYSp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_EVSYS_COMPONENT_
#define _SAMD20_EVSYS_COMPONENT_

/* ========================================================================== */
/** EVSYSpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD20_EVSYS ۼ ̪ */
/*@{*/

#define REV_EVSYS								0x100

/* -------- EVSYS_CTRL : (EVSYSψ:0x00) ( /W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ   0: ĳ ؾ */
    uint8_t  :3;				/*!< ޯ1`3: \ */
    uint8_t  GCLKREQ:1;			/*!< ޯ   4: ʸۯv */
    uint8_t  :3;				/*!< ޯ5`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_CTRL_OFFSET						0x00			/**< \brief (EVSYS_CTRL offset) */
#define EVSYS_CTRL_RESETVALUE					0x00			/**< \brief (EVSYS_CTRL reset_value) */

#define EVSYS_CTRL_SWRST_Pos					0				/**< \brief (EVSYS_CTRL)ĳ ؾ */
#define EVSYS_CTRL_SWRST						(0x1u << EVSYS_CTRL_SWRST_Pos)
#define EVSYS_CTRL_GCLKREQ_Pos					4				/**< \brief (EVSYS_CTRL)ʸۯv */
#define EVSYS_CTRL_GCLKREQ						(0x1u << EVSYS_CTRL_GCLKREQ_Pos)
#define EVSYS_CTRL_MASK							0x11u			/**< \brief (EVSYS_CTRL)Օڼ޽ */

/* -------- EVSYS_CHANNEL : (EVSYSψ:0x04) (R/W 32) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CHANNEL:8;			/*!< ޯ 0` 7: ّI */
    uint32_t SWEVT:1;			/*!< ޯ     8: ĳ */
    uint32_t :7;				/*!< ޯ 9`15: \ */
    uint32_t EVGEN:8;			/*!< ޯ16`23: ېI */
    uint32_t PATH:2;			/*!< ޯ 24,25: oHI */
    uint32_t EDGSEL:2;			/*!< ޯ 26,27: [I */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_CHANNEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_CHANNEL_OFFSET					0x04			/**< \brief (EVSYS_CHANNEL offset) */
#define EVSYS_CHANNEL_RESETVALUE				0x00000000			/**< \brief (EVSYS_CHANNEL reset_value) */

#define EVSYS_CHANNEL_CHANNEL_Pos				0				/**< \brief (EVSYS_CHANNEL)ّI */
#define EVSYS_CHANNEL_CHANNEL_Msk				(0xFFu << EVSYS_CHANNEL_CHANNEL_Pos)
#define EVSYS_CHANNEL_CHANNEL(value)			((EVSYS_CHANNEL_CHANNEL_Msk & ((value) << EVSYS_CHANNEL_CHANNEL_Pos)))
#define EVSYS_CHANNEL_SWEVT_Pos					8				/**< \brief (EVSYS_CHANNEL)ĳ */
#define EVSYS_CHANNEL_SWEVT						(0x1u << EVSYS_CHANNEL_SWEVT_Pos)
#define EVSYS_CHANNEL_EVGEN_Pos					16				/**< \brief (EVSYS_CHANNEL)ېI */
#define EVSYS_CHANNEL_EVGEN_Msk					(0xFFu << EVSYS_CHANNEL_EVGEN_Pos)
#define EVSYS_CHANNEL_EVGEN(value)				((EVSYS_CHANNEL_EVGEN_Msk & ((value) << EVSYS_CHANNEL_EVGEN_Pos)))
#define EVSYS_CHANNEL_PATH_Pos					24				/**< \brief (EVSYS_CHANNEL)oHI */
#define EVSYS_CHANNEL_PATH_Msk					(0x3u << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_PATH(value)				((EVSYS_CHANNEL_PATH_Msk & ((value) << EVSYS_CHANNEL_PATH_Pos)))
#define   EVSYS_CHANNEL_PATH_SYNCHRONOUS_Val		0x0u			/**< \brief (EVSYS_CHANNEL)oH */
#define   EVSYS_CHANNEL_PATH_RESYNCHRONIZED_Val		0x1u			/**< \brief (EVSYS_CHANNEL)ēoH */
#define   EVSYS_CHANNEL_PATH_ASYNCHRONOUS_Val		0x2u			/**< \brief (EVSYS_CHANNEL)񓯊oH */
#define EVSYS_CHANNEL_PATH_SYNCHRONOUS			(EVSYS_CHANNEL_PATH_SYNCHRONOUS_Val << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_PATH_RESYNCHRONIZED		(EVSYS_CHANNEL_PATH_RESYNCHRONIZED_Val << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_PATH_ASYNCHRONOUS			(EVSYS_CHANNEL_PATH_ASYNCHRONOUS_Val << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_EDGSEL_Pos				26				/**< \brief (EVSYS_CHANNEL)[I */
#define EVSYS_CHANNEL_EDGSEL_Msk				(0x3u << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL(value)				((EVSYS_CHANNEL_EDGSEL_Msk & ((value) << EVSYS_CHANNEL_EDGSEL_Pos)))
#define   EVSYS_CHANNEL_EDGSEL_NO_EVT_OUTPUT_Val	0x0u			/**< \brief (EVSYS_CHANNEL)ۏo͂Ȃ */
#define   EVSYS_CHANNEL_EDGSEL_RISING_EDGE_Val		0x1u			/**< \brief (EVSYS_CHANNEL)㏸[Ŏیo */
#define   EVSYS_CHANNEL_EDGSEL_FALLING_EDGE_Val		0x2u			/**< \brief (EVSYS_CHANNEL)~[Ŏیo */
#define   EVSYS_CHANNEL_EDGSEL_BOTH_EDGE_Val		0x3u			/**< \brief (EVSYS_CHANNEL)㏸[/~[Ŏیo */
#define EVSYS_CHANNEL_EDGSEL_NO_EVT_OUTPUT		(EVSYS_CHANNEL_EDGSEL_NO_EVT_OUTPUT_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL_RISING_EDGE		(EVSYS_CHANNEL_EDGSEL_RISING_EDGE_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL_FALLING_EDGE		(EVSYS_CHANNEL_EDGSEL_FALLING_EDGE_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL_BOTH_EDGE			(EVSYS_CHANNEL_EDGSEL_BOTH_EDGE_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_MASK						0x0FFF01FFu			/**< \brief (EVSYS_CHANNEL)Օڼ޽ */

/* -------- EVSYS_USER : (EVSYSψ:0x08) (R/W 16)gpd -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t USER:8;			/*!< ޯ0` 7: gpdI */
    uint16_t CHANNEL:8;			/*!< ޯ8`15: َۑI */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_USER_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_USER_OFFSET						0x08			/**< \brief (EVSYS_USER offset)gpd */
#define EVSYS_USER_RESETVALUE					0x0000			/**< \brief (EVSYS_USER reset_value)gpd */

#define EVSYS_USER_USER_Pos						0				/**< \brief (EVSYS_USER)gpdI */
#define EVSYS_USER_USER_Msk						(0xFFu << EVSYS_USER_USER_Pos)
#define EVSYS_USER_USER(value)					((EVSYS_USER_USER_Msk & ((value) << EVSYS_USER_USER_Pos)))
#define EVSYS_USER_CHANNEL_Pos					8				/**< \brief (EVSYS_USER)َۑI */
#define EVSYS_USER_CHANNEL_Msk					(0xFFu << EVSYS_USER_CHANNEL_Pos)
#define EVSYS_USER_CHANNEL(value)				((EVSYS_USER_CHANNEL_Msk & ((value) << EVSYS_USER_CHANNEL_Pos)))
#define EVSYS_USER_MASK							0xFFFFu			/**< \brief (EVSYS_USER)Օڼ޽ */

/* -------- EVSYS_CHSTATUS : (EVSYSψ:0x0C) (R/  32)ُ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t USRRDY0:8;			/*!< ޯ 0` 7: 0`7ɑ΂gpҏ(16̏]) */
    uint32_t CHBUSY0:8;			/*!< ޯ 8`15: ّZ0`7(16̏]) */
    uint32_t USRRDY1:8;			/*!< ޯ16`23: 8`15ɑ΂gpҏ(16̏]) */
    uint32_t CHBUSY1:8;			/*!< ޯ24`31: ّZ8`15(16̏]) */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_CHSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_CHSTATUS_OFFSET					0x0C			/**< \brief (EVSYS_CHSTATUS offset)ُ */
#define EVSYS_CHSTATUS_RESETVALUE				0x00000000			/**< \brief (EVSYS_CHSTATUS reset_value)ُ */

#define EVSYS_CHSTATUS_USRRDY0_Pos				0				/**< \brief (EVSYS_CHSTATUS)0`7NIgp */
#define EVSYS_CHSTATUS_USRRDY0_Msk				(0xFFu << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0(value)			((EVSYS_CHSTATUS_USRRDY0_Msk & ((value) << EVSYS_CHSTATUS_USRRDY0_Pos)))
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY0_Val		0x1u			/**< \brief (EVSYS_CHSTATUS)0pgp */
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY1_Val		0x2u			/**< \brief (EVSYS_CHSTATUS)1pgp */
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY2_Val		0x4u			/**< \brief (EVSYS_CHSTATUS)2pgp */
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY3_Val		0x8u			/**< \brief (EVSYS_CHSTATUS)3pgp */
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY4_Val		0x10u			/**< \brief (EVSYS_CHSTATUS)4pgp */
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY5_Val		0x20u			/**< \brief (EVSYS_CHSTATUS)5pgp */
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY6_Val		0x40u			/**< \brief (EVSYS_CHSTATUS)6pgp */
#define   EVSYS_CHSTATUS_USRRDY0_USRRDY7_Val		0x80u			/**< \brief (EVSYS_CHSTATUS)7pgp */
#define EVSYS_CHSTATUS_USRRDY0_USRRDY0			(EVSYS_CHSTATUS_USRRDY0_USRRDY0_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0_USRRDY1			(EVSYS_CHSTATUS_USRRDY0_USRRDY1_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0_USRRDY2			(EVSYS_CHSTATUS_USRRDY0_USRRDY2_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0_USRRDY3			(EVSYS_CHSTATUS_USRRDY0_USRRDY3_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0_USRRDY4			(EVSYS_CHSTATUS_USRRDY0_USRRDY4_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0_USRRDY5			(EVSYS_CHSTATUS_USRRDY0_USRRDY5_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0_USRRDY6			(EVSYS_CHSTATUS_USRRDY0_USRRDY6_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY0_USRRDY7			(EVSYS_CHSTATUS_USRRDY0_USRRDY7_Val << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_Pos				8				/**< \brief (EVSYS_CHSTATUS)ّZ0`7(16̏]) */
#define EVSYS_CHSTATUS_CHBUSY0_Msk				(0xFFu << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0(value)			((EVSYS_CHSTATUS_CHBUSY0_Msk & ((value) << EVSYS_CHSTATUS_CHBUSY0_Pos)))
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY0_Val		0x1u			/**< \brief (EVSYS_CHSTATUS)0Z */
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY1_Val		0x2u			/**< \brief (EVSYS_CHSTATUS)1Z */
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY2_Val		0x4u			/**< \brief (EVSYS_CHSTATUS)2Z */
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY3_Val		0x8u			/**< \brief (EVSYS_CHSTATUS)3Z */
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY4_Val		0x10u			/**< \brief (EVSYS_CHSTATUS)4Z */
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY5_Val		0x20u			/**< \brief (EVSYS_CHSTATUS)5Z */
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY6_Val		0x40u			/**< \brief (EVSYS_CHSTATUS)6Z */
#define   EVSYS_CHSTATUS_CHBUSY0_CHBUSY7_Val		0x80u			/**< \brief (EVSYS_CHSTATUS)7Z */
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY0			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY0_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY1			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY1_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY2			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY2_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY3			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY3_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY4			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY4_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY5			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY5_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY6			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY6_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY0_CHBUSY7			(EVSYS_CHSTATUS_CHBUSY0_CHBUSY7_Val << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_USRRDY1_Pos				16				/**< \brief (EVSYS_CHSTATUS)8`15ɑ΂gpҏ(16̏]) */
#define EVSYS_CHSTATUS_USRRDY1_Msk				(0xFFu << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1(value)			((EVSYS_CHSTATUS_USRRDY1_Msk & ((value) << EVSYS_CHSTATUS_USRRDY1_Pos)))
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY8_Val		0x1u			/**< \brief (EVSYS_CHSTATUS)8pgp */
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY9_Val		0x2u			/**< \brief (EVSYS_CHSTATUS)9pgp */
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY10_Val		0x4u			/**< \brief (EVSYS_CHSTATUS)10pgp */
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY11_Val		0x8u			/**< \brief (EVSYS_CHSTATUS)11pgp */
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY12_Val		0x10u			/**< \brief (EVSYS_CHSTATUS)12pgp */
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY13_Val		0x20u			/**< \brief (EVSYS_CHSTATUS)13pgp */
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY14_Val		0x40u			/**< \brief (EVSYS_CHSTATUS)14pgp */
#define   EVSYS_CHSTATUS_USRRDY1_USRRDY15_Val		0x80u			/**< \brief (EVSYS_CHSTATUS)15pgp */
#define EVSYS_CHSTATUS_USRRDY1_USRRDY8			(EVSYS_CHSTATUS_USRRDY1_USRRDY8_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1_USRRDY9			(EVSYS_CHSTATUS_USRRDY1_USRRDY9_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1_USRRDY10			(EVSYS_CHSTATUS_USRRDY1_USRRDY10_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1_USRRDY11			(EVSYS_CHSTATUS_USRRDY1_USRRDY11_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1_USRRDY12			(EVSYS_CHSTATUS_USRRDY1_USRRDY12_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1_USRRDY13			(EVSYS_CHSTATUS_USRRDY1_USRRDY13_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1_USRRDY14			(EVSYS_CHSTATUS_USRRDY1_USRRDY14_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY1_USRRDY15			(EVSYS_CHSTATUS_USRRDY1_USRRDY15_Val << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_Pos				24				/**< \brief (EVSYS_CHSTATUS)ّZ8`15(16̏]) */
#define EVSYS_CHSTATUS_CHBUSY1_Msk				(0xFFu << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1(value)			((EVSYS_CHSTATUS_CHBUSY1_Msk & ((value) << EVSYS_CHSTATUS_CHBUSY1_Pos)))
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY8_Val		0x1u			/**< \brief (EVSYS_CHSTATUS)8Z */
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY9_Val		0x2u			/**< \brief (EVSYS_CHSTATUS)9Z */
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY10_Val		0x4u			/**< \brief (EVSYS_CHSTATUS)10Z */
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY11_Val		0x8u			/**< \brief (EVSYS_CHSTATUS)11Z */
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY12_Val		0x10u			/**< \brief (EVSYS_CHSTATUS)12Z */
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY13_Val		0x20u			/**< \brief (EVSYS_CHSTATUS)13Z */
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY14_Val		0x40u			/**< \brief (EVSYS_CHSTATUS)14Z */
#define   EVSYS_CHSTATUS_CHBUSY1_CHBUSY15_Val		0x80u			/**< \brief (EVSYS_CHSTATUS)15Z */
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY8			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY8_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY9			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY9_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY10			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY10_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY11			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY11_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY12			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY12_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY13			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY13_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY14			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY14_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_CHBUSY15			(EVSYS_CHSTATUS_CHBUSY1_CHBUSY15_Val << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_MASK						0xFFFFFFFFu			/**< \brief (EVSYS_CHSTATUS)Օڼ޽ */

/* -------- EVSYS_INTENCLR : (EVSYSψ:0x10) (R/W 32)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t OVR0:8;			/*!< ޯ 0` 7: 0`7ɑ΂鵰ް݊荞݋֎~(16̏]) */
    uint32_t EVD0:8;			/*!< ޯ 8`15: 0`7ɑ΂鎖یo荞݋֎~(16̏]) */
    uint32_t OVR1:8;			/*!< ޯ16`23: 8`15ɑ΂鵰ް݊荞݋֎~(16̏]) */
    uint32_t EVD1:8;			/*!< ޯ24`31: 8`15ɑ΂鎖یo荞݋֎~(16̏]) */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_INTENCLR_OFFSET					0x10			/**< \brief (EVSYS_INTENCLR offset)荞݋ */
#define EVSYS_INTENCLR_RESETVALUE				0x00000000			/**< \brief (EVSYS_INTENCLR reset_value)荞݋ */

#define EVSYS_INTENCLR_OVR0_Pos					0				/**< \brief (EVSYS_INTENCLR)0`7ɑ΂鵰ް݊荞݋֎~(16̏]) */
#define EVSYS_INTENCLR_OVR0_Msk					(0xFFu << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0(value)				((EVSYS_INTENCLR_OVR0_Msk & ((value) << EVSYS_INTENCLR_OVR0_Pos)))
#define   EVSYS_INTENCLR_OVR0_OVR0_Val				0x1u			/**< \brief (EVSYS_INTENCLR)0ŵް݌o */
#define   EVSYS_INTENCLR_OVR0_OVR1_Val				0x2u			/**< \brief (EVSYS_INTENCLR)1ŵް݌o */
#define   EVSYS_INTENCLR_OVR0_OVR2_Val				0x4u			/**< \brief (EVSYS_INTENCLR)2ŵް݌o */
#define   EVSYS_INTENCLR_OVR0_OVR3_Val				0x8u			/**< \brief (EVSYS_INTENCLR)3ŵް݌o */
#define   EVSYS_INTENCLR_OVR0_OVR4_Val				0x10u			/**< \brief (EVSYS_INTENCLR)4ŵް݌o */
#define   EVSYS_INTENCLR_OVR0_OVR5_Val				0x20u			/**< \brief (EVSYS_INTENCLR)5ŵް݌o */
#define   EVSYS_INTENCLR_OVR0_OVR6_Val				0x40u			/**< \brief (EVSYS_INTENCLR)6ŵް݌o */
#define   EVSYS_INTENCLR_OVR0_OVR7_Val				0x80u			/**< \brief (EVSYS_INTENCLR)7ŵް݌o */
#define EVSYS_INTENCLR_OVR0_OVR0				(EVSYS_INTENCLR_OVR0_OVR0_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0_OVR1				(EVSYS_INTENCLR_OVR0_OVR1_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0_OVR2				(EVSYS_INTENCLR_OVR0_OVR2_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0_OVR3				(EVSYS_INTENCLR_OVR0_OVR3_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0_OVR4				(EVSYS_INTENCLR_OVR0_OVR4_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0_OVR5				(EVSYS_INTENCLR_OVR0_OVR5_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0_OVR6				(EVSYS_INTENCLR_OVR0_OVR6_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR0_OVR7				(EVSYS_INTENCLR_OVR0_OVR7_Val  << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_EVD0_Pos					8				/**< \brief (EVSYS_INTENCLR)0`7ɑ΂鎖یo荞݋֎~(16̏]) */
#define EVSYS_INTENCLR_EVD0_Msk					(0xFFu << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0(value)				((EVSYS_INTENCLR_EVD0_Msk & ((value) << EVSYS_INTENCLR_EVD0_Pos)))
#define   EVSYS_INTENCLR_EVD0_EVD0_Val				0x1u			/**< \brief (EVSYS_INTENCLR)0Ŏیo */
#define   EVSYS_INTENCLR_EVD0_EVD1_Val				0x2u			/**< \brief (EVSYS_INTENCLR)1Ŏیo */
#define   EVSYS_INTENCLR_EVD0_EVD2_Val				0x4u			/**< \brief (EVSYS_INTENCLR)2Ŏیo */
#define   EVSYS_INTENCLR_EVD0_EVD3_Val				0x8u			/**< \brief (EVSYS_INTENCLR)3Ŏیo */
#define   EVSYS_INTENCLR_EVD0_EVD4_Val				0x10u			/**< \brief (EVSYS_INTENCLR)4Ŏیo */
#define   EVSYS_INTENCLR_EVD0_EVD5_Val				0x20u			/**< \brief (EVSYS_INTENCLR)5Ŏیo */
#define   EVSYS_INTENCLR_EVD0_EVD6_Val				0x40u			/**< \brief (EVSYS_INTENCLR)6Ŏیo */
#define   EVSYS_INTENCLR_EVD0_EVD7_Val				0x80u			/**< \brief (EVSYS_INTENCLR)7Ŏیo */
#define EVSYS_INTENCLR_EVD0_EVD0				(EVSYS_INTENCLR_EVD0_EVD0_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0_EVD1				(EVSYS_INTENCLR_EVD0_EVD1_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0_EVD2				(EVSYS_INTENCLR_EVD0_EVD2_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0_EVD3				(EVSYS_INTENCLR_EVD0_EVD3_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0_EVD4				(EVSYS_INTENCLR_EVD0_EVD4_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0_EVD5				(EVSYS_INTENCLR_EVD0_EVD5_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0_EVD6				(EVSYS_INTENCLR_EVD0_EVD6_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD0_EVD7				(EVSYS_INTENCLR_EVD0_EVD7_Val  << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_OVR1_Pos					16				/**< \brief (EVSYS_INTENCLR)8`15ɑ΂鵰ް݊荞݋֎~(16̏]) */
#define EVSYS_INTENCLR_OVR1_Msk					(0xFFu << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1(value)				((EVSYS_INTENCLR_OVR1_Msk & ((value) << EVSYS_INTENCLR_OVR1_Pos)))
#define   EVSYS_INTENCLR_OVR1_OVR8_Val				0x1u			/**< \brief (EVSYS_INTENCLR)8ŵް݌o */
#define   EVSYS_INTENCLR_OVR1_OVR9_Val				0x2u			/**< \brief (EVSYS_INTENCLR)9ŵް݌o */
#define   EVSYS_INTENCLR_OVR1_OVR10_Val				0x4u			/**< \brief (EVSYS_INTENCLR)10ŵް݌o */
#define   EVSYS_INTENCLR_OVR1_OVR11_Val				0x8u			/**< \brief (EVSYS_INTENCLR)11ŵް݌o */
#define   EVSYS_INTENCLR_OVR1_OVR12_Val				0x10u			/**< \brief (EVSYS_INTENCLR)12ŵް݌o */
#define   EVSYS_INTENCLR_OVR1_OVR13_Val				0x20u			/**< \brief (EVSYS_INTENCLR)13ŵް݌o */
#define   EVSYS_INTENCLR_OVR1_OVR14_Val				0x40u			/**< \brief (EVSYS_INTENCLR)14ŵް݌o */
#define   EVSYS_INTENCLR_OVR1_OVR15_Val				0x80u			/**< \brief (EVSYS_INTENCLR)15ŵް݌o */
#define EVSYS_INTENCLR_OVR1_OVR8				(EVSYS_INTENCLR_OVR1_OVR8_Val  << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1_OVR9				(EVSYS_INTENCLR_OVR1_OVR9_Val  << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1_OVR10				(EVSYS_INTENCLR_OVR1_OVR10_Val << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1_OVR11				(EVSYS_INTENCLR_OVR1_OVR11_Val << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1_OVR12				(EVSYS_INTENCLR_OVR1_OVR12_Val << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1_OVR13				(EVSYS_INTENCLR_OVR1_OVR13_Val << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1_OVR14				(EVSYS_INTENCLR_OVR1_OVR14_Val << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR1_OVR15				(EVSYS_INTENCLR_OVR1_OVR15_Val << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_EVD1_Pos					24				/**< \brief (EVSYS_INTENCLR)8`15ɑ΂鎖یo荞݋֎~(16̏]) */
#define EVSYS_INTENCLR_EVD1_Msk					(0xFFu << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1(value)				((EVSYS_INTENCLR_EVD1_Msk & ((value) << EVSYS_INTENCLR_EVD1_Pos)))
#define   EVSYS_INTENCLR_EVD1_EVD8_Val				0x1u			/**< \brief (EVSYS_INTENCLR)8Ŏیo */
#define   EVSYS_INTENCLR_EVD1_EVD9_Val				0x2u			/**< \brief (EVSYS_INTENCLR)9Ŏیo */
#define   EVSYS_INTENCLR_EVD1_EVD10_Val				0x4u			/**< \brief (EVSYS_INTENCLR)10Ŏیo */
#define   EVSYS_INTENCLR_EVD1_EVD11_Val				0x8u			/**< \brief (EVSYS_INTENCLR)11Ŏیo */
#define   EVSYS_INTENCLR_EVD1_EVD12_Val				0x10u			/**< \brief (EVSYS_INTENCLR)12Ŏیo */
#define   EVSYS_INTENCLR_EVD1_EVD13_Val				0x20u			/**< \brief (EVSYS_INTENCLR)13Ŏیo */
#define   EVSYS_INTENCLR_EVD1_EVD14_Val				0x40u			/**< \brief (EVSYS_INTENCLR)14Ŏیo */
#define   EVSYS_INTENCLR_EVD1_EVD15_Val				0x80u			/**< \brief (EVSYS_INTENCLR)15Ŏیo */
#define EVSYS_INTENCLR_EVD1_EVD8				(EVSYS_INTENCLR_EVD1_EVD8_Val  << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1_EVD9				(EVSYS_INTENCLR_EVD1_EVD9_Val  << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1_EVD10				(EVSYS_INTENCLR_EVD1_EVD10_Val << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1_EVD11				(EVSYS_INTENCLR_EVD1_EVD11_Val << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1_EVD12				(EVSYS_INTENCLR_EVD1_EVD12_Val << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1_EVD13				(EVSYS_INTENCLR_EVD1_EVD13_Val << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1_EVD14				(EVSYS_INTENCLR_EVD1_EVD14_Val << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD1_EVD15				(EVSYS_INTENCLR_EVD1_EVD15_Val << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_MASK						0xFFFFFFFFu			/**< \brief (EVSYS_INTENCLR)Օڼ޽ */

/* -------- EVSYS_INTENSET : (EVSYSψ:0x14) (R/W 32)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t OVR0:8;			/*!< ޯ 0` 7: 0`7ɑ΂鵰ް݊荞݋(16̏]) */
    uint32_t EVD0:8;			/*!< ޯ 8`15: 0`7ɑ΂鎖یo荞݋(16̏]) */
    uint32_t OVR1:8;			/*!< ޯ16`23: 8`15ɑ΂鵰ް݊荞݋(16̏]) */
    uint32_t EVD1:8;			/*!< ޯ24`31: 8`15ɑ΂鎖یo荞݋(16̏]) */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_INTENSET_OFFSET					0x14			/**< \brief (EVSYS_INTENSET offset)荞݋ݒ */
#define EVSYS_INTENSET_RESETVALUE				0x00000000			/**< \brief (EVSYS_INTENSET reset_value)荞݋ݒ */

#define EVSYS_INTENSET_OVR0_Pos					0				/**< \brief (EVSYS_INTENSET)0`7ɑ΂鵰ް݊荞݋(16̏]) */
#define EVSYS_INTENSET_OVR0_Msk					(0xFFu << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0(value)				((EVSYS_INTENSET_OVR0_Msk & ((value) << EVSYS_INTENSET_OVR0_Pos)))
#define   EVSYS_INTENSET_OVR0_OVR0_Val				0x1u			/**< \brief (EVSYS_INTENSET)0ŵް݌o */
#define   EVSYS_INTENSET_OVR0_OVR1_Val				0x2u			/**< \brief (EVSYS_INTENSET)1ŵް݌o */
#define   EVSYS_INTENSET_OVR0_OVR2_Val				0x4u			/**< \brief (EVSYS_INTENSET)2ŵް݌o */
#define   EVSYS_INTENSET_OVR0_OVR3_Val				0x8u			/**< \brief (EVSYS_INTENSET)3ŵް݌o */
#define   EVSYS_INTENSET_OVR0_OVR4_Val				0x10u			/**< \brief (EVSYS_INTENSET)4ŵް݌o */
#define   EVSYS_INTENSET_OVR0_OVR5_Val				0x20u			/**< \brief (EVSYS_INTENSET)5ŵް݌o */
#define   EVSYS_INTENSET_OVR0_OVR6_Val				0x40u			/**< \brief (EVSYS_INTENSET)6ŵް݌o */
#define   EVSYS_INTENSET_OVR0_OVR7_Val				0x80u			/**< \brief (EVSYS_INTENSET)7ŵް݌o */
#define EVSYS_INTENSET_OVR0_OVR0				(EVSYS_INTENSET_OVR0_OVR0_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0_OVR1				(EVSYS_INTENSET_OVR0_OVR1_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0_OVR2				(EVSYS_INTENSET_OVR0_OVR2_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0_OVR3				(EVSYS_INTENSET_OVR0_OVR3_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0_OVR4				(EVSYS_INTENSET_OVR0_OVR4_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0_OVR5				(EVSYS_INTENSET_OVR0_OVR5_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0_OVR6				(EVSYS_INTENSET_OVR0_OVR6_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR0_OVR7				(EVSYS_INTENSET_OVR0_OVR7_Val  << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_EVD0_Pos					8				/**< \brief (EVSYS_INTENSET)0`7ɑ΂鎖یo荞݋(16̏]) */
#define EVSYS_INTENSET_EVD0_Msk					(0xFFu << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0(value)				((EVSYS_INTENSET_EVD0_Msk & ((value) << EVSYS_INTENSET_EVD0_Pos)))
#define   EVSYS_INTENSET_EVD0_EVD0_Val				0x1u			/**< \brief (EVSYS_INTENSET)0Ŏیo */
#define   EVSYS_INTENSET_EVD0_EVD1_Val				0x2u			/**< \brief (EVSYS_INTENSET)1Ŏیo */
#define   EVSYS_INTENSET_EVD0_EVD2_Val				0x4u			/**< \brief (EVSYS_INTENSET)2Ŏیo */
#define   EVSYS_INTENSET_EVD0_EVD3_Val				0x8u			/**< \brief (EVSYS_INTENSET)3Ŏیo */
#define   EVSYS_INTENSET_EVD0_EVD4_Val				0x10u			/**< \brief (EVSYS_INTENSET)4Ŏیo */
#define   EVSYS_INTENSET_EVD0_EVD5_Val				0x20u			/**< \brief (EVSYS_INTENSET)5Ŏیo */
#define   EVSYS_INTENSET_EVD0_EVD6_Val				0x40u			/**< \brief (EVSYS_INTENSET)6Ŏیo */
#define   EVSYS_INTENSET_EVD0_EVD7_Val				0x80u			/**< \brief (EVSYS_INTENSET)7Ŏیo */
#define EVSYS_INTENSET_EVD0_EVD0				(EVSYS_INTENSET_EVD0_EVD0_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0_EVD1				(EVSYS_INTENSET_EVD0_EVD1_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0_EVD2				(EVSYS_INTENSET_EVD0_EVD2_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0_EVD3				(EVSYS_INTENSET_EVD0_EVD3_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0_EVD4				(EVSYS_INTENSET_EVD0_EVD4_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0_EVD5				(EVSYS_INTENSET_EVD0_EVD5_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0_EVD6				(EVSYS_INTENSET_EVD0_EVD6_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD0_EVD7				(EVSYS_INTENSET_EVD0_EVD7_Val  << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_OVR1_Pos					16				/**< \brief (EVSYS_INTENSET)8`15ɑ΂鵰ް݊荞݋(16̏]) */
#define EVSYS_INTENSET_OVR1_Msk					(0xFFu << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1(value)				((EVSYS_INTENSET_OVR1_Msk & ((value) << EVSYS_INTENSET_OVR1_Pos)))
#define   EVSYS_INTENSET_OVR1_OVR8_Val				0x1u			/**< \brief (EVSYS_INTENSET)8ŵް݌o */
#define   EVSYS_INTENSET_OVR1_OVR9_Val				0x2u			/**< \brief (EVSYS_INTENSET)9ŵް݌o */
#define   EVSYS_INTENSET_OVR1_OVR10_Val				0x4u			/**< \brief (EVSYS_INTENSET)10ŵް݌o */
#define   EVSYS_INTENSET_OVR1_OVR11_Val				0x8u			/**< \brief (EVSYS_INTENSET)11ŵް݌o */
#define   EVSYS_INTENSET_OVR1_OVR12_Val				0x10u			/**< \brief (EVSYS_INTENSET)12ŵް݌o */
#define   EVSYS_INTENSET_OVR1_OVR13_Val				0x20u			/**< \brief (EVSYS_INTENSET)13ŵް݌o */
#define   EVSYS_INTENSET_OVR1_OVR14_Val				0x40u			/**< \brief (EVSYS_INTENSET)14ŵް݌o */
#define   EVSYS_INTENSET_OVR1_OVR15_Val				0x80u			/**< \brief (EVSYS_INTENSET)15ŵް݌o */
#define EVSYS_INTENSET_OVR1_OVR8				(EVSYS_INTENSET_OVR1_OVR8_Val  << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1_OVR9				(EVSYS_INTENSET_OVR1_OVR9_Val  << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1_OVR10				(EVSYS_INTENSET_OVR1_OVR10_Val << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1_OVR11				(EVSYS_INTENSET_OVR1_OVR11_Val << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1_OVR12				(EVSYS_INTENSET_OVR1_OVR12_Val << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1_OVR13				(EVSYS_INTENSET_OVR1_OVR13_Val << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1_OVR14				(EVSYS_INTENSET_OVR1_OVR14_Val << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR1_OVR15				(EVSYS_INTENSET_OVR1_OVR15_Val << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_EVD1_Pos					24				/**< \brief (EVSYS_INTENSET)8`15ɑ΂鎖یo荞݋(16̏]) */
#define EVSYS_INTENSET_EVD1_Msk					(0xFFu << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1(value)				((EVSYS_INTENSET_EVD1_Msk & ((value) << EVSYS_INTENSET_EVD1_Pos)))
#define   EVSYS_INTENSET_EVD1_EVD8_Val				0x1u			/**< \brief (EVSYS_INTENSET)8Ŏیo */
#define   EVSYS_INTENSET_EVD1_EVD9_Val				0x2u			/**< \brief (EVSYS_INTENSET)9Ŏیo */
#define   EVSYS_INTENSET_EVD1_EVD10_Val				0x4u			/**< \brief (EVSYS_INTENSET)10Ŏیo */
#define   EVSYS_INTENSET_EVD1_EVD11_Val				0x8u			/**< \brief (EVSYS_INTENSET)11Ŏیo */
#define   EVSYS_INTENSET_EVD1_EVD12_Val				0x10u			/**< \brief (EVSYS_INTENSET)12Ŏیo */
#define   EVSYS_INTENSET_EVD1_EVD13_Val				0x20u			/**< \brief (EVSYS_INTENSET)13Ŏیo */
#define   EVSYS_INTENSET_EVD1_EVD14_Val				0x40u			/**< \brief (EVSYS_INTENSET)14Ŏیo */
#define   EVSYS_INTENSET_EVD1_EVD15_Val				0x80u			/**< \brief (EVSYS_INTENSET)15Ŏیo */
#define EVSYS_INTENSET_EVD1_EVD8				(EVSYS_INTENSET_EVD1_EVD8_Val  << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1_EVD9				(EVSYS_INTENSET_EVD1_EVD9_Val  << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1_EVD10				(EVSYS_INTENSET_EVD1_EVD10_Val << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1_EVD11				(EVSYS_INTENSET_EVD1_EVD11_Val << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1_EVD12				(EVSYS_INTENSET_EVD1_EVD12_Val << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1_EVD13				(EVSYS_INTENSET_EVD1_EVD13_Val << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1_EVD14				(EVSYS_INTENSET_EVD1_EVD14_Val << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD1_EVD15				(EVSYS_INTENSET_EVD1_EVD15_Val << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_MASK						0xFFFFFFFFu			/**< \brief (EVSYS_INTENSET)Օڼ޽ */

/* -------- EVSYS_INTFLAG : (EVSYSψ:0x18) (R/W 32)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t OVR0:8;			/*!< ޯ 0` 7: 0`7ɑ΂鵰ް݊荞׸(16̏]) */
    uint32_t EVD0:8;			/*!< ޯ 8`15: 0`7ɑ΂鎖یo荞׸(16̏]) */
    uint32_t OVR1:8;			/*!< ޯ16`23: 8`15ɑ΂鵰ް݊荞׸(16̏]) */
    uint32_t EVD1:8;			/*!< ޯ24`31: 8`15ɑ΂鎖یo荞׸(16̏]) */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_INTFLAG_OFFSET					0x18			/**< \brief (EVSYS_INTFLAG offset)荞׸ޏ/ */
#define EVSYS_INTFLAG_RESETVALUE				0x00000000			/**< \brief (EVSYS_INTFLAG reset_value)荞׸ޏ/ */

#define EVSYS_INTFLAG_OVR0_Pos					0				/**< \brief (EVSYS_INTFLAG)0`7ɑ΂鵰ް݊荞׸(16̏]) */
#define EVSYS_INTFLAG_OVR0_Msk					(0xFFu << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0(value)				((EVSYS_INTFLAG_OVR0_Msk & ((value) << EVSYS_INTFLAG_OVR0_Pos)))
#define   EVSYS_INTFLAG_OVR0_OVR0_Val				0x1u			/**< \brief (EVSYS_INTFLAG)0ŵް݌o */
#define   EVSYS_INTFLAG_OVR0_OVR1_Val				0x2u			/**< \brief (EVSYS_INTFLAG)1ŵް݌o */
#define   EVSYS_INTFLAG_OVR0_OVR2_Val				0x4u			/**< \brief (EVSYS_INTFLAG)2ŵް݌o */
#define   EVSYS_INTFLAG_OVR0_OVR3_Val				0x8u			/**< \brief (EVSYS_INTFLAG)3ŵް݌o */
#define   EVSYS_INTFLAG_OVR0_OVR4_Val				0x10u			/**< \brief (EVSYS_INTFLAG)4ŵް݌o */
#define   EVSYS_INTFLAG_OVR0_OVR5_Val				0x20u			/**< \brief (EVSYS_INTFLAG)5ŵް݌o */
#define   EVSYS_INTFLAG_OVR0_OVR6_Val				0x40u			/**< \brief (EVSYS_INTFLAG)6ŵް݌o */
#define   EVSYS_INTFLAG_OVR0_OVR7_Val				0x80u			/**< \brief (EVSYS_INTFLAG)7ŵް݌o */
#define EVSYS_INTFLAG_OVR0_OVR0					(EVSYS_INTFLAG_OVR0_OVR0_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0_OVR1					(EVSYS_INTFLAG_OVR0_OVR1_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0_OVR2					(EVSYS_INTFLAG_OVR0_OVR2_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0_OVR3					(EVSYS_INTFLAG_OVR0_OVR3_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0_OVR4					(EVSYS_INTFLAG_OVR0_OVR4_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0_OVR5					(EVSYS_INTFLAG_OVR0_OVR5_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0_OVR6					(EVSYS_INTFLAG_OVR0_OVR6_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR0_OVR7					(EVSYS_INTFLAG_OVR0_OVR7_Val   << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_EVD0_Pos					8				/**< \brief (EVSYS_INTFLAG)0`7ɑ΂鎖یo荞׸(16̏]) */
#define EVSYS_INTFLAG_EVD0_Msk					(0xFFu << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0(value)				((EVSYS_INTFLAG_EVD0_Msk & ((value) << EVSYS_INTFLAG_EVD0_Pos)))
#define   EVSYS_INTFLAG_EVD0_EVD0_Val				0x1u			/**< \brief (EVSYS_INTFLAG)0Ŏیo */
#define   EVSYS_INTFLAG_EVD0_EVD1_Val				0x2u			/**< \brief (EVSYS_INTFLAG)1Ŏیo */
#define   EVSYS_INTFLAG_EVD0_EVD2_Val				0x4u			/**< \brief (EVSYS_INTFLAG)2Ŏیo */
#define   EVSYS_INTFLAG_EVD0_EVD3_Val				0x8u			/**< \brief (EVSYS_INTFLAG)3Ŏیo */
#define   EVSYS_INTFLAG_EVD0_EVD4_Val				0x10u			/**< \brief (EVSYS_INTFLAG)4Ŏیo */
#define   EVSYS_INTFLAG_EVD0_EVD5_Val				0x20u			/**< \brief (EVSYS_INTFLAG)5Ŏیo */
#define   EVSYS_INTFLAG_EVD0_EVD6_Val				0x40u			/**< \brief (EVSYS_INTFLAG)6Ŏیo */
#define   EVSYS_INTFLAG_EVD0_EVD7_Val				0x80u			/**< \brief (EVSYS_INTFLAG)7Ŏیo */
#define EVSYS_INTFLAG_EVD0_EVD0					(EVSYS_INTFLAG_EVD0_EVD0_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0_EVD1					(EVSYS_INTFLAG_EVD0_EVD1_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0_EVD2					(EVSYS_INTFLAG_EVD0_EVD2_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0_EVD3					(EVSYS_INTFLAG_EVD0_EVD3_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0_EVD4					(EVSYS_INTFLAG_EVD0_EVD4_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0_EVD5					(EVSYS_INTFLAG_EVD0_EVD5_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0_EVD6					(EVSYS_INTFLAG_EVD0_EVD6_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD0_EVD7					(EVSYS_INTFLAG_EVD0_EVD7_Val   << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_OVR1_Pos					16				/**< \brief (EVSYS_INTFLAG)8`15ɑ΂鵰ް݊荞׸(16̏]) */
#define EVSYS_INTFLAG_OVR1_Msk					(0xFFu << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1(value)				((EVSYS_INTFLAG_OVR1_Msk & ((value) << EVSYS_INTFLAG_OVR1_Pos)))
#define   EVSYS_INTFLAG_OVR1_OVR8_Val				0x1u			/**< \brief (EVSYS_INTFLAG)8ŵް݌o */
#define   EVSYS_INTFLAG_OVR1_OVR9_Val				0x2u			/**< \brief (EVSYS_INTFLAG)9ŵް݌o */
#define   EVSYS_INTFLAG_OVR1_OVR10_Val				0x4u			/**< \brief (EVSYS_INTFLAG)10ŵް݌o */
#define   EVSYS_INTFLAG_OVR1_OVR11_Val				0x8u			/**< \brief (EVSYS_INTFLAG)11ŵް݌o */
#define   EVSYS_INTFLAG_OVR1_OVR12_Val				0x10u			/**< \brief (EVSYS_INTFLAG)12ŵް݌o */
#define   EVSYS_INTFLAG_OVR1_OVR13_Val				0x20u			/**< \brief (EVSYS_INTFLAG)13ŵް݌o */
#define   EVSYS_INTFLAG_OVR1_OVR14_Val				0x40u			/**< \brief (EVSYS_INTFLAG)14ŵް݌o */
#define   EVSYS_INTFLAG_OVR1_OVR15_Val				0x80u			/**< \brief (EVSYS_INTFLAG)15ŵް݌o */
#define EVSYS_INTFLAG_OVR1_OVR8					(EVSYS_INTFLAG_OVR1_OVR8_Val   << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1_OVR9					(EVSYS_INTFLAG_OVR1_OVR9_Val   << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1_OVR10				(EVSYS_INTFLAG_OVR1_OVR10_Val  << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1_OVR11				(EVSYS_INTFLAG_OVR1_OVR11_Val  << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1_OVR12				(EVSYS_INTFLAG_OVR1_OVR12_Val  << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1_OVR13				(EVSYS_INTFLAG_OVR1_OVR13_Val  << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1_OVR14				(EVSYS_INTFLAG_OVR1_OVR14_Val  << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR1_OVR15				(EVSYS_INTFLAG_OVR1_OVR15_Val  << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_EVD1_Pos					24				/**< \brief (EVSYS_INTFLAG)8`15ɑ΂鎖یo荞׸(16̏]) */
#define EVSYS_INTFLAG_EVD1_Msk					(0xFFu << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1(value)				((EVSYS_INTFLAG_EVD1_Msk & ((value) << EVSYS_INTFLAG_EVD1_Pos)))
#define   EVSYS_INTFLAG_EVD1_EVD8_Val				0x1u			/**< \brief (EVSYS_INTFLAG)8Ŏیo */
#define   EVSYS_INTFLAG_EVD1_EVD9_Val				0x2u			/**< \brief (EVSYS_INTFLAG)9Ŏیo */
#define   EVSYS_INTFLAG_EVD1_EVD10_Val				0x4u			/**< \brief (EVSYS_INTFLAG)10Ŏیo */
#define   EVSYS_INTFLAG_EVD1_EVD11_Val				0x8u			/**< \brief (EVSYS_INTFLAG)11Ŏیo */
#define   EVSYS_INTFLAG_EVD1_EVD12_Val				0x10u			/**< \brief (EVSYS_INTFLAG)12Ŏیo */
#define   EVSYS_INTFLAG_EVD1_EVD13_Val				0x20u			/**< \brief (EVSYS_INTFLAG)13Ŏیo */
#define   EVSYS_INTFLAG_EVD1_EVD14_Val				0x40u			/**< \brief (EVSYS_INTFLAG)14Ŏیo */
#define   EVSYS_INTFLAG_EVD1_EVD15_Val				0x80u			/**< \brief (EVSYS_INTFLAG)15Ŏیo */
#define EVSYS_INTFLAG_EVD1_EVD8					(EVSYS_INTFLAG_EVD1_EVD8_Val   << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1_EVD9					(EVSYS_INTFLAG_EVD1_EVD9_Val   << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1_EVD10				(EVSYS_INTFLAG_EVD1_EVD10_Val  << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1_EVD11				(EVSYS_INTFLAG_EVD1_EVD11_Val  << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1_EVD12				(EVSYS_INTFLAG_EVD1_EVD12_Val  << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1_EVD13				(EVSYS_INTFLAG_EVD1_EVD13_Val  << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1_EVD14				(EVSYS_INTFLAG_EVD1_EVD14_Val  << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD1_EVD15				(EVSYS_INTFLAG_EVD1_EVD15_Val  << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_MASK						0xFFFFFFFFu			/**< \brief (EVSYS_INTFLAG)Օڼ޽ */

/** \brief EVSYSʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __O  EVSYS_CTRL_Type		CTRL;			/**< \briefψ:0x00 ( /W  8) */
	   RoReg8				Reserved1[0x3];
  __IO EVSYS_CHANNEL_Type	CHANNEL;		/**< \briefψ:0x04 (R/W 32) */
  __IO EVSYS_USER_Type		USER;			/**< \briefψ:0x08 (R/W 16)gpd */
	   RoReg8				Reserved2[0x2];
  __I  EVSYS_CHSTATUS_Type	CHSTATUS;		/**< \briefψ:0x0C (R/  32)ُ */
  __IO EVSYS_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x10 (R/W 32)荞݋ */
  __IO EVSYS_INTENSET_Type	INTENSET;		/**< \briefψ:0x14 (R/W 32)荞݋ݒ */
  __IO EVSYS_INTFLAG_Type	INTFLAG;		/**< \briefψ:0x18 (R/W 32)荞׸ޏ/ */
} Evsys;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD20_EVSYS_COMPONENT_ */
