/**
 * \file
 *
 * \brief PMp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_PM_COMPONENT_
#define _SAMD20_PM_COMPONENT_

/* ========================================================================== */
/** PMpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD20_PM d͊Ǘ */
/*@{*/

#define REV_PM						0x200

/* -------- PM_CTRL : (PMψ:0x00) (R/W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :2;				/*!< ޯ0`1: \ */
    uint8_t  CFDEN:1;			/*!< ޯ   2: ۯQo */
    uint8_t  :1;				/*!< ޯ   3: \ */
    uint8_t  BKUPCLK:1;			/*!< ޯ   4: ָۯI */
    uint8_t  :3;				/*!< ޯ5`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_CTRL_OFFSET				0x00			/**< \brief (PM_CTRL offset) */
#define PM_CTRL_RESETVALUE			0x00			/**< \brief (PM_CTRL reset_value) */

#define PM_CTRL_CFDEN_Pos			2				/**< \brief (PM_CTRL)ۯQo */
#define PM_CTRL_CFDEN				(0x1u << PM_CTRL_CFDEN_Pos)
#define PM_CTRL_BKUPCLK_Pos			4				/**< \brief (PM_CTRL)ָۯI */
#define PM_CTRL_BKUPCLK				(0x1u << PM_CTRL_BKUPCLK_Pos)
#define PM_CTRL_MASK				0x14u			/**< \brief (PM_CTRL)Օڼ޽ */

/* -------- PM_SLEEP : (PMψ:0x01) (R/W  8)x~ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  IDLE:2;			/*!< ޯ0`1:   */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_SLEEP_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_SLEEP_OFFSET				0x01			/**< \brief (PM_SLEEP offset)x~ */
#define PM_SLEEP_RESETVALUE			0x00			/**< \brief (PM_SLEEP reset_value)x~ */

#define PM_SLEEP_IDLE_Pos			0				/**< \brief (PM_SLEEP)  */
#define PM_SLEEP_IDLE_Msk			(0x3u << PM_SLEEP_IDLE_Pos)
#define PM_SLEEP_IDLE(value)		((PM_SLEEP_IDLE_Msk & ((value) << PM_SLEEP_IDLE_Pos)))
#define PM_SLEEP_MASK				0x03u			/**< \brief (PM_SLEEP)Օڼ޽ */

/* -------- PM_CPUSEL : (PMψ:0x08) (R/W  8)CPUۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CPUDIV:3;			/*!< ޯ0`2: CPUۯI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_CPUSEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_CPUSEL_OFFSET			0x08			/**< \brief (PM_CPUSEL offset)CPUۯI */
#define PM_CPUSEL_RESETVALUE		0x00			/**< \brief (PM_CPUSEL reset_value)CPUۯI */

#define PM_CPUSEL_CPUDIV_Pos		0				/**< \brief (PM_CPUSEL)CPUۯI */
#define PM_CPUSEL_CPUDIV_Msk		(0x7u << PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV(value)		((PM_CPUSEL_CPUDIV_Msk & ((value) << PM_CPUSEL_CPUDIV_Pos)))
#define PM_CPUSEL_MASK				0x07u			/**< \brief (PM_CPUSEL)Օڼ޽ */

/* -------- PM_APBASEL : (PMψ:0x09) (R/W  8)APBAۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  APBADIV:3;			/*!< ޯ0`2: APBAۯI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBASEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBASEL_OFFSET			0x09			/**< \brief (PM_APBASEL offset)APBAۯI */
#define PM_APBASEL_RESETVALUE		0x00			/**< \brief (PM_APBASEL reset_value)APBAۯI */

#define PM_APBASEL_APBADIV_Pos		0				/**< \brief (PM_APBASEL)APBAۯI */
#define PM_APBASEL_APBADIV_Msk		(0x7u << PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV(value)	((PM_APBASEL_APBADIV_Msk & ((value) << PM_APBASEL_APBADIV_Pos)))
#define PM_APBASEL_MASK				0x07u			/**< \brief (PM_APBASEL)Օڼ޽ */

/* -------- PM_APBBSEL : (PMψ:0x0A) (R/W  8)APBBۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  APBBDIV:3;			/*!< ޯ0`2: APBBۯI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBBSEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBBSEL_OFFSET			0x0A			/**< \brief (PM_APBBSEL offset)APBBۯI */
#define PM_APBBSEL_RESETVALUE		0x00			/**< \brief (PM_APBBSEL reset_value)APBBۯI */

#define PM_APBBSEL_APBBDIV_Pos		0				/**< \brief (PM_APBBSEL)APBBۯI */
#define PM_APBBSEL_APBBDIV_Msk		(0x7u << PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV(value)	((PM_APBBSEL_APBBDIV_Msk & ((value) << PM_APBBSEL_APBBDIV_Pos)))
#define PM_APBBSEL_MASK				0x07u			/**< \brief (PM_APBBSEL)Օڼ޽ */

/* -------- PM_APBCSEL : (PMψ:0x0B) (R/W  8)APBCۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  APBCDIV:3;			/*!< ޯ0`2: APBCۯI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBCSEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBCSEL_OFFSET			0x0B			/**< \brief (PM_APBCSEL offset)APBCۯI */
#define PM_APBCSEL_RESETVALUE		0x00			/**< \brief (PM_APBCSEL reset_value)APBCۯI */

#define PM_APBCSEL_APBCDIV_Pos		0				/**< \brief (PM_APBCSEL)APBCۯI */
#define PM_APBCSEL_APBCDIV_Msk		(0x7u << PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV(value)	((PM_APBCSEL_APBCDIV_Msk & ((value) << PM_APBCSEL_APBCDIV_Pos)))
#define PM_APBCSEL_MASK				0x07u			/**< \brief (PM_APBCSEL)Օڼ޽ */

/* -------- PM_AHBMASK : (PMψ:0x14) (R/W 32)AHBՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t HPB0:1;			/*!< ޯ    0: HPB0 AHBۯՕ */
    uint32_t HPB1:1;			/*!< ޯ    1: HPB1 AHBۯՕ */
    uint32_t HPB2:1;			/*!< ޯ    2: HPB2 AHBۯՕ */
    uint32_t DSU:1;				/*!< ޯ    3: DSU AHBۯՕ */
    uint32_t NVMCTRL:1;			/*!< ޯ    4: NVMCTRL AHBۯՕ */
    uint32_t :27;				/*!< ޯ5`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_AHBMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_AHBMASK_OFFSET			0x14			/**< \brief (PM_AHBMASK offset)AHBՕ */
#define PM_AHBMASK_RESETVALUE		0x0000001F		/**< \brief (PM_AHBMASK reset_value)AHBՕ */

#define PM_AHBMASK_HPB0_Pos			0				/**< \brief (PM_AHBMASK)HPB0 AHBۯՕ */
#define PM_AHBMASK_HPB0				(0x1u << PM_AHBMASK_HPB0_Pos)
#define PM_AHBMASK_HPB1_Pos			1				/**< \brief (PM_AHBMASK)HPB1 AHBۯՕ */
#define PM_AHBMASK_HPB1				(0x1u << PM_AHBMASK_HPB1_Pos)
#define PM_AHBMASK_HPB2_Pos			2				/**< \brief (PM_AHBMASK)HPB2 AHBۯՕ */
#define PM_AHBMASK_HPB2				(0x1u << PM_AHBMASK_HPB2_Pos)
#define PM_AHBMASK_DSU_Pos			3				/**< \brief (PM_AHBMASK)DSU AHBۯՕ */
#define PM_AHBMASK_DSU				(0x1u << PM_AHBMASK_DSU_Pos)
#define PM_AHBMASK_NVMCTRL_Pos		4				/**< \brief (PM_AHBMASK)NVMCTRL AHBۯՕ */
#define PM_AHBMASK_NVMCTRL			(0x1u << PM_AHBMASK_NVMCTRL_Pos)
#define PM_AHBMASK_MASK				0x0000001Fu		/**< \brief (PM_AHBMASK)Օڼ޽ */

/* -------- PM_APBAMASK : (PMψ:0x18) (R/W 32)APBAՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PAC0:1;			/*!< ޯ    0: PAC0 APBۯՕ */
    uint32_t PM:1;				/*!< ޯ    1: PM APBۯՕ */
    uint32_t SYSCTRL:1;			/*!< ޯ    2: SYSCTRL APBۯՕ */
    uint32_t GCLK:1;			/*!< ޯ    3: GCLK APBۯՕ */
    uint32_t WDT:1;				/*!< ޯ    4: WDT APBۯՕ */
    uint32_t RTC:1;				/*!< ޯ    5: RTC APBۯՕ */
    uint32_t EIC:1;				/*!< ޯ    6: EIC APBۯՕ */
    uint32_t :25;				/*!< ޯ7`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBAMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBAMASK_OFFSET			0x18			/**< \brief (PM_APBAMASK offset)APBAՕ */
#define PM_APBAMASK_RESETVALUE		0x0000007F		/**< \brief (PM_APBAMASK reset_value)APBAՕ */

#define PM_APBAMASK_PAC0_Pos		0				/**< \brief (PM_APBAMASK)PAC0 APBۯՕ */
#define PM_APBAMASK_PAC0			(0x1u << PM_APBAMASK_PAC0_Pos)
#define PM_APBAMASK_PM_Pos			1				/**< \brief (PM_APBAMASK)PM APBۯՕ */
#define PM_APBAMASK_PM				(0x1u << PM_APBAMASK_PM_Pos)
#define PM_APBAMASK_SYSCTRL_Pos		2				/**< \brief (PM_APBAMASK)SYSCTRL APBۯՕ */
#define PM_APBAMASK_SYSCTRL			(0x1u << PM_APBAMASK_SYSCTRL_Pos)
#define PM_APBAMASK_GCLK_Pos		3				/**< \brief (PM_APBAMASK)GCLK APBۯՕ */
#define PM_APBAMASK_GCLK			(0x1u << PM_APBAMASK_GCLK_Pos)
#define PM_APBAMASK_WDT_Pos			4				/**< \brief (PM_APBAMASK)WDT APBۯՕ */
#define PM_APBAMASK_WDT				(0x1u << PM_APBAMASK_WDT_Pos)
#define PM_APBAMASK_RTC_Pos			5				/**< \brief (PM_APBAMASK)RTC APBۯՕ */
#define PM_APBAMASK_RTC				(0x1u << PM_APBAMASK_RTC_Pos)
#define PM_APBAMASK_EIC_Pos			6				/**< \brief (PM_APBAMASK)EIC APBۯՕ */
#define PM_APBAMASK_EIC				(0x1u << PM_APBAMASK_EIC_Pos)
#define PM_APBAMASK_MASK			0x0000007Fu		/**< \brief (PM_APBAMASK)Օڼ޽ */

/* -------- PM_APBBMASK : (PMψ:0x1C) (R/W 32)APBBՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PAC1:1;			/*!< ޯ    0: PAC1 APBۯՕ */
    uint32_t DSU:1;				/*!< ޯ    1: DSU APBۯՕ */
    uint32_t NVMCTRL:1;			/*!< ޯ    2: NVMCTRL APBۯՕ */
    uint32_t PORT:1;			/*!< ޯ    3: PORT APBۯՕ */
    uint32_t :28;				/*!< ޯ4`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBBMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBBMASK_OFFSET			0x1C			/**< \brief (PM_APBBMASK offset)APBBՕ */
#define PM_APBBMASK_RESETVALUE		0x0000001F		/**< \brief (PM_APBBMASK reset_value)APBBՕ */

#define PM_APBBMASK_PAC1_Pos		0				/**< \brief (PM_APBBMASK)PAC1 APBۯՕ */
#define PM_APBBMASK_PAC1			(0x1u << PM_APBBMASK_PAC1_Pos)
#define PM_APBBMASK_DSU_Pos			1				/**< \brief (PM_APBBMASK)DSU APBۯՕ */
#define PM_APBBMASK_DSU				(0x1u << PM_APBBMASK_DSU_Pos)
#define PM_APBBMASK_NVMCTRL_Pos		2				/**< \brief (PM_APBBMASK)NVMCTRL APBۯՕ */
#define PM_APBBMASK_NVMCTRL			(0x1u << PM_APBBMASK_NVMCTRL_Pos)
#define PM_APBBMASK_PORT_Pos		3				/**< \brief (PM_APBBMASK)PORT APBۯՕ */
#define PM_APBBMASK_PORT			(0x1u << PM_APBBMASK_PORT_Pos)
#define PM_APBBMASK_MASK			0x0000000Fu		/**< \brief (PM_APBBMASK)Օڼ޽ */

/* -------- PM_APBCMASK : (PMψ:0x20) (R/W 32)APBCՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PAC2:1;			/*!< ޯ     0: PAC2 APBۯՕ */
    uint32_t EVSYS:1;			/*!< ޯ     1: EVSYS APBۯՕ */
    uint32_t SERCOM0:1;			/*!< ޯ     2: SERCOM0 APBۯՕ */
    uint32_t SERCOM1:1;			/*!< ޯ     3: SERCOM1 APBۯՕ */
    uint32_t SERCOM2:1;			/*!< ޯ     4: SERCOM2 APBۯՕ */
    uint32_t SERCOM3:1;			/*!< ޯ     5: SERCOM3 APBۯՕ */
    uint32_t SERCOM4:1;			/*!< ޯ     6: SERCOM4 APBۯՕ */
    uint32_t SERCOM5:1;			/*!< ޯ     7: SERCOM5 APBۯՕ */
    uint32_t TC0:1;				/*!< ޯ     8: TC0 APBۯՕ */
    uint32_t TC1:1;				/*!< ޯ     9: TC1 APBۯՕ */
    uint32_t TC2:1;				/*!< ޯ    10: TC2 APBۯՕ */
    uint32_t TC3:1;				/*!< ޯ    11: TC3 APBۯՕ */
    uint32_t TC4:1;				/*!< ޯ    12: TC4 APBۯՕ */
    uint32_t TC5:1;				/*!< ޯ    13: TC5 APBۯՕ */
    uint32_t TC6:1;				/*!< ޯ    14: TC6 APBۯՕ */
    uint32_t TC7:1;				/*!< ޯ    15: TC7 APBۯՕ */
    uint32_t ADC:1;				/*!< ޯ    16: ADC APBۯՕ */
    uint32_t AC:1;				/*!< ޯ    17: AC APBۯՕ */
    uint32_t DAC:1;				/*!< ޯ    18: DAC APBۯՕ */
    uint32_t :13;				/*!< ޯ19`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBCMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBCMASK_OFFSET			0x20			/**< \brief (PM_APBCMASK offset)APBCՕ */
#define PM_APBCMASK_RESETVALUE		0x00010000		/**< \brief (PM_APBCMASK reset_value)APBCՕ */

#define PM_APBCMASK_PAC2_Pos		0				/**< \brief (PM_APBCMASK)PAC2 APBۯՕ */
#define PM_APBCMASK_PAC2			(0x1u << PM_APBCMASK_PAC2_Pos)
#define PM_APBCMASK_EVSYS_Pos		1				/**< \brief (PM_APBCMASK)EVSYS APBۯՕ */
#define PM_APBCMASK_EVSYS			(0x1u << PM_APBCMASK_EVSYS_Pos)
#define PM_APBCMASK_SERCOM0_Pos		2				/**< \brief (PM_APBCMASK)SERCOM0 APBۯՕ */
#define PM_APBCMASK_SERCOM0			(0x1u << PM_APBCMASK_SERCOM0_Pos)
#define PM_APBCMASK_SERCOM1_Pos		3				/**< \brief (PM_APBCMASK)SERCOM1 APBۯՕ */
#define PM_APBCMASK_SERCOM1			(0x1u << PM_APBCMASK_SERCOM1_Pos)
#define PM_APBCMASK_SERCOM2_Pos		4				/**< \brief (PM_APBCMASK)SERCOM2 APBۯՕ */
#define PM_APBCMASK_SERCOM2			(0x1u << PM_APBCMASK_SERCOM2_Pos)
#define PM_APBCMASK_SERCOM3_Pos		5				/**< \brief (PM_APBCMASK)SERCOM3 APBۯՕ */
#define PM_APBCMASK_SERCOM3			(0x1u << PM_APBCMASK_SERCOM3_Pos)
#define PM_APBCMASK_SERCOM4_Pos		6				/**< \brief (PM_APBCMASK)SERCOM4 APBۯՕ */
#define PM_APBCMASK_SERCOM4			(0x1u << PM_APBCMASK_SERCOM4_Pos)
#define PM_APBCMASK_SERCOM5_Pos		7				/**< \brief (PM_APBCMASK)SERCOM5 APBۯՕ */
#define PM_APBCMASK_SERCOM5			(0x1u << PM_APBCMASK_SERCOM5_Pos)
#define PM_APBCMASK_TC0_Pos			8				/**< \brief (PM_APBCMASK)TC0 APBۯՕ */
#define PM_APBCMASK_TC0				(0x1u << PM_APBCMASK_TC0_Pos)
#define PM_APBCMASK_TC1_Pos			9				/**< \brief (PM_APBCMASK)TC1 APBۯՕ */
#define PM_APBCMASK_TC1				(0x1u << PM_APBCMASK_TC1_Pos)
#define PM_APBCMASK_TC2_Pos			10				/**< \brief (PM_APBCMASK)TC2 APBۯՕ */
#define PM_APBCMASK_TC2				(0x1u << PM_APBCMASK_TC2_Pos)
#define PM_APBCMASK_TC3_Pos			11				/**< \brief (PM_APBCMASK)TC3 APBۯՕ */
#define PM_APBCMASK_TC3				(0x1u << PM_APBCMASK_TC3_Pos)
#define PM_APBCMASK_TC4_Pos			12				/**< \brief (PM_APBCMASK)TC4 APBۯՕ */
#define PM_APBCMASK_TC4				(0x1u << PM_APBCMASK_TC4_Pos)
#define PM_APBCMASK_TC5_Pos			13				/**< \brief (PM_APBCMASK)TC5 APBۯՕ */
#define PM_APBCMASK_TC5				(0x1u << PM_APBCMASK_TC5_Pos)
#define PM_APBCMASK_TC6_Pos			14				/**< \brief (PM_APBCMASK)TC6 APBۯՕ */
#define PM_APBCMASK_TC6				(0x1u << PM_APBCMASK_TC6_Pos)
#define PM_APBCMASK_TC7_Pos			15				/**< \brief (PM_APBCMASK)TC7 APBۯՕ */
#define PM_APBCMASK_TC7				(0x1u << PM_APBCMASK_TC7_Pos)
#define PM_APBCMASK_ADC_Pos			16				/**< \brief (PM_APBCMASK)ADC APBۯՕ */
#define PM_APBCMASK_ADC				(0x1u << PM_APBCMASK_ADC_Pos)
#define PM_APBCMASK_AC_Pos			17				/**< \brief (PM_APBCMASK)AC APBۯՕ */
#define PM_APBCMASK_AC				(0x1u << PM_APBCMASK_AC_Pos)
#define PM_APBCMASK_DAC_Pos			18				/**< \brief (PM_APBCMASK)DAC APBۯՕ */
#define PM_APBCMASK_DAC				(0x1u << PM_APBCMASK_DAC_Pos)
#define PM_APBCMASK_MASK			0x0007FFFFu		/**< \brief (PM_APBCMASK)Օڼ޽ */

/* -------- PM_INTENCLR : (PMψ:0x34) (R/W  8)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CKRDY:1;			/*!< ޯ   0: ۯ荞݋ */
    uint8_t  CFD:1;				/*!< ޯ   1: ۯQo */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_INTENCLR_OFFSET			0x34			/**< \brief (PM_INTENCLR offset)荞݋ */
#define PM_INTENCLR_RESETVALUE		0x00			/**< \brief (PM_INTENCLR reset_value)荞݋ */

#define PM_INTENCLR_CKRDY_Pos		0				/**< \brief (PM_INTENCLR)ۯ荞݋ */
#define PM_INTENCLR_CKRDY			(0x1u << PM_INTENCLR_CKRDY_Pos)
#define PM_INTENCLR_CFD_Pos			1				/**< \brief (PM_INTENCLR)ۯQo */
#define PM_INTENCLR_CFD				(0x1u << PM_INTENCLR_CFD_Pos)
#define PM_INTENCLR_MASK			0x03u			/**< \brief (PM_INTENCLR)Օڼ޽ */

/* -------- PM_INTENSET : (PMψ:0x35) (R/W  8)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CKRDY:1;			/*!< ޯ   0: ۯ荞݋ݒ */
    uint8_t  CFD:1;				/*!< ޯ   1: ۯQo荞݋ݒ */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_INTENSET_OFFSET			0x35			/**< \brief (PM_INTENSET offset)荞݋ݒ */
#define PM_INTENSET_RESETVALUE		0x00			/**< \brief (PM_INTENSET reset_value)荞݋ݒ */

#define PM_INTENSET_CKRDY_Pos		0				/**< \brief (PM_INTENSET)ۯ荞݋ݒ */
#define PM_INTENSET_CKRDY			(0x1u << PM_INTENSET_CKRDY_Pos)
#define PM_INTENSET_CFD_Pos			1				/**< \brief (PM_INTENSET)ۯQo荞݋ݒ */
#define PM_INTENSET_CFD				(0x1u << PM_INTENSET_CFD_Pos)
#define PM_INTENSET_MASK			0x03u			/**< \brief (PM_INTENSET)Օڼ޽ */

/* -------- PM_INTFLAG : (PMψ:0x36) (R/W  8)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CKRDY:1;			/*!< ޯ   0: ۯ荞 */
    uint8_t  CFD:1;				/*!< ޯ   1: ۯQo荞 */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_INTFLAG_OFFSET			0x36			/**< \brief (PM_INTFLAG offset)荞׸ޏ/ */
#define PM_INTFLAG_RESETVALUE		0x00			/**< \brief (PM_INTFLAG reset_value)荞׸ޏ/ */

#define PM_INTFLAG_CKRDY_Pos		0				/**< \brief (PM_INTFLAG)ۯ荞 */
#define PM_INTFLAG_CKRDY			(0x1u << PM_INTFLAG_CKRDY_Pos)
#define PM_INTFLAG_CFD_Pos			1				/**< \brief (PM_INTFLAG)ۯQo荞 */
#define PM_INTFLAG_CFD				(0x1u << PM_INTFLAG_CFD_Pos)
#define PM_INTFLAG_MASK				0x03u			/**< \brief (PM_INTFLAG)Օڼ޽ */

/* -------- PM_RCAUSE : (PMψ:0x38) (R/   8)ؾČ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  POR:1;				/*!< ޯ0: dONؾ */
    uint8_t  BOD12:1;			/*!< ޯ1: d12oؾ */
    uint8_t  BOD33:1;			/*!< ޯ2: d33oؾ */
    uint8_t  :1;				/*!< ޯ3: \ */
    uint8_t  EXT:1;				/*!< ޯ4: Oؾ  */
    uint8_t  WDT:1;				/*!< ޯ5: ޯ ؾ */
    uint8_t  SYST:1;			/*!< ޯ6:  ؾėv */
    uint8_t  :1;				/*!< ޯ7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_RCAUSE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_RCAUSE_OFFSET			0x38			/**< \brief (PM_RCAUSE offset)ؾČ */
#define PM_RCAUSE_RESETVALUE		0x01			/**< \brief (PM_RCAUSE reset_value)ؾČ */

#define PM_RCAUSE_POR_Pos			0				/**< \brief (PM_RCAUSE)dONؾ */
#define PM_RCAUSE_POR				(0x1u << PM_RCAUSE_POR_Pos)
#define PM_RCAUSE_BOD12_Pos			1				/**< \brief (PM_RCAUSE)d12oؾ */
#define PM_RCAUSE_BOD12				(0x1u << PM_RCAUSE_BOD12_Pos)
#define PM_RCAUSE_BOD33_Pos			2				/**< \brief (PM_RCAUSE)d33oؾ */
#define PM_RCAUSE_BOD33				(0x1u << PM_RCAUSE_BOD33_Pos)
#define PM_RCAUSE_EXT_Pos			4				/**< \brief (PM_RCAUSE)Oؾ  */
#define PM_RCAUSE_EXT				(0x1u << PM_RCAUSE_EXT_Pos)
#define PM_RCAUSE_WDT_Pos			5				/**< \brief (PM_RCAUSE)ޯ ؾ */
#define PM_RCAUSE_WDT				(0x1u << PM_RCAUSE_WDT_Pos)
#define PM_RCAUSE_SYST_Pos			6				/**< \brief (PM_RCAUSE) ؾėv */
#define PM_RCAUSE_SYST				(0x1u << PM_RCAUSE_SYST_Pos)
#define PM_RCAUSE_MASK				0x77u			/**< \brief (PM_RCAUSE)Օڼ޽ */

/** \brief PMʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO PM_CTRL_Type			CTRL;			/**< \briefψ:0x00 (R/W  8) */
  __IO PM_SLEEP_Type		SLEEP;			/**< \briefψ:0x01 (R/W  8)x~ */
	   RoReg8				Reserved1[0x6];
  __IO PM_CPUSEL_Type		CPUSEL;			/**< \briefψ:0x08 (R/W  8)CPUۯI */
  __IO PM_APBASEL_Type		APBASEL;		/**< \briefψ:0x09 (R/W  8)APBAۯI */
  __IO PM_APBBSEL_Type		APBBSEL;		/**< \briefψ:0x0A (R/W  8)APBBۯI */
  __IO PM_APBCSEL_Type		APBCSEL;		/**< \briefψ:0x0B (R/W  8)APBCۯI */
	   RoReg8				Reserved2[0x8];
  __IO PM_AHBMASK_Type		AHBMASK;		/**< \briefψ:0x14 (R/W 32)AHBՕ */
  __IO PM_APBAMASK_Type		APBAMASK;		/**< \briefψ:0x18 (R/W 32)APBAՕ */
  __IO PM_APBBMASK_Type		APBBMASK;		/**< \briefψ:0x1C (R/W 32)APBBՕ */
  __IO PM_APBCMASK_Type		APBCMASK;		/**< \briefψ:0x20 (R/W 32)APBCՕ */
	   RoReg8				Reserved3[0x10];
  __IO PM_INTENCLR_Type		INTENCLR;		/**< \briefψ:0x34 (R/W  8)荞݋ */
  __IO PM_INTENSET_Type		INTENSET;		/**< \briefψ:0x35 (R/W  8)荞݋ݒ */
  __IO PM_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x36 (R/W  8)荞׸ޏ/ */
	   RoReg8				Reserved4[0x1];
  __I  PM_RCAUSE_Type		RCAUSE;			/**< \briefψ:0x38 (R/   8)ؾČ */
} Pm;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD20_PM_COMPONENT_ */
