/**
 * \file
 *
 * \brief SYSCTRLp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_SYSCTRL_COMPONENT_
#define _SAMD20_SYSCTRL_COMPONENT_

/* ========================================================================== */
/** SYSCTRLpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD20_SYSCTRL ѐ */
/*@{*/

#define REV_SYSCTRL						0x200

/* -------- SYSCTRL_INTENCLR : (SYSCTRLψ:0x00) (R/W 32)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻 */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻 */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33 */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33 */
    uint32_t BOD12RDY:1;		/*!< ޯ    12: BOD12 */
    uint32_t BOD12DET:1;		/*!< ޯ    13: BOD12o */
    uint32_t B12SRDY:1;			/*!< ޯ    14: BOD12 */
    uint32_t :17;				/*!< ޯ15`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_INTENCLR_OFFSET		0x00			/**< \brief (SYSCTRL_INTENCLR offset)荞݋ */
#define SYSCTRL_INTENCLR_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_INTENCLR reset_value)荞݋ */

#define SYSCTRL_INTENCLR_XOSCRDY_Pos	0				/**< \brief (SYSCTRL_INTENCLR)XOSC */
#define SYSCTRL_INTENCLR_XOSCRDY		(0x1u << SYSCTRL_INTENCLR_XOSCRDY_Pos)
#define SYSCTRL_INTENCLR_XOSC32KRDY_Pos	1				/**< \brief (SYSCTRL_INTENCLR)XOSC32K */
#define SYSCTRL_INTENCLR_XOSC32KRDY		(0x1u << SYSCTRL_INTENCLR_XOSC32KRDY_Pos)
#define SYSCTRL_INTENCLR_OSC32KRDY_Pos	2				/**< \brief (SYSCTRL_INTENCLR)OSC32K */
#define SYSCTRL_INTENCLR_OSC32KRDY		(0x1u << SYSCTRL_INTENCLR_OSC32KRDY_Pos)
#define SYSCTRL_INTENCLR_OSC8MRDY_Pos	3				/**< \brief (SYSCTRL_INTENCLR)OSC8M */
#define SYSCTRL_INTENCLR_OSC8MRDY		(0x1u << SYSCTRL_INTENCLR_OSC8MRDY_Pos)
#define SYSCTRL_INTENCLR_DFLLRDY_Pos	4				/**< \brief (SYSCTRL_INTENCLR)DFLL */
#define SYSCTRL_INTENCLR_DFLLRDY		(0x1u << SYSCTRL_INTENCLR_DFLLRDY_Pos)
#define SYSCTRL_INTENCLR_DFLLOOB_Pos	5				/**< \brief (SYSCTRL_INTENCLR)DFLLEO */
#define SYSCTRL_INTENCLR_DFLLOOB		(0x1u << SYSCTRL_INTENCLR_DFLLOOB_Pos)
#define SYSCTRL_INTENCLR_DFLLLCKF_Pos	6				/**< \brief (SYSCTRL_INTENCLR)DFLLŒ艻 */
#define SYSCTRL_INTENCLR_DFLLLCKF		(0x1u << SYSCTRL_INTENCLR_DFLLLCKF_Pos)
#define SYSCTRL_INTENCLR_DFLLLCKC_Pos	7				/**< \brief (SYSCTRL_INTENCLR)DFLLaŒ艻 */
#define SYSCTRL_INTENCLR_DFLLLCKC		(0x1u << SYSCTRL_INTENCLR_DFLLLCKC_Pos)
#define SYSCTRL_INTENCLR_DFLLRCS_Pos	8				/**< \brief (SYSCTRL_INTENCLR)DFLLۯ~ */
#define SYSCTRL_INTENCLR_DFLLRCS		(0x1u << SYSCTRL_INTENCLR_DFLLRCS_Pos)
#define SYSCTRL_INTENCLR_BOD33RDY_Pos	9				/**< \brief (SYSCTRL_INTENCLR)BOD33 */
#define SYSCTRL_INTENCLR_BOD33RDY		(0x1u << SYSCTRL_INTENCLR_BOD33RDY_Pos)
#define SYSCTRL_INTENCLR_BOD33DET_Pos	10				/**< \brief (SYSCTRL_INTENCLR)BOD33o */
#define SYSCTRL_INTENCLR_BOD33DET		(0x1u << SYSCTRL_INTENCLR_BOD33DET_Pos)
#define SYSCTRL_INTENCLR_B33SRDY_Pos	11				/**< \brief (SYSCTRL_INTENCLR)BOD33 */
#define SYSCTRL_INTENCLR_B33SRDY		(0x1u << SYSCTRL_INTENCLR_B33SRDY_Pos)
#define SYSCTRL_INTENCLR_BOD12RDY_Pos	12				/**< \brief (SYSCTRL_INTENCLR)BOD12 */
#define SYSCTRL_INTENCLR_BOD12RDY		(0x1u << SYSCTRL_INTENCLR_BOD12RDY_Pos)
#define SYSCTRL_INTENCLR_BOD12DET_Pos	13				/**< \brief (SYSCTRL_INTENCLR)BOD12o */
#define SYSCTRL_INTENCLR_BOD12DET		(0x1u << SYSCTRL_INTENCLR_BOD12DET_Pos)
#define SYSCTRL_INTENCLR_B12SRDY_Pos	14				/**< \brief (SYSCTRL_INTENCLR)BOD12 */
#define SYSCTRL_INTENCLR_B12SRDY		(0x1u << SYSCTRL_INTENCLR_B12SRDY_Pos)
#define SYSCTRL_INTENCLR_MASK			0x00007FFFu		/**< \brief (SYSCTRL_INTENCLR)Օڼ޽ */

/* -------- SYSCTRL_INTENSET : (SYSCTRLψ:0x04) (R/W 32)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻 */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻 */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33 */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33 */
    uint32_t BOD12RDY:1;		/*!< ޯ    12: BOD12 */
    uint32_t BOD12DET:1;		/*!< ޯ    13: BOD12o */
    uint32_t B12SRDY:1;			/*!< ޯ    14: BOD12 */
    uint32_t :17;				/*!< ޯ15`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_INTENSET_OFFSET			0x04			/**< \brief (SYSCTRL_INTENSET offset)荞݋ݒ */
#define SYSCTRL_INTENSET_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_INTENSET reset_value)荞݋ݒ */

#define SYSCTRL_INTENSET_XOSCRDY_Pos	0				/**< \brief (SYSCTRL_INTENSET)XOSC */
#define SYSCTRL_INTENSET_XOSCRDY		(0x1u << SYSCTRL_INTENSET_XOSCRDY_Pos)
#define SYSCTRL_INTENSET_XOSC32KRDY_Pos	1				/**< \brief (SYSCTRL_INTENSET)XOSC32K */
#define SYSCTRL_INTENSET_XOSC32KRDY		(0x1u << SYSCTRL_INTENSET_XOSC32KRDY_Pos)
#define SYSCTRL_INTENSET_OSC32KRDY_Pos	2				/**< \brief (SYSCTRL_INTENSET)OSC32K */
#define SYSCTRL_INTENSET_OSC32KRDY		(0x1u << SYSCTRL_INTENSET_OSC32KRDY_Pos)
#define SYSCTRL_INTENSET_OSC8MRDY_Pos	3				/**< \brief (SYSCTRL_INTENSET)OSC8M */
#define SYSCTRL_INTENSET_OSC8MRDY		(0x1u << SYSCTRL_INTENSET_OSC8MRDY_Pos)
#define SYSCTRL_INTENSET_DFLLRDY_Pos	4				/**< \brief (SYSCTRL_INTENSET)DFLL */
#define SYSCTRL_INTENSET_DFLLRDY		(0x1u << SYSCTRL_INTENSET_DFLLRDY_Pos)
#define SYSCTRL_INTENSET_DFLLOOB_Pos	5				/**< \brief (SYSCTRL_INTENSET)DFLLEO */
#define SYSCTRL_INTENSET_DFLLOOB		(0x1u << SYSCTRL_INTENSET_DFLLOOB_Pos)
#define SYSCTRL_INTENSET_DFLLLCKF_Pos	6				/**< \brief (SYSCTRL_INTENSET)DFLLŒ艻 */
#define SYSCTRL_INTENSET_DFLLLCKF		(0x1u << SYSCTRL_INTENSET_DFLLLCKF_Pos)
#define SYSCTRL_INTENSET_DFLLLCKC_Pos	7				/**< \brief (SYSCTRL_INTENSET)DFLLaŒ艻 */
#define SYSCTRL_INTENSET_DFLLLCKC		(0x1u << SYSCTRL_INTENSET_DFLLLCKC_Pos)
#define SYSCTRL_INTENSET_DFLLRCS_Pos	8				/**< \brief (SYSCTRL_INTENSET)DFLLۯ~ */
#define SYSCTRL_INTENSET_DFLLRCS		(0x1u << SYSCTRL_INTENSET_DFLLRCS_Pos)
#define SYSCTRL_INTENSET_BOD33RDY_Pos	9				/**< \brief (SYSCTRL_INTENSET)BOD33 */
#define SYSCTRL_INTENSET_BOD33RDY		(0x1u << SYSCTRL_INTENSET_BOD33RDY_Pos)
#define SYSCTRL_INTENSET_BOD33DET_Pos	10				/**< \brief (SYSCTRL_INTENSET)BOD33o */
#define SYSCTRL_INTENSET_BOD33DET		(0x1u << SYSCTRL_INTENSET_BOD33DET_Pos)
#define SYSCTRL_INTENSET_B33SRDY_Pos	11				/**< \brief (SYSCTRL_INTENSET)BOD33 */
#define SYSCTRL_INTENSET_B33SRDY		(0x1u << SYSCTRL_INTENSET_B33SRDY_Pos)
#define SYSCTRL_INTENSET_BOD12RDY_Pos	12				/**< \brief (SYSCTRL_INTENSET)BOD12 */
#define SYSCTRL_INTENSET_BOD12RDY		(0x1u << SYSCTRL_INTENSET_BOD12RDY_Pos)
#define SYSCTRL_INTENSET_BOD12DET_Pos	13				/**< \brief (SYSCTRL_INTENSET)BOD12o */
#define SYSCTRL_INTENSET_BOD12DET		(0x1u << SYSCTRL_INTENSET_BOD12DET_Pos)
#define SYSCTRL_INTENSET_B12SRDY_Pos	14				/**< \brief (SYSCTRL_INTENSET)BOD12 */
#define SYSCTRL_INTENSET_B12SRDY		(0x1u << SYSCTRL_INTENSET_B12SRDY_Pos)
#define SYSCTRL_INTENSET_MASK			0x00007FFFu		/**< \brief (SYSCTRL_INTENSET)Օڼ޽ */

/* -------- SYSCTRL_INTFLAG : (SYSCTRLψ:0x08) (R/W 32)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻 */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻 */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33 */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33 */
    uint32_t BOD12RDY:1;		/*!< ޯ    12: BOD12 */
    uint32_t BOD12DET:1;		/*!< ޯ    13: BOD12o */
    uint32_t B12SRDY:1;			/*!< ޯ    14: BOD12 */
    uint32_t :17;				/*!< ޯ15`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_INTFLAG_OFFSET			0x08			/**< \brief (SYSCTRL_INTFLAG offset)荞׸ޏ/ */
#define SYSCTRL_INTFLAG_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_INTFLAG reset_value)荞׸ޏ/ */

#define SYSCTRL_INTFLAG_XOSCRDY_Pos		0				/**< \brief (SYSCTRL_INTFLAG)XOSC */
#define SYSCTRL_INTFLAG_XOSCRDY		 	(0x1u << SYSCTRL_INTFLAG_XOSCRDY_Pos)
#define SYSCTRL_INTFLAG_XOSC32KRDY_Pos	1				/**< \brief (SYSCTRL_INTFLAG)XOSC32K */
#define SYSCTRL_INTFLAG_XOSC32KRDY		(0x1u << SYSCTRL_INTFLAG_XOSC32KRDY_Pos)
#define SYSCTRL_INTFLAG_OSC32KRDY_Pos	2				/**< \brief (SYSCTRL_INTFLAG)OSC32K */
#define SYSCTRL_INTFLAG_OSC32KRDY		(0x1u << SYSCTRL_INTFLAG_OSC32KRDY_Pos)
#define SYSCTRL_INTFLAG_OSC8MRDY_Pos	3				/**< \brief (SYSCTRL_INTFLAG)OSC8M */
#define SYSCTRL_INTFLAG_OSC8MRDY		(0x1u << SYSCTRL_INTFLAG_OSC8MRDY_Pos)
#define SYSCTRL_INTFLAG_DFLLRDY_Pos		4				/**< \brief (SYSCTRL_INTFLAG)DFLL */
#define SYSCTRL_INTFLAG_DFLLRDY			(0x1u << SYSCTRL_INTFLAG_DFLLRDY_Pos)
#define SYSCTRL_INTFLAG_DFLLOOB_Pos		5				/**< \brief (SYSCTRL_INTFLAG)DFLLEO */
#define SYSCTRL_INTFLAG_DFLLOOB			(0x1u << SYSCTRL_INTFLAG_DFLLOOB_Pos)
#define SYSCTRL_INTFLAG_DFLLLCKF_Pos	6				/**< \brief (SYSCTRL_INTFLAG)DFLLŒ艻 */
#define SYSCTRL_INTFLAG_DFLLLCKF		(0x1u << SYSCTRL_INTFLAG_DFLLLCKF_Pos)
#define SYSCTRL_INTFLAG_DFLLLCKC_Pos	7				/**< \brief (SYSCTRL_INTFLAG)DFLLaŒ艻 */
#define SYSCTRL_INTFLAG_DFLLLCKC		(0x1u << SYSCTRL_INTFLAG_DFLLLCKC_Pos)
#define SYSCTRL_INTFLAG_DFLLRCS_Pos		8				/**< \brief (SYSCTRL_INTFLAG)DFLLۯ~ */
#define SYSCTRL_INTFLAG_DFLLRCS			(0x1u << SYSCTRL_INTFLAG_DFLLRCS_Pos)
#define SYSCTRL_INTFLAG_BOD33RDY_Pos	9				/**< \brief (SYSCTRL_INTFLAG)BOD33 */
#define SYSCTRL_INTFLAG_BOD33RDY		(0x1u << SYSCTRL_INTFLAG_BOD33RDY_Pos)
#define SYSCTRL_INTFLAG_BOD33DET_Pos	10				/**< \brief (SYSCTRL_INTFLAG)BOD33o */
#define SYSCTRL_INTFLAG_BOD33DET		(0x1u << SYSCTRL_INTFLAG_BOD33DET_Pos)
#define SYSCTRL_INTFLAG_B33SRDY_Pos		11				/**< \brief (SYSCTRL_INTFLAG)BOD33 */
#define SYSCTRL_INTFLAG_B33SRDY			(0x1u << SYSCTRL_INTFLAG_B33SRDY_Pos)
#define SYSCTRL_INTFLAG_BOD12RDY_Pos	12				/**< \brief (SYSCTRL_INTFLAG)BOD12 */
#define SYSCTRL_INTFLAG_BOD12RDY		(0x1u << SYSCTRL_INTFLAG_BOD12RDY_Pos)
#define SYSCTRL_INTFLAG_BOD12DET_Pos	13				/**< \brief (SYSCTRL_INTFLAG)BOD12o */
#define SYSCTRL_INTFLAG_BOD12DET		(0x1u << SYSCTRL_INTFLAG_BOD12DET_Pos)
#define SYSCTRL_INTFLAG_B12SRDY_Pos		14				/**< \brief (SYSCTRL_INTFLAG)BOD12 */
#define SYSCTRL_INTFLAG_B12SRDY			(0x1u << SYSCTRL_INTFLAG_B12SRDY_Pos)
#define SYSCTRL_INTFLAG_MASK			0x00007FFFu		/**< \brief (SYSCTRL_INTFLAG)Օڼ޽ */

/* -------- SYSCTRL_PCLKSR : (SYSCTRLψ:0x0C) (R/  32)d͂Ƹۯ̏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t XOSCRDY:1;			/*!< ޯ     0: XOSC */
    uint32_t XOSC32KRDY:1;		/*!< ޯ     1: XOSC32K */
    uint32_t OSC32KRDY:1;		/*!< ޯ     2: OSC32K */
    uint32_t OSC8MRDY:1;		/*!< ޯ     3: OSC8M */
    uint32_t DFLLRDY:1;			/*!< ޯ     4: DFLL */
    uint32_t DFLLOOB:1;			/*!< ޯ     5: DFLLEO */
    uint32_t DFLLLCKF:1;		/*!< ޯ     6: DFLLŒ艻 */
    uint32_t DFLLLCKC:1;		/*!< ޯ     7: DFLLaŒ艻 */
    uint32_t DFLLRCS:1;			/*!< ޯ     8: DFLLۯ~ */
    uint32_t BOD33RDY:1;		/*!< ޯ     9: BOD33 */
    uint32_t BOD33DET:1;		/*!< ޯ    10: BOD33o */
    uint32_t B33SRDY:1;			/*!< ޯ    11: BOD33 */
    uint32_t BOD12RDY:1;		/*!< ޯ    12: BOD12 */
    uint32_t BOD12DET:1;		/*!< ޯ    13: BOD12o */
    uint32_t B12SRDY:1;			/*!< ޯ    14: BOD12 */
    uint32_t :17;				/*!< ޯ15`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_PCLKSR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_PCLKSR_OFFSET			0x0C			/**< \brief (SYSCTRL_PCLKSR offset)d͂Ƹۯ̏ */
#define SYSCTRL_PCLKSR_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_PCLKSR reset_value)d͂Ƹۯ̏ */

#define SYSCTRL_PCLKSR_XOSCRDY_Pos	 	0				/**< \brief (SYSCTRL_PCLKSR)XOSC */
#define SYSCTRL_PCLKSR_XOSCRDY			(0x1u << SYSCTRL_PCLKSR_XOSCRDY_Pos)
#define SYSCTRL_PCLKSR_XOSC32KRDY_Pos	1				/**< \brief (SYSCTRL_PCLKSR)XOSC32K */
#define SYSCTRL_PCLKSR_XOSC32KRDY		(0x1u << SYSCTRL_PCLKSR_XOSC32KRDY_Pos)
#define SYSCTRL_PCLKSR_OSC32KRDY_Pos	2				/**< \brief (SYSCTRL_PCLKSR)OSC32K */
#define SYSCTRL_PCLKSR_OSC32KRDY		(0x1u << SYSCTRL_PCLKSR_OSC32KRDY_Pos)
#define SYSCTRL_PCLKSR_OSC8MRDY_Pos		3				/**< \brief (SYSCTRL_PCLKSR)OSC8M */
#define SYSCTRL_PCLKSR_OSC8MRDY			(0x1u << SYSCTRL_PCLKSR_OSC8MRDY_Pos)
#define SYSCTRL_PCLKSR_DFLLRDY_Pos		4				/**< \brief (SYSCTRL_PCLKSR)DFLL */
#define SYSCTRL_PCLKSR_DFLLRDY			(0x1u << SYSCTRL_PCLKSR_DFLLRDY_Pos)
#define SYSCTRL_PCLKSR_DFLLOOB_Pos		5				/**< \brief (SYSCTRL_PCLKSR)DFLLEO */
#define SYSCTRL_PCLKSR_DFLLOOB			(0x1u << SYSCTRL_PCLKSR_DFLLOOB_Pos)
#define SYSCTRL_PCLKSR_DFLLLCKF_Pos		6				/**< \brief (SYSCTRL_PCLKSR)DFLLŒ艻 */
#define SYSCTRL_PCLKSR_DFLLLCKF			(0x1u << SYSCTRL_PCLKSR_DFLLLCKF_Pos)
#define SYSCTRL_PCLKSR_DFLLLCKC_Pos		7				/**< \brief (SYSCTRL_PCLKSR)DFLLaŒ艻 */
#define SYSCTRL_PCLKSR_DFLLLCKC			(0x1u << SYSCTRL_PCLKSR_DFLLLCKC_Pos)
#define SYSCTRL_PCLKSR_DFLLRCS_Pos		8				/**< \brief (SYSCTRL_PCLKSR)DFLLۯ~ */
#define SYSCTRL_PCLKSR_DFLLRCS			(0x1u << SYSCTRL_PCLKSR_DFLLRCS_Pos)
#define SYSCTRL_PCLKSR_BOD33RDY_Pos		9				/**< \brief (SYSCTRL_PCLKSR)BOD33 */
#define SYSCTRL_PCLKSR_BOD33RDY			(0x1u << SYSCTRL_PCLKSR_BOD33RDY_Pos)
#define SYSCTRL_PCLKSR_BOD33DET_Pos		10				/**< \brief (SYSCTRL_PCLKSR)BOD33o */
#define SYSCTRL_PCLKSR_BOD33DET			(0x1u << SYSCTRL_PCLKSR_BOD33DET_Pos)
#define SYSCTRL_PCLKSR_B33SRDY_Pos		11				/**< \brief (SYSCTRL_PCLKSR)BOD33 */
#define SYSCTRL_PCLKSR_B33SRDY			(0x1u << SYSCTRL_PCLKSR_B33SRDY_Pos)
#define SYSCTRL_PCLKSR_BOD12RDY_Pos		12				/**< \brief (SYSCTRL_PCLKSR)BOD12 */
#define SYSCTRL_PCLKSR_BOD12RDY			(0x1u << SYSCTRL_PCLKSR_BOD12RDY_Pos)
#define SYSCTRL_PCLKSR_BOD12DET_Pos		13				/**< \brief (SYSCTRL_PCLKSR)BOD12o */
#define SYSCTRL_PCLKSR_BOD12DET			(0x1u << SYSCTRL_PCLKSR_BOD12DET_Pos)
#define SYSCTRL_PCLKSR_B12SRDY_Pos		14				/**< \brief (SYSCTRL_PCLKSR)BOD12 */
#define SYSCTRL_PCLKSR_B12SRDY			(0x1u << SYSCTRL_PCLKSR_B12SRDY_Pos)
#define SYSCTRL_PCLKSR_MASK				0x00007FFFu		/**< \brief (SYSCTRL_PCLKSR)Օڼ޽ */

/* -------- SYSCTRL_XOSC : (SYSCTRLψ:0x10) (R/W 16)XOSC -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;				/*!< ޯ     0: \ */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t XTALEN:1;			/*!< ޯ     2: ؽٗpU틖 */
    uint16_t :3;				/*!< ޯ 3` 5: \ */
    uint16_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint16_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint16_t GAIN:3;			/*!< ޯ 8`10: l */
    uint16_t AMPGC:1;			/*!< ޯ    11: U */
    uint16_t STARTUP:4;			/*!< ޯ12`15: n */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_XOSC_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_XOSC_OFFSET				0x10			/**< \brief (SYSCTRL_XOSC offset)XOSC */
#define SYSCTRL_XOSC_RESETVALUE			0x0080			/**< \brief (SYSCTRL_XOSC reset_value)XOSC */

#define SYSCTRL_XOSC_ENABLE_Pos			1				/**< \brief (SYSCTRL_XOSC) */
#define SYSCTRL_XOSC_ENABLE				(0x1u << SYSCTRL_XOSC_ENABLE_Pos)
#define SYSCTRL_XOSC_XTALEN_Pos			2				/**< \brief (SYSCTRL_XOSC)ؽٗpU틖 */
#define SYSCTRL_XOSC_XTALEN				(0x1u << SYSCTRL_XOSC_XTALEN_Pos)
#define SYSCTRL_XOSC_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_XOSC)޲s */
#define SYSCTRL_XOSC_RUNSTDBY			(0x1u << SYSCTRL_XOSC_RUNSTDBY_Pos)
#define SYSCTRL_XOSC_ONDEMAND_Pos		7				/**< \brief (SYSCTRL_XOSC)^ */
#define SYSCTRL_XOSC_ONDEMAND			(0x1u << SYSCTRL_XOSC_ONDEMAND_Pos)
#define SYSCTRL_XOSC_GAIN_Pos			8				/**< \brief (SYSCTRL_XOSC)l */
#define SYSCTRL_XOSC_GAIN_Msk			(0x7u << SYSCTRL_XOSC_GAIN_Pos)
#define SYSCTRL_XOSC_GAIN(value)		((SYSCTRL_XOSC_GAIN_Msk & ((value) << SYSCTRL_XOSC_GAIN_Pos)))
#define SYSCTRL_XOSC_AMPGC_Pos			11				/**< \brief (SYSCTRL_XOSC)U */
#define SYSCTRL_XOSC_AMPGC				(0x1u << SYSCTRL_XOSC_AMPGC_Pos)
#define SYSCTRL_XOSC_STARTUP_Pos		12				/**< \brief (SYSCTRL_XOSC)n */
#define SYSCTRL_XOSC_STARTUP_Msk		(0xFu << SYSCTRL_XOSC_STARTUP_Pos)
#define SYSCTRL_XOSC_STARTUP(value)		((SYSCTRL_XOSC_STARTUP_Msk & ((value) << SYSCTRL_XOSC_STARTUP_Pos)))
#define SYSCTRL_XOSC_MASK				0xFFC6u			/**< \brief (SYSCTRL_XOSC)Օڼ޽ */

/* -------- SYSCTRL_XOSC32K : (SYSCTRLψ:0x14) (R/W 16)XOSC32K -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;				/*!< ޯ     0: \ */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t XTALEN:1;			/*!< ޯ     2: ؽٗpU틖 */
    uint16_t EN32K:1;			/*!< ޯ     3: 32kHzo͋ */
    uint16_t EN1K:1;			/*!< ޯ     4: 1kHzo͋ */
    uint16_t AAMPEN:1;			/*!< ޯ     5: U䋖 */
    uint16_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint16_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint16_t STARTUP:3;			/*!< ޯ 8`10: n */
    uint16_t :1;				/*!< ޯ    11: \ */
    uint16_t WRTLOCK:1;			/*!< ޯ    12: ݎ{ */
    uint16_t :3;				/*!< ޯ13`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_XOSC32K_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_XOSC32K_OFFSET			0x14			/**< \brief (SYSCTRL_XOSC32K offset)XOSC32K */
#define SYSCTRL_XOSC32K_RESETVALUE		0x0080			/**< \brief (SYSCTRL_XOSC32K reset_value)XOSC32K */

#define SYSCTRL_XOSC32K_ENABLE_Pos		1				/**< \brief (SYSCTRL_XOSC32K) */
#define SYSCTRL_XOSC32K_ENABLE			(0x1u << SYSCTRL_XOSC32K_ENABLE_Pos)
#define SYSCTRL_XOSC32K_XTALEN_Pos		2				/**< \brief (SYSCTRL_XOSC32K)ؽٗpU틖 */
#define SYSCTRL_XOSC32K_XTALEN			(0x1u << SYSCTRL_XOSC32K_XTALEN_Pos)
#define SYSCTRL_XOSC32K_EN32K_Pos		3				/**< \brief (SYSCTRL_XOSC32K)32kHzo͋ */
#define SYSCTRL_XOSC32K_EN32K			(0x1u << SYSCTRL_XOSC32K_EN32K_Pos)
#define SYSCTRL_XOSC32K_EN1K_Pos		4				/**< \brief (SYSCTRL_XOSC32K)1kHzo͋ */
#define SYSCTRL_XOSC32K_EN1K			(0x1u << SYSCTRL_XOSC32K_EN1K_Pos)
#define SYSCTRL_XOSC32K_AAMPEN_Pos		5				/**< \brief (SYSCTRL_XOSC32K)U䋖 */
#define SYSCTRL_XOSC32K_AAMPEN			(0x1u << SYSCTRL_XOSC32K_AAMPEN_Pos)
#define SYSCTRL_XOSC32K_RUNSTDBY_Pos	6				/**< \brief (SYSCTRL_XOSC32K)޲s */
#define SYSCTRL_XOSC32K_RUNSTDBY		(0x1u << SYSCTRL_XOSC32K_RUNSTDBY_Pos)
#define SYSCTRL_XOSC32K_ONDEMAND_Pos	7				/**< \brief (SYSCTRL_XOSC32K)^ */
#define SYSCTRL_XOSC32K_ONDEMAND		(0x1u << SYSCTRL_XOSC32K_ONDEMAND_Pos)
#define SYSCTRL_XOSC32K_STARTUP_Pos		8				/**< \brief (SYSCTRL_XOSC32K)n */
#define SYSCTRL_XOSC32K_STARTUP_Msk		(0x7u << SYSCTRL_XOSC32K_STARTUP_Pos)
#define SYSCTRL_XOSC32K_STARTUP(value)	((SYSCTRL_XOSC32K_STARTUP_Msk & ((value) << SYSCTRL_XOSC32K_STARTUP_Pos)))
#define SYSCTRL_XOSC32K_WRTLOCK_Pos		12				/**< \brief (SYSCTRL_XOSC32K)ݎ{ */
#define SYSCTRL_XOSC32K_WRTLOCK			(0x1u << SYSCTRL_XOSC32K_WRTLOCK_Pos)
#define SYSCTRL_XOSC32K_MASK			0x17FEu			/**< \brief (SYSCTRL_XOSC32K)Օڼ޽ */

/* -------- SYSCTRL_OSC32K : (SYSCTRLψ:0x18) (R/W 32)OSC32K -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t EN32K:1;			/*!< ޯ     2: 32kHzo͋ */
    uint32_t EN1K:1;			/*!< ޯ     3: 1kHzo͋ */
    uint32_t :2;				/*!< ޯ 4` 5: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint32_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint32_t STARTUP:3;			/*!< ޯ 8`10: n */
    uint32_t :1;				/*!< ޯ    11: \ */
    uint32_t WRTLOCK:1;			/*!< ޯ    12: ݎ{ */
    uint32_t :3;				/*!< ޯ13`15: \ */
    uint32_t CALIB:7;			/*!< ޯ16`22: Zl */
    uint32_t :9;				/*!< ޯ23`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_OSC32K_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_OSC32K_OFFSET			0x18			/**< \brief (SYSCTRL_OSC32K offset)OSC32K */
#define SYSCTRL_OSC32K_RESETVALUE		0x003F0080		/**< \brief (SYSCTRL_OSC32K reset_value)OSC32K */

#define SYSCTRL_OSC32K_ENABLE_Pos		1				/**< \brief (SYSCTRL_OSC32K) */
#define SYSCTRL_OSC32K_ENABLE			(0x1u << SYSCTRL_OSC32K_ENABLE_Pos)
#define SYSCTRL_OSC32K_EN32K_Pos		2				/**< \brief (SYSCTRL_OSC32K)32kHzo͋ */
#define SYSCTRL_OSC32K_EN32K			(0x1u << SYSCTRL_OSC32K_EN32K_Pos)
#define SYSCTRL_OSC32K_EN1K_Pos			3				/**< \brief (SYSCTRL_OSC32K)1kHzo͋ */
#define SYSCTRL_OSC32K_EN1K				(0x1u << SYSCTRL_OSC32K_EN1K_Pos)
#define SYSCTRL_OSC32K_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_OSC32K)޲s */
#define SYSCTRL_OSC32K_RUNSTDBY			(0x1u << SYSCTRL_OSC32K_RUNSTDBY_Pos)
#define SYSCTRL_OSC32K_ONDEMAND_Pos		7				/**< \brief (SYSCTRL_OSC32K)^ */
#define SYSCTRL_OSC32K_ONDEMAND			(0x1u << SYSCTRL_OSC32K_ONDEMAND_Pos)
#define SYSCTRL_OSC32K_STARTUP_Pos		8				/**< \brief (SYSCTRL_OSC32K)n */
#define SYSCTRL_OSC32K_STARTUP_Msk		(0x7u << SYSCTRL_OSC32K_STARTUP_Pos)
#define SYSCTRL_OSC32K_STARTUP(value)	((SYSCTRL_OSC32K_STARTUP_Msk & ((value) << SYSCTRL_OSC32K_STARTUP_Pos)))
#define SYSCTRL_OSC32K_WRTLOCK_Pos		12				/**< \brief (SYSCTRL_OSC32K)ݎ{ */
#define SYSCTRL_OSC32K_WRTLOCK			(0x1u << SYSCTRL_OSC32K_WRTLOCK_Pos)
#define SYSCTRL_OSC32K_CALIB_Pos		16				/**< \brief (SYSCTRL_OSC32K)Zl */
#define SYSCTRL_OSC32K_CALIB_Msk		(0x7Fu << SYSCTRL_OSC32K_CALIB_Pos)
#define SYSCTRL_OSC32K_CALIB(value)		((SYSCTRL_OSC32K_CALIB_Msk & ((value) << SYSCTRL_OSC32K_CALIB_Pos)))
#define SYSCTRL_OSC32K_MASK				0x007F17CEu		/**< \brief (SYSCTRL_OSC32K)Օڼ޽ */

/* -------- SYSCTRL_OSCULP32K : (SYSCTRLψ:0x1C) (R/W  8)OSCULP32K -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CALIB:5;			/*!< ޯ0`4: Zl */
    uint8_t  :2;				/*!< ޯ5`6: \ */
    uint8_t  WRTLOCK:1;			/*!< ޯ   7: ݎ{ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_OSCULP32K_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_OSCULP32K_OFFSET		0x1C			/**< \brief (SYSCTRL_OSCULP32K offset)OSCULP32K */
#define SYSCTRL_OSCULP32K_RESETVALUE	0x0F			/**< \brief (SYSCTRL_OSCULP32K reset_value)OSCULP32K */

#define SYSCTRL_OSCULP32K_CALIB_Pos		0				/**< \brief (SYSCTRL_OSCULP32K)Zl */
#define SYSCTRL_OSCULP32K_CALIB_Msk		(0x1Fu << SYSCTRL_OSCULP32K_CALIB_Pos)
#define SYSCTRL_OSCULP32K_CALIB(value)	((SYSCTRL_OSCULP32K_CALIB_Msk & ((value) << SYSCTRL_OSCULP32K_CALIB_Pos)))
#define SYSCTRL_OSCULP32K_WRTLOCK_Pos	7				/**< \brief (SYSCTRL_OSCULP32K)ݎ{ */
#define SYSCTRL_OSCULP32K_WRTLOCK		(0x1u << SYSCTRL_OSCULP32K_WRTLOCK_Pos)
#define SYSCTRL_OSCULP32K_MASK			0x9Fu			/**< \brief (SYSCTRL_OSCULP32K)Օڼ޽ */

/* -------- SYSCTRL_OSC8M : (SYSCTRLψ:0x20) (R/W 32)OSC8MA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t :4;				/*!< ޯ 2` 5: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint32_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint32_t PRESC:2;			/*!< ޯ 8` 9: OuI */
    uint32_t :6;				/*!< ޯ10`15: \ */
    uint32_t CALIB:12;			/*!< ޯ16`27: Zl */
    uint32_t :2;				/*!< ޯ28`29: \ */
    uint32_t FRANGE:2;			/*!< ޯ30`31: g͈ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_OSC8M_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_OSC8M_OFFSET			0x20			/**< \brief (SYSCTRL_OSC8M offset)OSC8MA */
#define SYSCTRL_OSC8M_RESETVALUE		0x00000080		/**< \brief (SYSCTRL_OSC8M reset_value)OSC8MA */

#define SYSCTRL_OSC8M_ENABLE_Pos		1				/**< \brief (SYSCTRL_OSC8M) */
#define SYSCTRL_OSC8M_ENABLE			(0x1u << SYSCTRL_OSC8M_ENABLE_Pos)
#define SYSCTRL_OSC8M_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_OSC8M)޲s */
#define SYSCTRL_OSC8M_RUNSTDBY			(0x1u << SYSCTRL_OSC8M_RUNSTDBY_Pos)
#define SYSCTRL_OSC8M_ONDEMAND_Pos		7				/**< \brief (SYSCTRL_OSC8M)^ */
#define SYSCTRL_OSC8M_ONDEMAND			(0x1u << SYSCTRL_OSC8M_ONDEMAND_Pos)
#define SYSCTRL_OSC8M_PRESC_Pos			8				/**< \brief (SYSCTRL_OSC8M)OuI */
#define SYSCTRL_OSC8M_PRESC_Msk			(0x3u << SYSCTRL_OSC8M_PRESC_Pos)
#define SYSCTRL_OSC8M_PRESC(value)		((SYSCTRL_OSC8M_PRESC_Msk & ((value) << SYSCTRL_OSC8M_PRESC_Pos)))
#define SYSCTRL_OSC8M_CALIB_Pos			16				/**< \brief (SYSCTRL_OSC8M)Zl */
#define SYSCTRL_OSC8M_CALIB_Msk			(0xFFFu << SYSCTRL_OSC8M_CALIB_Pos)
#define SYSCTRL_OSC8M_CALIB(value)		((SYSCTRL_OSC8M_CALIB_Msk & ((value) << SYSCTRL_OSC8M_CALIB_Pos)))
#define SYSCTRL_OSC8M_FRANGE_Pos		30				/**< \brief (SYSCTRL_OSC8M)g͈ */
#define SYSCTRL_OSC8M_FRANGE_Msk		(0x3u << SYSCTRL_OSC8M_FRANGE_Pos)
#define SYSCTRL_OSC8M_FRANGE(value)		((SYSCTRL_OSC8M_FRANGE_Msk & ((value) << SYSCTRL_OSC8M_FRANGE_Pos)))
#define SYSCTRL_OSC8M_MASK				0xCFFF03C2u		/**< \brief (SYSCTRL_OSC8M)Օڼ޽ */

/* -------- SYSCTRL_DFLLCTRL : (SYSCTRLψ:0x24) (R/W 16)DFLL`Ԑݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;				/*!< ޯ     0: \ */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t MODE:1;			/*!< ޯ     2: I */
    uint16_t STABLE:1;			/*!< ޯ     3: g */
    uint16_t LLAW:1;			/*!< ޯ     4: NŒ艻 */
    uint16_t USBCRM:1;			/*!< ޯ     5: USBۯ */
    uint16_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint16_t ONDEMAND:1;		/*!< ޯ     7: ^ */
    uint16_t CCDIS:1;			/*!< ޯ     8: p֎~ */
    uint16_t QLDIS:1;			/*!< ޯ     9: vŒ艻֎~ */
    uint16_t :6;				/*!< ޯ10`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLCTRL_OFFSET			0x24			/**< \brief (SYSCTRL_DFLLCTRL offset)DFLL`Ԑݒ */
#define SYSCTRL_DFLLCTRL_RESETVALUE		0x0080			/**< \brief (SYSCTRL_DFLLCTRL reset_value)DFLL`Ԑݒ */

#define SYSCTRL_DFLLCTRL_ENABLE_Pos		1				/**< \brief (SYSCTRL_DFLLCTRL) */
#define SYSCTRL_DFLLCTRL_ENABLE			(0x1u << SYSCTRL_DFLLCTRL_ENABLE_Pos)
#define SYSCTRL_DFLLCTRL_MODE_Pos		2				/**< \brief (SYSCTRL_DFLLCTRL)I */
#define SYSCTRL_DFLLCTRL_MODE			(0x1u << SYSCTRL_DFLLCTRL_MODE_Pos)
#define SYSCTRL_DFLLCTRL_STABLE_Pos		3				/**< \brief (SYSCTRL_DFLLCTRL)g */
#define SYSCTRL_DFLLCTRL_STABLE			(0x1u << SYSCTRL_DFLLCTRL_STABLE_Pos)
#define SYSCTRL_DFLLCTRL_LLAW_Pos		4				/**< \brief (SYSCTRL_DFLLCTRL)NŒ艻*/
#define SYSCTRL_DFLLCTRL_LLAW			(0x1u << SYSCTRL_DFLLCTRL_LLAW_Pos)
#define SYSCTRL_DFLLCTRL_USBCRM_Pos		5				/**< \brief (SYSCTRL_DFLLCTRL)USBۯ */
#define SYSCTRL_DFLLCTRL_USBCRM			(0x1u << SYSCTRL_DFLLCTRL_USBCRM_Pos)
#define SYSCTRL_DFLLCTRL_RUNSTDBY_Pos	6				/**< \brief (SYSCTRL_DFLLCTRL)޲s */
#define SYSCTRL_DFLLCTRL_RUNSTDBY		(0x1u << SYSCTRL_DFLLCTRL_RUNSTDBY_Pos)
#define SYSCTRL_DFLLCTRL_ONDEMAND_Pos	7				/**< \brief (SYSCTRL_DFLLCTRL)^ */
#define SYSCTRL_DFLLCTRL_ONDEMAND		(0x1u << SYSCTRL_DFLLCTRL_ONDEMAND_Pos)
#define SYSCTRL_DFLLCTRL_CCDIS_Pos		8				/**< \brief (SYSCTRL_DFLLCTRL)p֎~ */
#define SYSCTRL_DFLLCTRL_CCDIS			(0x1u << SYSCTRL_DFLLCTRL_CCDIS_Pos)
#define SYSCTRL_DFLLCTRL_QLDIS_Pos		9				/**< \brief (SYSCTRL_DFLLCTRL)vŒ艻֎~ */
#define SYSCTRL_DFLLCTRL_QLDIS			(0x1u << SYSCTRL_DFLLCTRL_QLDIS_Pos)
#define SYSCTRL_DFLLCTRL_MASK			0x03FEu			/**< \brief (SYSCTRL_DFLLCTRL)Օڼ޽ */

/* -------- SYSCTRL_DFLLVAL : (SYSCTRLψ:0x28) (R/W 32)DFLLZl -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t FINE:8;			/*!< ޯ 0` 7: Zl */
    uint32_t COARSE:5;			/*!< ޯ 8`12: aZl */
    uint32_t :3;				/*!< ޯ13`15: \ */
    uint32_t DIFF:16;			/*!< ޯ16`31: { */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLVAL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLVAL_OFFSET			0x28			/**< \brief (SYSCTRL_DFLLVAL offset)DFLLZl */
#define SYSCTRL_DFLLVAL_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_DFLLVAL reset_value)DFLLZl */

#define SYSCTRL_DFLLVAL_FINE_Pos		0				/**< \brief (SYSCTRL_DFLLVAL)Zl */
#define SYSCTRL_DFLLVAL_FINE_Msk		(0xFFu << SYSCTRL_DFLLVAL_FINE_Pos)
#define SYSCTRL_DFLLVAL_FINE(value)		((SYSCTRL_DFLLVAL_FINE_Msk & ((value) << SYSCTRL_DFLLVAL_FINE_Pos)))
#define SYSCTRL_DFLLVAL_COARSE_Pos		8				/**< \brief (SYSCTRL_DFLLVAL)aZl */
#define SYSCTRL_DFLLVAL_COARSE_Msk		(0x1Fu << SYSCTRL_DFLLVAL_COARSE_Pos)
#define SYSCTRL_DFLLVAL_COARSE(value)	((SYSCTRL_DFLLVAL_COARSE_Msk & ((value) << SYSCTRL_DFLLVAL_COARSE_Pos)))
#define SYSCTRL_DFLLVAL_DIFF_Pos		16				/**< \brief (SYSCTRL_DFLLVAL){ */
#define SYSCTRL_DFLLVAL_DIFF_Msk		(0xFFFFu << SYSCTRL_DFLLVAL_DIFF_Pos)
#define SYSCTRL_DFLLVAL_DIFF(value)		((SYSCTRL_DFLLVAL_DIFF_Msk & ((value) << SYSCTRL_DFLLVAL_DIFF_Pos)))
#define SYSCTRL_DFLLVAL_MASK			0xFFFF1FFFu		/**< \brief (SYSCTRL_DFLLVAL)Օڼ޽ */

/* -------- SYSCTRL_DFLLMUL : (SYSCTRLψ:0x2C) (R/W 32)DFLL{ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t MUL:16;			/*!< ޯ 0`15: {l */
    uint32_t FSTEP:8;			/*!< ޯ16`23: őiK */
    uint32_t CSTEP:5;			/*!< ޯ24`28: őaiK */
    uint32_t :3;				/*!< ޯ29`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLMUL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLMUL_OFFSET			0x2C			/**< \brief (SYSCTRL_DFLLMUL offset)DFLL{ */
#define SYSCTRL_DFLLMUL_RESETVALUE		0x00000000		/**< \brief (SYSCTRL_DFLLMUL reset_value)DFLL{ */

#define SYSCTRL_DFLLMUL_MUL_Pos			0				/**< \brief (SYSCTRL_DFLLMUL){l */
#define SYSCTRL_DFLLMUL_MUL_Msk			(0xFFFFu << SYSCTRL_DFLLMUL_MUL_Pos)
#define SYSCTRL_DFLLMUL_MUL(value)		((SYSCTRL_DFLLMUL_MUL_Msk & ((value) << SYSCTRL_DFLLMUL_MUL_Pos)))
#define SYSCTRL_DFLLMUL_FSTEP_Pos		16				/**< \brief (SYSCTRL_DFLLMUL)őiK */
#define SYSCTRL_DFLLMUL_FSTEP_Msk		(0xFFu << SYSCTRL_DFLLMUL_FSTEP_Pos)
#define SYSCTRL_DFLLMUL_FSTEP(value)	((SYSCTRL_DFLLMUL_FSTEP_Msk & ((value) << SYSCTRL_DFLLMUL_FSTEP_Pos)))
#define SYSCTRL_DFLLMUL_CSTEP_Pos		24				/**< \brief (SYSCTRL_DFLLMUL)őaiK */
#define SYSCTRL_DFLLMUL_CSTEP_Msk		(0x1Fu << SYSCTRL_DFLLMUL_CSTEP_Pos)
#define SYSCTRL_DFLLMUL_CSTEP(value)	((SYSCTRL_DFLLMUL_CSTEP_Msk & ((value) << SYSCTRL_DFLLMUL_CSTEP_Pos)))
#define SYSCTRL_DFLLMUL_MASK			0x1FFFFFFFu		/**< \brief (SYSCTRL_DFLLMUL)Օڼ޽ */

/* -------- SYSCTRL_DFLLSYNC : (SYSCTRLψ:0x30) (R/W  8)DFLL -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :7;				/*!< ޯ0`6: \ */
    uint8_t  READREQ:1;			/*!< ޯ   7: ǂݍݗv */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_DFLLSYNC_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_DFLLSYNC_OFFSET			0x30			/**< \brief (SYSCTRL_DFLLSYNC offset)DFLL */
#define SYSCTRL_DFLLSYNC_RESETVALUE		0x00			/**< \brief (SYSCTRL_DFLLSYNC reset_value)DFLL */

#define SYSCTRL_DFLLSYNC_READREQ_Pos	7				/**< \brief (SYSCTRL_DFLLSYNC)ǂݍݗv */
#define SYSCTRL_DFLLSYNC_READREQ		(0x1u << SYSCTRL_DFLLSYNC_READREQ_Pos)
#define SYSCTRL_DFLLSYNC_MASK			0x80u			/**< \brief (SYSCTRL_DFLLSYNC)Օڼ޽ */

/* -------- SYSCTRL_BOD33 : (SYSCTRLψ:0x34) (R/W 32)BOD33 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t HYST:1;			/*!< ޯ     2: ˽ؼ */
    uint32_t ACTION:2;			/*!< ޯ 3` 4: 臒l̊ */
    uint32_t :1;				/*!< ޯ     5: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint32_t :1;				/*!< ޯ     7: \ */
    uint32_t MODE:1;			/*!< ޯ     8: ` */
    uint32_t CEN:1;				/*!< ޯ     9: ۯ */
    uint32_t :2;				/*!< ޯ10`11: \ */
    uint32_t PSEL:4;			/*!< ޯ12`15: OuI */
    uint32_t LEVEL:6;			/*!< ޯ16`21: 臒l */
    uint32_t :10;				/*!< ޯ22`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_BOD33_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_BOD33_OFFSET			0x34			/**< \brief (SYSCTRL_BOD33 offset)BOD33 */

#define SYSCTRL_BOD33_ENABLE_Pos		1				/**< \brief (SYSCTRL_BOD33) */
#define SYSCTRL_BOD33_ENABLE			(0x1u << SYSCTRL_BOD33_ENABLE_Pos)
#define SYSCTRL_BOD33_HYST_Pos			2				/**< \brief (SYSCTRL_BOD33)˽ؼ */
#define SYSCTRL_BOD33_HYST				(0x1u << SYSCTRL_BOD33_HYST_Pos)
#define SYSCTRL_BOD33_ACTION_Pos		3				/**< \brief (SYSCTRL_BOD33)臒l̊ */
#define SYSCTRL_BOD33_ACTION_Msk		(0x3u << SYSCTRL_BOD33_ACTION_Pos)
#define SYSCTRL_BOD33_ACTION(value)		((SYSCTRL_BOD33_ACTION_Msk & ((value) << SYSCTRL_BOD33_ACTION_Pos)))
#define SYSCTRL_BOD33_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_BOD33)޲s */
#define SYSCTRL_BOD33_RUNSTDBY			(0x1u << SYSCTRL_BOD33_RUNSTDBY_Pos)
#define SYSCTRL_BOD33_MODE_Pos			8				/**< \brief (SYSCTRL_BOD33)` */
#define SYSCTRL_BOD33_MODE				(0x1u << SYSCTRL_BOD33_MODE_Pos)
#define SYSCTRL_BOD33_CEN_Pos			9				/**< \brief (SYSCTRL_BOD33)ۯ */
#define SYSCTRL_BOD33_CEN				(0x1u << SYSCTRL_BOD33_CEN_Pos)
#define SYSCTRL_BOD33_PSEL_Pos			12				/**< \brief (SYSCTRL_BOD33)OuI */
#define SYSCTRL_BOD33_PSEL_Msk			(0xFu << SYSCTRL_BOD33_PSEL_Pos)
#define SYSCTRL_BOD33_PSEL(value)		((SYSCTRL_BOD33_PSEL_Msk & ((value) << SYSCTRL_BOD33_PSEL_Pos)))
#define SYSCTRL_BOD33_LEVEL_Pos			16				/**< \brief (SYSCTRL_BOD33)臒l */
#define SYSCTRL_BOD33_LEVEL_Msk			(0x3Fu << SYSCTRL_BOD33_LEVEL_Pos)
#define SYSCTRL_BOD33_LEVEL(value)		((SYSCTRL_BOD33_LEVEL_Msk & ((value) << SYSCTRL_BOD33_LEVEL_Pos)))
#define SYSCTRL_BOD33_MASK				0x003FF35Eu		/**< \brief (SYSCTRL_BOD33)Օڼ޽ */

/* -------- SYSCTRL_BOD12 : (SYSCTRLψ:0x38) (R/W 32)BOD12 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t ENABLE:1;			/*!< ޯ     1:  */
    uint32_t HYST:1;			/*!< ޯ     2: ˽ؼ */
    uint32_t ACTION:2;			/*!< ޯ 3` 4: 臒l̊ */
    uint32_t :1;				/*!< ޯ     5: \ */
    uint32_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint32_t :1;				/*!< ޯ     7: \ */
    uint32_t MODE:1;			/*!< ޯ     8: ` */
    uint32_t CEN:1;				/*!< ޯ     9: ۯ */
    uint32_t :2;				/*!< ޯ10`11: \ */
    uint32_t PSEL:4;			/*!< ޯ12`15: OuI */
    uint32_t LEVEL:5;			/*!< ޯ16`20: 臒l */
    uint32_t :11;				/*!< ޯ21`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_BOD12_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_BOD12_OFFSET			0x38			/**< \brief (SYSCTRL_BOD12 offset)BOD12 */

#define SYSCTRL_BOD12_ENABLE_Pos		1				/**< \brief (SYSCTRL_BOD12) */
#define SYSCTRL_BOD12_ENABLE			(0x1u << SYSCTRL_BOD12_ENABLE_Pos)
#define SYSCTRL_BOD12_HYST_Pos			2				/**< \brief (SYSCTRL_BOD12)˽ؼ */
#define SYSCTRL_BOD12_HYST				(0x1u << SYSCTRL_BOD12_HYST_Pos)
#define SYSCTRL_BOD12_ACTION_Pos		3				/**< \brief (SYSCTRL_BOD12)臒l̊ */
#define SYSCTRL_BOD12_ACTION_Msk		(0x3u << SYSCTRL_BOD12_ACTION_Pos)
#define SYSCTRL_BOD12_ACTION(value)		((SYSCTRL_BOD12_ACTION_Msk & ((value) << SYSCTRL_BOD12_ACTION_Pos)))
#define SYSCTRL_BOD12_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_BOD12)޲s */
#define SYSCTRL_BOD12_RUNSTDBY			(0x1u << SYSCTRL_BOD12_RUNSTDBY_Pos)
#define SYSCTRL_BOD12_MODE_Pos			8				/**< \brief (SYSCTRL_BOD12)` */
#define SYSCTRL_BOD12_MODE				(0x1u << SYSCTRL_BOD12_MODE_Pos)
#define SYSCTRL_BOD12_CEN_Pos			9				/**< \brief (SYSCTRL_BOD12)ۯ */
#define SYSCTRL_BOD12_CEN				(0x1u << SYSCTRL_BOD12_CEN_Pos)
#define SYSCTRL_BOD12_PSEL_Pos			12				/**< \brief (SYSCTRL_BOD12)OuI */
#define SYSCTRL_BOD12_PSEL_Msk			(0xFu << SYSCTRL_BOD12_PSEL_Pos)
#define SYSCTRL_BOD12_PSEL(value)		((SYSCTRL_BOD12_PSEL_Msk & ((value) << SYSCTRL_BOD12_PSEL_Pos)))
#define SYSCTRL_BOD12_LEVEL_Pos			16				/**< \brief (SYSCTRL_BOD12)臒l */
#define SYSCTRL_BOD12_LEVEL_Msk			(0x1Fu << SYSCTRL_BOD12_LEVEL_Pos)
#define SYSCTRL_BOD12_LEVEL(value)		((SYSCTRL_BOD12_LEVEL_Msk & ((value) << SYSCTRL_BOD12_LEVEL_Pos)))
#define SYSCTRL_BOD12_MASK				0x001FF35Eu		/**< \brief (SYSCTRL_BOD12)Օڼ޽ */

/* -------- SYSCTRL_VREG : (SYSCTRLψ:0x3C) (R/W 16)VREG -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t :1;				/*!< ޯ     0: \ */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t :2;				/*!< ޯ 2` 3: \ */
    uint16_t VDDMON:2;			/*!< ޯ 4` 5: jQłؾċ */
    uint16_t RUNSTDBY:1;		/*!< ޯ     6: ޲s */
    uint16_t :1;				/*!< ޯ     7: \ */
    uint16_t LEVEL:3;			/*!< ޯ 8`10: o͓d */
    uint16_t :1;				/*!< ޯ    11: \ */
    uint16_t CALIB:3;			/*!< ޯ12`14: Zl */
    uint16_t :1;				/*!< ޯ    15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_VREG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_VREG_OFFSET				0x3C			/**< \brief (SYSCTRL_VREG offset)VREG */
#define SYSCTRL_VREG_RESETVALUE			0x0000			/**< \brief (SYSCTRL_VREG reset_value)VREG */

#define SYSCTRL_VREG_ENABLE_Pos			1				/**< \brief (SYSCTRL_VREG) */
#define SYSCTRL_VREG_ENABLE				(0x1u << SYSCTRL_VREG_ENABLE_Pos)
#define SYSCTRL_VREG_VDDMON_Pos			4				/**< \brief (SYSCTRL_VREG)jQłؾċ */
#define SYSCTRL_VREG_VDDMON_Msk			(0x3u << SYSCTRL_VREG_VDDMON_Pos)
#define SYSCTRL_VREG_VDDMON(value)		((SYSCTRL_VREG_VDDMON_Msk & ((value) << SYSCTRL_VREG_VDDMON_Pos)))
#define SYSCTRL_VREG_RUNSTDBY_Pos		6				/**< \brief (SYSCTRL_VREG)޲s */
#define SYSCTRL_VREG_RUNSTDBY			(0x1u << SYSCTRL_VREG_RUNSTDBY_Pos)
#define SYSCTRL_VREG_LEVEL_Pos			8				/**< \brief (SYSCTRL_VREG)o͓d */
#define SYSCTRL_VREG_LEVEL_Msk			(0x7u << SYSCTRL_VREG_LEVEL_Pos)
#define SYSCTRL_VREG_LEVEL(value)		((SYSCTRL_VREG_LEVEL_Msk & ((value) << SYSCTRL_VREG_LEVEL_Pos)))
#define SYSCTRL_VREG_CALIB_Pos			12				/**< \brief (SYSCTRL_VREG)Zl */
#define SYSCTRL_VREG_CALIB_Msk			(0x7u << SYSCTRL_VREG_CALIB_Pos)
#define SYSCTRL_VREG_CALIB(value)		((SYSCTRL_VREG_CALIB_Msk & ((value) << SYSCTRL_VREG_CALIB_Pos)))
#define SYSCTRL_VREG_MASK				0x7772u			/**< \brief (SYSCTRL_VREG)Օڼ޽ */

/* -------- SYSCTRL_VREF : (SYSCTRLψ:0x40) (R/W 32)VREFA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :1;				/*!< ޯ     0: \ */
    uint32_t TSEN:1;			/*!< ޯ     1: xmo͋   */
    uint32_t BGOUTEN:1;			/*!< ޯ     2: ޷ެߏo͋ */
    uint32_t :13;				/*!< ޯ 3`15: \ */
    uint32_t CALIB:11;			/*!< ޯ16`26: dZl */
    uint32_t :5;				/*!< ޯ27`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} SYSCTRL_VREF_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define SYSCTRL_VREF_OFFSET				0x40			/**< \brief (SYSCTRL_VREF offset)VREFA */
#define SYSCTRL_VREF_RESETVALUE			0x00000000		/**< \brief (SYSCTRL_VREF reset_value)VREFA */

#define SYSCTRL_VREF_TSEN_Pos			1				/**< \brief (SYSCTRL_VREF)xmo͋ */
#define SYSCTRL_VREF_TSEN				(0x1u << SYSCTRL_VREF_TSEN_Pos)
#define SYSCTRL_VREF_BGOUTEN_Pos		2				/**< \brief (SYSCTRL_VREF)޷ެߏo͋ */
#define SYSCTRL_VREF_BGOUTEN			(0x1u << SYSCTRL_VREF_BGOUTEN_Pos)
#define SYSCTRL_VREF_CALIB_Pos			16				/**< \brief (SYSCTRL_VREF)dZl */
#define SYSCTRL_VREF_CALIB_Msk			(0x7FFu << SYSCTRL_VREF_CALIB_Pos)
#define SYSCTRL_VREF_CALIB(value)		((SYSCTRL_VREF_CALIB_Msk & ((value) << SYSCTRL_VREF_CALIB_Pos)))
#define SYSCTRL_VREF_MASK				0x07FF0006u		/**< \brief (SYSCTRL_VREF)Օڼ޽ */

/** \brief SYSCTRLʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO SYSCTRL_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x00 (R/W 32)荞݋ */
  __IO SYSCTRL_INTENSET_Type	INTENSET;		/**< \briefψ:0x04 (R/W 32)荞݋ݒ */
  __IO SYSCTRL_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x08 (R/W 32)荞׸ޏ/ */
  __I  SYSCTRL_PCLKSR_Type		PCLKSR;			/**< \briefψ:0x0C (R/  32)d͂Ƹۯ̏ */
  __IO SYSCTRL_XOSC_Type		XOSC;			/**< \briefψ:0x10 (R/W 16)XOSC */
	   RoReg8					Reserved1[0x2];
  __IO SYSCTRL_XOSC32K_Type		XOSC32K;		/**< \briefψ:0x14 (R/W 16)XOSC32K */
	   RoReg8					Reserved2[0x2];
  __IO SYSCTRL_OSC32K_Type		OSC32K;			/**< \briefψ:0x18 (R/W 32)OSC32K */
  __IO SYSCTRL_OSCULP32K_Type	OSCULP32K;		/**< \briefψ:0x1C (R/W  8)OSCULP32K */
	   RoReg8					Reserved3[0x3];
  __IO SYSCTRL_OSC8M_Type		OSC8M;			/**< \briefψ:0x20 (R/W 32)OSC8MA */
  __IO SYSCTRL_DFLLCTRL_Type	DFLLCTRL;		/**< \briefψ:0x24 (R/W 16)DFLL`Ԑݒ */
	   RoReg8					Reserved4[0x2];
  __IO SYSCTRL_DFLLVAL_Type		DFLLVAL;		/**< \briefψ:0x28 (R/W 32)DFLLZl */
  __IO SYSCTRL_DFLLMUL_Type		DFLLMUL;		/**< \briefψ:0x2C (R/W 32)DFLL{ */
  __IO SYSCTRL_DFLLSYNC_Type	DFLLSYNC;		/**< \briefψ:0x30 (R/W  8)DFLL */
	   RoReg8					Reserved5[0x3];
  __IO SYSCTRL_BOD33_Type		BOD33;			/**< \briefψ:0x34 (R/W 32)BOD33 */
  __IO SYSCTRL_BOD12_Type		BOD12;			/**< \briefψ:0x38 (R/W 32)BOD12 */
  __IO SYSCTRL_VREG_Type		VREG;			/**< \briefψ:0x3C (R/W 16)VREG */
	   RoReg8					Reserved6[0x2];
  __IO SYSCTRL_VREF_Type		VREF;			/**< \briefψ:0x40 (R/W 32)VREFA */
} Sysctrl;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD20_SYSCTRL_COMPONENT_ */
