/**
 * \file
 *
 * \brief WDTp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_WDT_COMPONENT_
#define _SAMD20_WDT_COMPONENT_

/* ========================================================================== */
/** WDTpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD20_WDT ޯތv */
/*@{*/

#define REV_WDT						0x200

/* -------- WDT_CTRL : (WDTψ:0x0) (R/W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :1;				/*!< ޯ   0: \ */
    uint8_t  ENABLE:1;			/*!< ޯ   1:  */
    uint8_t  WEN:1;				/*!< ޯ   2: ޯތv푋싖 */
    uint8_t  :4;				/*!< ޯ3`6: \ */
    uint8_t  ALWAYSON:1;		/*!< ޯ   7: ޯތvON */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_CTRL_OFFSET				0x0				/**< \brief (WDT_CTRL offset) */
#define WDT_CTRL_RESETVALUE			0x00			/**< \brief (WDT_CTRL reset_value) */

#define WDT_CTRL_ENABLE_Pos			1				/**< \brief (WDT_CTRL) */
#define WDT_CTRL_ENABLE				(0x1u << WDT_CTRL_ENABLE_Pos)
#define WDT_CTRL_WEN_Pos			2				/**< \brief (WDT_CTRL)ޯތv푋싖 */
#define WDT_CTRL_WEN				(0x1u << WDT_CTRL_WEN_Pos)
#define WDT_CTRL_ALWAYSON_Pos		7				/**< \brief (WDT_CTRL)ޯތvON */
#define WDT_CTRL_ALWAYSON			(0x1u << WDT_CTRL_ALWAYSON_Pos)
#define WDT_CTRL_MASK				0x86u			/**< \brief (WDT_CTRL)Օڼ޽ */

/* -------- WDT_CONFIG : (WDTψ:0x1) (R/W  8)`Ԑݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  PER:4;				/*!< ޯ0`3: Ԏ */
    uint8_t  WINDOW:4;			/*!< ޯ4`7: ޯތv푋Ԏ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_CONFIG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_CONFIG_OFFSET			0x1				/**< \brief (WDT_CONFIG offset)`Ԑݒ */
#define WDT_CONFIG_RESETVALUE		0xBB			/**< \brief (WDT_CONFIG reset_value)`Ԑݒ */

#define WDT_CONFIG_PER_Pos			0				/**< \brief (WDT_CONFIG)Ԏ */
#define WDT_CONFIG_PER_Msk			(0xFu << WDT_CONFIG_PER_Pos)
#define WDT_CONFIG_PER(value)		((WDT_CONFIG_PER_Msk & ((value) << WDT_CONFIG_PER_Pos)))
#define WDT_CONFIG_WINDOW_Pos		4				/**< \brief (WDT_CONFIG)ޯތv푋Ԏ */
#define WDT_CONFIG_WINDOW_Msk		(0xFu << WDT_CONFIG_WINDOW_Pos)
#define WDT_CONFIG_WINDOW(value)	((WDT_CONFIG_WINDOW_Msk & ((value) << WDT_CONFIG_WINDOW_Pos)))
#define WDT_CONFIG_MASK				0xFFu			/**< \brief (WDT_CONFIG)Օڼ޽ */

/* -------- WDT_EWCTRL : (WDTψ:0x2) (R/W  8)x -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  EWOFFSET:4;		/*!< ޯ0`3: x荞ݎԕψ */
    uint8_t  :4;				/*!< ޯ4`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_EWCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_EWCTRL_OFFSET			0x2				/**< \brief (WDT_EWCTRL offset)x */
#define WDT_EWCTRL_RESETVALUE		0x0B			/**< \brief (WDT_EWCTRL reset_value)x */

#define WDT_EWCTRL_EWOFFSET_Pos		0				/**< \brief (WDT_EWCTRL)x荞ݎԕψ */
#define WDT_EWCTRL_EWOFFSET_Msk		(0xFu << WDT_EWCTRL_EWOFFSET_Pos)
#define WDT_EWCTRL_EWOFFSET(value)	((WDT_EWCTRL_EWOFFSET_Msk & ((value) << WDT_EWCTRL_EWOFFSET_Pos)))
#define WDT_EWCTRL_MASK				0x0Fu			/**< \brief (WDT_EWCTRL)Օڼ޽ */

/* -------- WDT_INTENCLR : (WDTψ:0x4) (R/W  8)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  EW:1;				/*!< ޯ   0: x荞݋֎~ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_INTENCLR_OFFSET			0x4				/**< \brief (WDT_INTENCLR offset)荞݋ */
#define WDT_INTENCLR_RESETVALUE		0x00			/**< \brief (WDT_INTENCLR reset_value)荞݋ */

#define WDT_INTENCLR_EW_Pos			0				/**< \brief (WDT_INTENCLR)x荞݋֎~ */
#define WDT_INTENCLR_EW				(0x1u << WDT_INTENCLR_EW_Pos)
#define WDT_INTENCLR_MASK			0x01u			/**< \brief (WDT_INTENCLR)Օڼ޽ */

/* -------- WDT_INTENSET : (WDTψ:0x5) (R/W  8)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  EW:1;				/*!< ޯ   0: x荞݋ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_INTENSET_OFFSET			0x5				/**< \brief (WDT_INTENSET offset)荞݋ݒ */
#define WDT_INTENSET_RESETVALUE		0x00			/**< \brief (WDT_INTENSET reset_value)荞݋ݒ */

#define WDT_INTENSET_EW_Pos			0				/**< \brief (WDT_INTENSET)x荞݋ */
#define WDT_INTENSET_EW				(0x1u << WDT_INTENSET_EW_Pos)
#define WDT_INTENSET_MASK			0x01u			/**< \brief (WDT_INTENSET)Օڼ޽ */

/* -------- WDT_INTFLAG : (WDTψ:0x6) (R/W  8)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  EW:1;				/*!< ޯ   0: x荞׸ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_INTFLAG_OFFSET			0x6				/**< \brief (WDT_INTFLAG offset)荞׸ޏ/ */
#define WDT_INTFLAG_RESETVALUE		0x00			/**< \brief (WDT_INTFLAG reset_value)荞׸ޏ/ */

#define WDT_INTFLAG_EW_Pos			0				/**< \brief (WDT_INTFLAG)x荞׸ */
#define WDT_INTFLAG_EW				(0x1u << WDT_INTFLAG_EW_Pos)
#define WDT_INTFLAG_MASK			0x01u			/**< \brief (WDT_INTFLAG)Օڼ޽ */

/* -------- WDT_STATUS : (WDTψ:0x7) (R/   8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :7;				/*!< ޯ0`6: \ */
    uint8_t  SYNCBUSY:1;		/*!< ޯ   7: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_STATUS_OFFSET			0x7				/**< \brief (WDT_STATUS offset) */
#define WDT_STATUS_RESETVALUE		0x00			/**< \brief (WDT_STATUS reset_value) */

#define WDT_STATUS_SYNCBUSY_Pos		7				/**< \brief (WDT_STATUS)Z */
#define WDT_STATUS_SYNCBUSY			(0x1u << WDT_STATUS_SYNCBUSY_Pos)
#define WDT_STATUS_MASK				0x80u			/**< \brief (WDT_STATUS)Օڼ޽ */

/* -------- WDT_CLEAR : (WDTψ:0x8) ( /W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CLEAR:8;			/*!< ޯ0`7: ޯތvw */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} WDT_CLEAR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define WDT_CLEAR_OFFSET			0x8				/**< \brief (WDT_CLEAR offset) */
#define WDT_CLEAR_RESETVALUE		0x00			/**< \brief (WDT_CLEAR reset_value) */

#define WDT_CLEAR_CLEAR_Pos			0				/**< \brief (WDT_CLEAR)ޯތvw */
#define WDT_CLEAR_CLEAR_Msk			(0xFFu << WDT_CLEAR_CLEAR_Pos)
#define WDT_CLEAR_CLEAR(value)		((WDT_CLEAR_CLEAR_Msk & ((value) << WDT_CLEAR_CLEAR_Pos)))
#define   WDT_CLEAR_CLEAR_KEY_Val	0xA5u			/**< \brief (WDT_CLEAR) Key */
#define WDT_CLEAR_CLEAR_KEY			(WDT_CLEAR_CLEAR_KEY_Val		<< WDT_CLEAR_CLEAR_Pos)
#define WDT_CLEAR_MASK				0xFFu			/**< \brief (WDT_CLEAR)Օڼ޽ */

/** \brief WDTʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO WDT_CTRL_Type		CTRL;			/**< \briefψ:0x0 (R/W  8) */
  __IO WDT_CONFIG_Type		CONFIG;			/**< \briefψ:0x1 (R/W  8)`Ԑݒ */
  __IO WDT_EWCTRL_Type		EWCTRL;			/**< \briefψ:0x2 (R/W  8)x */
	   RoReg8				Reserved1[0x1];
  __IO WDT_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x4 (R/W  8)荞݋ */
  __IO WDT_INTENSET_Type	INTENSET;		/**< \briefψ:0x5 (R/W  8)荞݋ݒ */
  __IO WDT_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x6 (R/W  8)荞׸ޏ/ */
  __I  WDT_STATUS_Type		STATUS;			/**< \briefψ:0x7 (R/   8) */
  __O  WDT_CLEAR_Type		CLEAR;			/**< \briefψ:0x8 ( /W  8) */
} Wdt;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD20_WDT_COMPONENT_ */
