/**
 * \file
 *
 * \brief NVMCTRLp̋Lqq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_NVMCTRL_INSTANCE_
#define _SAMD20_NVMCTRL_INSTANCE_

/* ========== NVMCTRLӋ@\pڼ޽` ========== */
#if (defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
#define REG_NVMCTRL_CTRLA		(0x41004000U) /**< \brief (NVMCTRL)NVMA */
#define REG_NVMCTRL_CTRLB		(0x41004004U) /**< \brief (NVMCTRL)NVMB */
#define REG_NVMCTRL_PARAM		(0x41004008U) /**< \brief (NVMCTRL)Ұ */
#define REG_NVMCTRL_INTENCLR	(0x4100400CU) /**< \brief (NVMCTRL)荞݋ */
#define REG_NVMCTRL_INTENSET	(0x41004010U) /**< \brief (NVMCTRL)荞݋ݒ */
#define REG_NVMCTRL_INTFLAG		(0x41004014U) /**< \brief (NVMCTRL)荞׸ޏ/ */
#define REG_NVMCTRL_STATUS		(0x41004018U) /**< \brief (NVMCTRL) */
#define REG_NVMCTRL_ADDR		(0x4100401CU) /**< \brief (NVMCTRL) */
#define REG_NVMCTRL_LOCK		(0x41004020U) /**< \brief (NVMCTRL){ */
#else
#define REG_NVMCTRL_CTRLA		(*(RwReg16*)0x41004000U) /**< \brief (NVMCTRL)NVMA */
#define REG_NVMCTRL_CTRLB		(*(RwReg  *)0x41004004U) /**< \brief (NVMCTRL)NVMB */
#define REG_NVMCTRL_PARAM		(*(RwReg  *)0x41004008U) /**< \brief (NVMCTRL)Ұ */
#define REG_NVMCTRL_INTENCLR	(*(RwReg8 *)0x4100400CU) /**< \brief (NVMCTRL)荞݋ */
#define REG_NVMCTRL_INTENSET	(*(RwReg8 *)0x41004010U) /**< \brief (NVMCTRL)荞݋ݒ */
#define REG_NVMCTRL_INTFLAG		(*(RwReg8 *)0x41004014U) /**< \brief (NVMCTRL)荞׸ޏ/ */
#define REG_NVMCTRL_STATUS		(*(RwReg16*)0x41004018U) /**< \brief (NVMCTRL) */
#define REG_NVMCTRL_ADDR		(*(RwReg  *)0x4100401CU) /**< \brief (NVMCTRL) */
#define REG_NVMCTRL_LOCK		(*(RwReg16*)0x41004020U) /**< \brief (NVMCTRL){ */
#endif /* (defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/* ========== NVMCTRLӋ@\pҰ ========== */
#define NVMCTRL_AUX0_ADDRESS					(NVMCTRL_USER_PAGE_ADDRESS + 0x00004000)
#define NVMCTRL_AUX1_ADDRESS					(NVMCTRL_USER_PAGE_ADDRESS + 0x00006000)
#define NVMCTRL_AUX2_ADDRESS					(NVMCTRL_USER_PAGE_ADDRESS + 0x00008000)
#define NVMCTRL_AUX3_ADDRESS					(NVMCTRL_USER_PAGE_ADDRESS + 0x0000A000)
#define NVMCTRL_CLK_AHB_ID						4
#define NVMCTRL_FACTORY_WORD_IMPLEMENTED_MASK	0XC0000007FFFFFFFF
#define NVMCTRL_FLASH_SIZE						(NVMCTRL_PAGES*NVMCTRL_PAGE_SIZE)
#define NVMCTRL_FUSES_SECURE_NVM
#define NVMCTRL_FUSES_SECURE_RAM
#define NVMCTRL_FUSES_SECURE_STATE
#define NVMCTRL_LOCKBIT_ADDRESS					(NVMCTRL_USER_PAGE_ADDRESS + 0x00002000)
#define NVMCTRL_PAGES							4096
#define NVMCTRL_PAGE_HW							(NVMCTRL_PAGE_SIZE/2)
#define NVMCTRL_PAGE_SIZE						(1<<NVMCTRL_PSZ_BITS)
#define NVMCTRL_PAGE_W							(NVMCTRL_PAGE_SIZE/4)
#define NVMCTRL_PMSB							3
#define NVMCTRL_PSZ_BITS						6
#define NVMCTRL_ROW_PAGES						(NVMCTRL_ROW_SIZE/NVMCTRL_PAGE_SIZE)
#define NVMCTRL_ROW_SIZE						(NVMCTRL_PAGE_SIZE*4)
#define NVMCTRL_USER_PAGE_ADDRESS				(FLASH_ADDR + NVMCTRL_USER_PAGE_OFFSET)
#define NVMCTRL_USER_PAGE_OFFSET				0x00800000
#define NVMCTRL_USER_WORD_IMPLEMENTED_MASK		0XC01FFFFFFFFFFFFF

#endif /* _SAMD20_NVMCTRL_INSTANCE_ */
