/**
 * \file
 *
 * \brief EVSYSp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_EVSYS_COMPONENT_
#define _SAMD21_EVSYS_COMPONENT_

/* ========================================================================== */
/** EVSYSpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_EVSYS ۼ ̪ */
/*@{*/

#define EVSYS_U2208
#define REV_EVSYS								0x101

/* -------- EVSYS_CTRL : (EVSYSψ:0x00) ( /W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ   0: ĳ ؾ */
    uint8_t  :3;				/*!< ޯ1`3: \ */
    uint8_t  GCLKREQ:1;			/*!< ޯ   4: ʸۯv */
    uint8_t  :3;				/*!< ޯ5`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_CTRL_OFFSET						0x00			/**< \brief (EVSYS_CTRL offset) */
#define EVSYS_CTRL_RESETVALUE					0x00			/**< \brief (EVSYS_CTRL reset_value) */

#define EVSYS_CTRL_SWRST_Pos					0				/**< \brief (EVSYS_CTRL)ĳ ؾ */
#define EVSYS_CTRL_SWRST						(0x1u << EVSYS_CTRL_SWRST_Pos)
#define EVSYS_CTRL_GCLKREQ_Pos					4				/**< \brief (EVSYS_CTRL)ʸۯv */
#define EVSYS_CTRL_GCLKREQ						(0x1u << EVSYS_CTRL_GCLKREQ_Pos)
#define EVSYS_CTRL_MASK							0x11u			/**< \brief (EVSYS_CTRL)Օڼ޽ */

/* -------- EVSYS_CHANNEL : (EVSYSψ:0x04) (R/W 32) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CHANNEL:4;			/*!< ޯ 0` 3: ّI */
    uint32_t :4;				/*!< ޯ 4` 7: \ */
    uint32_t SWEVT:1;			/*!< ޯ     8: ĳ */
    uint32_t :7;				/*!< ޯ 9`15: \ */
    uint32_t EVGEN:7;			/*!< ޯ16`22: ېI */
    uint32_t :1;				/*!< ޯ    23: \ */
    uint32_t PATH:2;			/*!< ޯ 24,25: oHI */
    uint32_t EDGSEL:2;			/*!< ޯ 26,27: [oI */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_CHANNEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_CHANNEL_OFFSET					0x04			/**< \brief (EVSYS_CHANNEL offset) */
#define EVSYS_CHANNEL_RESETVALUE				0x00000000			/**< \brief (EVSYS_CHANNEL reset_value) */

#define EVSYS_CHANNEL_CHANNEL_Pos				0				/**< \brief (EVSYS_CHANNEL)ّI */
#define EVSYS_CHANNEL_CHANNEL_Msk				(0xFu << EVSYS_CHANNEL_CHANNEL_Pos)
#define EVSYS_CHANNEL_CHANNEL(value)			((EVSYS_CHANNEL_CHANNEL_Msk & ((value) << EVSYS_CHANNEL_CHANNEL_Pos)))
#define EVSYS_CHANNEL_SWEVT_Pos					8				/**< \brief (EVSYS_CHANNEL)ĳ */
#define EVSYS_CHANNEL_SWEVT						(0x1u << EVSYS_CHANNEL_SWEVT_Pos)
#define EVSYS_CHANNEL_EVGEN_Pos					16				/**< \brief (EVSYS_CHANNEL)ېI */
#define EVSYS_CHANNEL_EVGEN_Msk					(0x7Fu << EVSYS_CHANNEL_EVGEN_Pos)
#define EVSYS_CHANNEL_EVGEN(value)				((EVSYS_CHANNEL_EVGEN_Msk & ((value) << EVSYS_CHANNEL_EVGEN_Pos)))
#define EVSYS_CHANNEL_PATH_Pos					24				/**< \brief (EVSYS_CHANNEL)oHI */
#define EVSYS_CHANNEL_PATH_Msk					(0x3u << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_PATH(value)				((EVSYS_CHANNEL_PATH_Msk & ((value) << EVSYS_CHANNEL_PATH_Pos)))
#define   EVSYS_CHANNEL_PATH_SYNCHRONOUS_Val		0x0u			/**< \brief (EVSYS_CHANNEL)oH */
#define   EVSYS_CHANNEL_PATH_RESYNCHRONIZED_Val		0x1u			/**< \brief (EVSYS_CHANNEL)ēoH */
#define   EVSYS_CHANNEL_PATH_ASYNCHRONOUS_Val		0x2u			/**< \brief (EVSYS_CHANNEL)񓯊oH */
#define EVSYS_CHANNEL_PATH_SYNCHRONOUS			(EVSYS_CHANNEL_PATH_SYNCHRONOUS_Val << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_PATH_RESYNCHRONIZED		(EVSYS_CHANNEL_PATH_RESYNCHRONIZED_Val << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_PATH_ASYNCHRONOUS			(EVSYS_CHANNEL_PATH_ASYNCHRONOUS_Val << EVSYS_CHANNEL_PATH_Pos)
#define EVSYS_CHANNEL_EDGSEL_Pos				26				/**< \brief (EVSYS_CHANNEL)[oI */
#define EVSYS_CHANNEL_EDGSEL_Msk				(0x3u << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL(value)				((EVSYS_CHANNEL_EDGSEL_Msk & ((value) << EVSYS_CHANNEL_EDGSEL_Pos)))
#define   EVSYS_CHANNEL_EDGSEL_NO_EVT_OUTPUT_Val	0x0u			/**< \brief (EVSYS_CHANNEL)ēƓ̌oHgpۏo͂Ȃ */
#define   EVSYS_CHANNEL_EDGSEL_RISING_EDGE_Val		0x1u			/**< \brief (EVSYS_CHANNEL)ēƓ̌oHgpې̐M̏㏸[łیo */
#define   EVSYS_CHANNEL_EDGSEL_FALLING_EDGE_Val		0x2u			/**< \brief (EVSYS_CHANNEL)ēƓ̌oHgpې̐M̉~[łیo */
#define   EVSYS_CHANNEL_EDGSEL_BOTH_EDGES_Val		0x3u			/**< \brief (EVSYS_CHANNEL)ēƓ̌oHgpې̐M̏㏸Ɖ~̒[Ŏیo */
#define EVSYS_CHANNEL_EDGSEL_NO_EVT_OUTPUT		(EVSYS_CHANNEL_EDGSEL_NO_EVT_OUTPUT_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL_RISING_EDGE		(EVSYS_CHANNEL_EDGSEL_RISING_EDGE_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL_FALLING_EDGE		(EVSYS_CHANNEL_EDGSEL_FALLING_EDGE_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_EDGSEL_BOTH_EDGES			(EVSYS_CHANNEL_EDGSEL_BOTH_EDGES_Val << EVSYS_CHANNEL_EDGSEL_Pos)
#define EVSYS_CHANNEL_MASK						0x0F7F010Fu			/**< \brief (EVSYS_CHANNEL)Օڼ޽ */

/* -------- EVSYS_USER : (EVSYSψ:0x08) (R/W 16)gpd -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t USER:5;			/*!< ޯ 0` 4: gpdI */
    uint16_t :3;				/*!< ޯ 5` 7: \ */
    uint16_t CHANNEL:5;			/*!< ޯ 8`12: َۑI */
    uint16_t :3;				/*!< ޯ13`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_USER_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_USER_OFFSET						0x08			/**< \brief (EVSYS_USER offset)gpd */
#define EVSYS_USER_RESETVALUE					0x0000			/**< \brief (EVSYS_USER reset_value)gpd */

#define EVSYS_USER_USER_Pos						0				/**< \brief (EVSYS_USER)gpdI */
#define EVSYS_USER_USER_Msk						(0x1Fu << EVSYS_USER_USER_Pos)
#define EVSYS_USER_USER(value)					((EVSYS_USER_USER_Msk & ((value) << EVSYS_USER_USER_Pos)))
#define EVSYS_USER_CHANNEL_Pos					8				/**< \brief (EVSYS_USER)َۑI */
#define EVSYS_USER_CHANNEL_Msk					(0x1Fu << EVSYS_USER_CHANNEL_Pos)
#define EVSYS_USER_CHANNEL(value)				((EVSYS_USER_CHANNEL_Msk & ((value) << EVSYS_USER_CHANNEL_Pos)))
#define   EVSYS_USER_CHANNEL_0_Val					0x0u			/**< \brief (EVSYS_USER) No Output Selected */
#define EVSYS_USER_CHANNEL_0					(EVSYS_USER_CHANNEL_0_Val			<< EVSYS_USER_CHANNEL_Pos)
#define EVSYS_USER_MASK							0x1F1Fu			/**< \brief (EVSYS_USER)Օڼ޽ */

/* -------- EVSYS_CHSTATUS : (EVSYSψ:0x0C) (R/  32)ُ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t USRRDY0:1;			/*!< ޯ     0: 0gpҏ */
    uint32_t USRRDY1:1;			/*!< ޯ     1: 1gpҏ */
    uint32_t USRRDY2:1;			/*!< ޯ     2: 2gpҏ */
    uint32_t USRRDY3:1;			/*!< ޯ     3: 3gpҏ */
    uint32_t USRRDY4:1;			/*!< ޯ     4: 4gpҏ */
    uint32_t USRRDY5:1;			/*!< ޯ     5: 5gpҏ */
    uint32_t USRRDY6:1;			/*!< ޯ     6: 6gpҏ */
    uint32_t USRRDY7:1;			/*!< ޯ     7: 7gpҏ */
    uint32_t CHBUSY0:1;			/*!< ޯ     8: 0Z */
    uint32_t CHBUSY1:1;			/*!< ޯ     9: 1Z */
    uint32_t CHBUSY2:1;			/*!< ޯ    10: 2Z */
    uint32_t CHBUSY3:1;			/*!< ޯ    11: 3Z */
    uint32_t CHBUSY4:1;			/*!< ޯ    12: 4Z */
    uint32_t CHBUSY5:1;			/*!< ޯ    13: 5Z */
    uint32_t CHBUSY6:1;			/*!< ޯ    14: 6Z */
    uint32_t CHBUSY7:1;			/*!< ޯ    15: 7Z */
    uint32_t USRRDY8:1;			/*!< ޯ    16: 8gpҏ */
    uint32_t USRRDY9:1;			/*!< ޯ    17: 9gpҏ */
    uint32_t USRRDY10:1;		/*!< ޯ    18: 10gpҏ */
    uint32_t USRRDY11:1;		/*!< ޯ    19: 11gpҏ */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t CHBUSY8:1;			/*!< ޯ    24: 8Z */
    uint32_t CHBUSY9:1;			/*!< ޯ    25: 9Z */
    uint32_t CHBUSY10:1;		/*!< ޯ    26: 10Z */
    uint32_t CHBUSY11:1;		/*!< ޯ    27: 11Z */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t USRRDY:8;			/*!< ޯ 0` 7: xgpҏ */
    uint32_t CHBUSY:8;			/*!< ޯ 8`15: xZ */
    uint32_t USRRDYp8:4;		/*!< ޯ16`19: x+8gpҏ */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t CHBUSYp8:4;		/*!< ޯ24`27: x+8Z */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_CHSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_CHSTATUS_OFFSET					0x0C			/**< \brief (EVSYS_CHSTATUS offset)ُ */
#define EVSYS_CHSTATUS_RESETVALUE				0x000F00FF			/**< \brief (EVSYS_CHSTATUS reset_value)ُ */

#define EVSYS_CHSTATUS_USRRDY0_Pos				0				/**< \brief (EVSYS_CHSTATUS)0gpҏ */
#define EVSYS_CHSTATUS_USRRDY0					(1 << EVSYS_CHSTATUS_USRRDY0_Pos)
#define EVSYS_CHSTATUS_USRRDY1_Pos				1				/**< \brief (EVSYS_CHSTATUS)1gpҏ */
#define EVSYS_CHSTATUS_USRRDY1					(1 << EVSYS_CHSTATUS_USRRDY1_Pos)
#define EVSYS_CHSTATUS_USRRDY2_Pos				2				/**< \brief (EVSYS_CHSTATUS)2gpҏ */
#define EVSYS_CHSTATUS_USRRDY2					(1 << EVSYS_CHSTATUS_USRRDY2_Pos)
#define EVSYS_CHSTATUS_USRRDY3_Pos				3				/**< \brief (EVSYS_CHSTATUS)3gpҏ */
#define EVSYS_CHSTATUS_USRRDY3					(1 << EVSYS_CHSTATUS_USRRDY3_Pos)
#define EVSYS_CHSTATUS_USRRDY4_Pos				4				/**< \brief (EVSYS_CHSTATUS)4gpҏ */
#define EVSYS_CHSTATUS_USRRDY4					(1 << EVSYS_CHSTATUS_USRRDY4_Pos)
#define EVSYS_CHSTATUS_USRRDY5_Pos				5				/**< \brief (EVSYS_CHSTATUS)5gpҏ */
#define EVSYS_CHSTATUS_USRRDY5					(1 << EVSYS_CHSTATUS_USRRDY5_Pos)
#define EVSYS_CHSTATUS_USRRDY6_Pos				6				/**< \brief (EVSYS_CHSTATUS)6gpҏ */
#define EVSYS_CHSTATUS_USRRDY6					(1 << EVSYS_CHSTATUS_USRRDY6_Pos)
#define EVSYS_CHSTATUS_USRRDY7_Pos				7				/**< \brief (EVSYS_CHSTATUS)7gpҏ */
#define EVSYS_CHSTATUS_USRRDY7					(1 << EVSYS_CHSTATUS_USRRDY7_Pos)
#define EVSYS_CHSTATUS_USRRDY_Pos				0				/**< \brief (EVSYS_CHSTATUS)xgpҏ */
#define EVSYS_CHSTATUS_USRRDY_Msk				(0xFFu << EVSYS_CHSTATUS_USRRDY_Pos)
#define EVSYS_CHSTATUS_USRRDY(value)			((EVSYS_CHSTATUS_USRRDY_Msk & ((value) << EVSYS_CHSTATUS_USRRDY_Pos)))
#define EVSYS_CHSTATUS_CHBUSY0_Pos				8				/**< \brief (EVSYS_CHSTATUS)0Z */
#define EVSYS_CHSTATUS_CHBUSY0					(1 << EVSYS_CHSTATUS_CHBUSY0_Pos)
#define EVSYS_CHSTATUS_CHBUSY1_Pos				9				/**< \brief (EVSYS_CHSTATUS)1Z */
#define EVSYS_CHSTATUS_CHBUSY1					(1 << EVSYS_CHSTATUS_CHBUSY1_Pos)
#define EVSYS_CHSTATUS_CHBUSY2_Pos				10				/**< \brief (EVSYS_CHSTATUS)2Z */
#define EVSYS_CHSTATUS_CHBUSY2					(1 << EVSYS_CHSTATUS_CHBUSY2_Pos)
#define EVSYS_CHSTATUS_CHBUSY3_Pos				11				/**< \brief (EVSYS_CHSTATUS)3Z */
#define EVSYS_CHSTATUS_CHBUSY3					(1 << EVSYS_CHSTATUS_CHBUSY3_Pos)
#define EVSYS_CHSTATUS_CHBUSY4_Pos				12				/**< \brief (EVSYS_CHSTATUS)4Z */
#define EVSYS_CHSTATUS_CHBUSY4					(1 << EVSYS_CHSTATUS_CHBUSY4_Pos)
#define EVSYS_CHSTATUS_CHBUSY5_Pos				13				/**< \brief (EVSYS_CHSTATUS)5Z */
#define EVSYS_CHSTATUS_CHBUSY5					(1 << EVSYS_CHSTATUS_CHBUSY5_Pos)
#define EVSYS_CHSTATUS_CHBUSY6_Pos				14				/**< \brief (EVSYS_CHSTATUS)6Z */
#define EVSYS_CHSTATUS_CHBUSY6					(1 << EVSYS_CHSTATUS_CHBUSY6_Pos)
#define EVSYS_CHSTATUS_CHBUSY7_Pos				15				/**< \brief (EVSYS_CHSTATUS)7Z */
#define EVSYS_CHSTATUS_CHBUSY7					(1 << EVSYS_CHSTATUS_CHBUSY7_Pos)
#define EVSYS_CHSTATUS_CHBUSY_Pos				8				/**< \brief (EVSYS_CHSTATUS)xZ */
#define EVSYS_CHSTATUS_CHBUSY_Msk				(0xFFu << EVSYS_CHSTATUS_CHBUSY_Pos)
#define EVSYS_CHSTATUS_CHBUSY(value)			((EVSYS_CHSTATUS_CHBUSY_Msk & ((value) << EVSYS_CHSTATUS_CHBUSY_Pos)))
#define EVSYS_CHSTATUS_USRRDY8_Pos				16				/**< \brief (EVSYS_CHSTATUS)8gpҏ */
#define EVSYS_CHSTATUS_USRRDY8					(1 << EVSYS_CHSTATUS_USRRDY8_Pos)
#define EVSYS_CHSTATUS_USRRDY9_Pos				17				/**< \brief (EVSYS_CHSTATUS)9gpҏ */
#define EVSYS_CHSTATUS_USRRDY9					(1 << EVSYS_CHSTATUS_USRRDY9_Pos)
#define EVSYS_CHSTATUS_USRRDY10_Pos				18				/**< \brief (EVSYS_CHSTATUS)10gpҏ */
#define EVSYS_CHSTATUS_USRRDY10					(1 << EVSYS_CHSTATUS_USRRDY10_Pos)
#define EVSYS_CHSTATUS_USRRDY11_Pos				19				/**< \brief (EVSYS_CHSTATUS)11gpҏ */
#define EVSYS_CHSTATUS_USRRDY11					(1 << EVSYS_CHSTATUS_USRRDY11_Pos)
#define EVSYS_CHSTATUS_USRRDYp8_Pos				16				/**< \brief (EVSYS_CHSTATUS)x+8gpҏ */
#define EVSYS_CHSTATUS_USRRDYp8_Msk				(0xFu << EVSYS_CHSTATUS_USRRDYp8_Pos)
#define EVSYS_CHSTATUS_USRRDYp8(value)			((EVSYS_CHSTATUS_USRRDYp8_Msk & ((value) << EVSYS_CHSTATUS_USRRDYp8_Pos)))
#define EVSYS_CHSTATUS_CHBUSY8_Pos				24				/**< \brief (EVSYS_CHSTATUS)8Z */
#define EVSYS_CHSTATUS_CHBUSY8					(1 << EVSYS_CHSTATUS_CHBUSY8_Pos)
#define EVSYS_CHSTATUS_CHBUSY9_Pos				25				/**< \brief (EVSYS_CHSTATUS)9Z */
#define EVSYS_CHSTATUS_CHBUSY9					(1 << EVSYS_CHSTATUS_CHBUSY9_Pos)
#define EVSYS_CHSTATUS_CHBUSY10_Pos				26				/**< \brief (EVSYS_CHSTATUS)10Z */
#define EVSYS_CHSTATUS_CHBUSY10					(1 << EVSYS_CHSTATUS_CHBUSY10_Pos)
#define EVSYS_CHSTATUS_CHBUSY11_Pos				27				/**< \brief (EVSYS_CHSTATUS)11Z */
#define EVSYS_CHSTATUS_CHBUSY11					(1 << EVSYS_CHSTATUS_CHBUSY11_Pos)
#define EVSYS_CHSTATUS_CHBUSYp8_Pos				24				/**< \brief (EVSYS_CHSTATUS)x+8Z */
#define EVSYS_CHSTATUS_CHBUSYp8_Msk				(0xFu << EVSYS_CHSTATUS_CHBUSYp8_Pos)
#define EVSYS_CHSTATUS_CHBUSYp8(value)			((EVSYS_CHSTATUS_CHBUSYp8_Msk & ((value) << EVSYS_CHSTATUS_CHBUSYp8_Pos)))
#define EVSYS_CHSTATUS_MASK						0x0F0FFFFFu			/**< \brief (EVSYS_CHSTATUS)Օڼ޽ */

/* -------- EVSYS_INTENCLR : (EVSYSψ:0x10) (R/W 32)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t OVR0:1;			/*!< ޯ     0: 0ް݊荞݋ */
    uint32_t OVR1:1;			/*!< ޯ     1: 1ް݊荞݋ */
    uint32_t OVR2:1;			/*!< ޯ     2: 2ް݊荞݋ */
    uint32_t OVR3:1;			/*!< ޯ     3: 3ް݊荞݋ */
    uint32_t OVR4:1;			/*!< ޯ     4: 4ް݊荞݋ */
    uint32_t OVR5:1;			/*!< ޯ     5: 5ް݊荞݋ */
    uint32_t OVR6:1;			/*!< ޯ     6: 6ް݊荞݋ */
    uint32_t OVR7:1;			/*!< ޯ     7: 7ް݊荞݋ */
    uint32_t EVD0:1;			/*!< ޯ     8: 0یo荞݋ */
    uint32_t EVD1:1;			/*!< ޯ     9: 1یo荞݋ */
    uint32_t EVD2:1;			/*!< ޯ    10: 2یo荞݋ */
    uint32_t EVD3:1;			/*!< ޯ    11: 3یo荞݋ */
    uint32_t EVD4:1;			/*!< ޯ    12: 4یo荞݋ */
    uint32_t EVD5:1;			/*!< ޯ    13: 5یo荞݋ */
    uint32_t EVD6:1;			/*!< ޯ    14: 6یo荞݋ */
    uint32_t EVD7:1;			/*!< ޯ    15: 7یo荞݋ */
    uint32_t OVR8:1;			/*!< ޯ    16: 8ް݊荞݋ */
    uint32_t OVR9:1;			/*!< ޯ    17: 9ް݊荞݋ */
    uint32_t OVR10:1;			/*!< ޯ    18: 10ް݊荞݋ */
    uint32_t OVR11:1;			/*!< ޯ    19: 11ް݊荞݋ */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t EVD8:1;			/*!< ޯ    24: 8یo荞݋ */
    uint32_t EVD9:1;			/*!< ޯ    25: 9یo荞݋ */
    uint32_t EVD10:1;			/*!< ޯ    26: 10یo荞݋ */
    uint32_t EVD11:1;			/*!< ޯ    27: 11یo荞݋ */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t OVR:8;				/*!< ޯ 0` 7: xް݊荞݋ */
    uint32_t EVD:8;				/*!< ޯ 8`15: xیo荞݋ */
    uint32_t OVRp8:4;			/*!< ޯ16`19: x+8ް݊荞݋ */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t EVDp8:4;			/*!< ޯ24`27: x+8یo荞݋ */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_INTENCLR_OFFSET					0x10			/**< \brief (EVSYS_INTENCLR offset)荞݋ */
#define EVSYS_INTENCLR_RESETVALUE				0x00000000			/**< \brief (EVSYS_INTENCLR reset_value)荞݋ */

#define EVSYS_INTENCLR_OVR0_Pos					0				/**< \brief (EVSYS_INTENCLR)0ް݊荞݋ */
#define EVSYS_INTENCLR_OVR0						(1 << EVSYS_INTENCLR_OVR0_Pos)
#define EVSYS_INTENCLR_OVR1_Pos					1				/**< \brief (EVSYS_INTENCLR)1ް݊荞݋ */
#define EVSYS_INTENCLR_OVR1						(1 << EVSYS_INTENCLR_OVR1_Pos)
#define EVSYS_INTENCLR_OVR2_Pos					2				/**< \brief (EVSYS_INTENCLR)2ް݊荞݋ */
#define EVSYS_INTENCLR_OVR2						(1 << EVSYS_INTENCLR_OVR2_Pos)
#define EVSYS_INTENCLR_OVR3_Pos					3				/**< \brief (EVSYS_INTENCLR)3ް݊荞݋ */
#define EVSYS_INTENCLR_OVR3						(1 << EVSYS_INTENCLR_OVR3_Pos)
#define EVSYS_INTENCLR_OVR4_Pos					4				/**< \brief (EVSYS_INTENCLR)4ް݊荞݋ */
#define EVSYS_INTENCLR_OVR4						(1 << EVSYS_INTENCLR_OVR4_Pos)
#define EVSYS_INTENCLR_OVR5_Pos					5				/**< \brief (EVSYS_INTENCLR)5ް݊荞݋ */
#define EVSYS_INTENCLR_OVR5						(1 << EVSYS_INTENCLR_OVR5_Pos)
#define EVSYS_INTENCLR_OVR6_Pos					6				/**< \brief (EVSYS_INTENCLR)6ް݊荞݋ */
#define EVSYS_INTENCLR_OVR6						(1 << EVSYS_INTENCLR_OVR6_Pos)
#define EVSYS_INTENCLR_OVR7_Pos					7				/**< \brief (EVSYS_INTENCLR)7ް݊荞݋ */
#define EVSYS_INTENCLR_OVR7						(1 << EVSYS_INTENCLR_OVR7_Pos)
#define EVSYS_INTENCLR_OVR_Pos					0				/**< \brief (EVSYS_INTENCLR)xް݊荞݋ */
#define EVSYS_INTENCLR_OVR_Msk					(0xFFu << EVSYS_INTENCLR_OVR_Pos)
#define EVSYS_INTENCLR_OVR(value)				((EVSYS_INTENCLR_OVR_Msk & ((value) << EVSYS_INTENCLR_OVR_Pos)))
#define EVSYS_INTENCLR_EVD0_Pos					8				/**< \brief (EVSYS_INTENCLR)0یo荞݋ */
#define EVSYS_INTENCLR_EVD0						(1 << EVSYS_INTENCLR_EVD0_Pos)
#define EVSYS_INTENCLR_EVD1_Pos					9				/**< \brief (EVSYS_INTENCLR)1یo荞݋ */
#define EVSYS_INTENCLR_EVD1						(1 << EVSYS_INTENCLR_EVD1_Pos)
#define EVSYS_INTENCLR_EVD2_Pos					10				/**< \brief (EVSYS_INTENCLR)2یo荞݋ */
#define EVSYS_INTENCLR_EVD2						(1 << EVSYS_INTENCLR_EVD2_Pos)
#define EVSYS_INTENCLR_EVD3_Pos					11				/**< \brief (EVSYS_INTENCLR)3یo荞݋ */
#define EVSYS_INTENCLR_EVD3						(1 << EVSYS_INTENCLR_EVD3_Pos)
#define EVSYS_INTENCLR_EVD4_Pos					12				/**< \brief (EVSYS_INTENCLR)4یo荞݋ */
#define EVSYS_INTENCLR_EVD4						(1 << EVSYS_INTENCLR_EVD4_Pos)
#define EVSYS_INTENCLR_EVD5_Pos					13				/**< \brief (EVSYS_INTENCLR)5یo荞݋ */
#define EVSYS_INTENCLR_EVD5						(1 << EVSYS_INTENCLR_EVD5_Pos)
#define EVSYS_INTENCLR_EVD6_Pos					14				/**< \brief (EVSYS_INTENCLR)6یo荞݋ */
#define EVSYS_INTENCLR_EVD6						(1 << EVSYS_INTENCLR_EVD6_Pos)
#define EVSYS_INTENCLR_EVD7_Pos					15				/**< \brief (EVSYS_INTENCLR)7یo荞݋ */
#define EVSYS_INTENCLR_EVD7						(1 << EVSYS_INTENCLR_EVD7_Pos)
#define EVSYS_INTENCLR_EVD_Pos					8				/**< \brief (EVSYS_INTENCLR)xیo荞݋ */
#define EVSYS_INTENCLR_EVD_Msk					(0xFFu << EVSYS_INTENCLR_EVD_Pos)
#define EVSYS_INTENCLR_EVD(value)				((EVSYS_INTENCLR_EVD_Msk & ((value) << EVSYS_INTENCLR_EVD_Pos)))
#define EVSYS_INTENCLR_OVR8_Pos					16				/**< \brief (EVSYS_INTENCLR)8ް݊荞݋ */
#define EVSYS_INTENCLR_OVR8						(1 << EVSYS_INTENCLR_OVR8_Pos)
#define EVSYS_INTENCLR_OVR9_Pos					17				/**< \brief (EVSYS_INTENCLR)9ް݊荞݋ */
#define EVSYS_INTENCLR_OVR9						(1 << EVSYS_INTENCLR_OVR9_Pos)
#define EVSYS_INTENCLR_OVR10_Pos				18				/**< \brief (EVSYS_INTENCLR)10ް݊荞݋ */
#define EVSYS_INTENCLR_OVR10					(1 << EVSYS_INTENCLR_OVR10_Pos)
#define EVSYS_INTENCLR_OVR11_Pos				19				/**< \brief (EVSYS_INTENCLR)11ް݊荞݋ */
#define EVSYS_INTENCLR_OVR11					(1 << EVSYS_INTENCLR_OVR11_Pos)
#define EVSYS_INTENCLR_OVRp8_Pos				16				/**< \brief (EVSYS_INTENCLR)x+8ް݊荞݋ */
#define EVSYS_INTENCLR_OVRp8_Msk				(0xFu << EVSYS_INTENCLR_OVRp8_Pos)
#define EVSYS_INTENCLR_OVRp8(value)				((EVSYS_INTENCLR_OVRp8_Msk & ((value) << EVSYS_INTENCLR_OVRp8_Pos)))
#define EVSYS_INTENCLR_EVD8_Pos					24				/**< \brief (EVSYS_INTENCLR)8یo荞݋ */
#define EVSYS_INTENCLR_EVD8						(1 << EVSYS_INTENCLR_EVD8_Pos)
#define EVSYS_INTENCLR_EVD9_Pos					25				/**< \brief (EVSYS_INTENCLR)9یo荞݋ */
#define EVSYS_INTENCLR_EVD9						(1 << EVSYS_INTENCLR_EVD9_Pos)
#define EVSYS_INTENCLR_EVD10_Pos				26				/**< \brief (EVSYS_INTENCLR)10یo荞݋ */
#define EVSYS_INTENCLR_EVD10					(1 << EVSYS_INTENCLR_EVD10_Pos)
#define EVSYS_INTENCLR_EVD11_Pos				27				/**< \brief (EVSYS_INTENCLR)11یo荞݋ */
#define EVSYS_INTENCLR_EVD11					(1 << EVSYS_INTENCLR_EVD11_Pos)
#define EVSYS_INTENCLR_EVDp8_Pos				24				/**< \brief (EVSYS_INTENCLR)x+8یo荞݋ */
#define EVSYS_INTENCLR_EVDp8_Msk				(0xFu << EVSYS_INTENCLR_EVDp8_Pos)
#define EVSYS_INTENCLR_EVDp8(value)				((EVSYS_INTENCLR_EVDp8_Msk & ((value) << EVSYS_INTENCLR_EVDp8_Pos)))
#define EVSYS_INTENCLR_MASK						0x0F0FFFFFu			/**< \brief (EVSYS_INTENCLR)Օڼ޽ */

/* -------- EVSYS_INTENSET : (EVSYSψ:0x14) (R/W 32)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t OVR0:1;			/*!< ޯ     0: 0ް݊荞݋ */
    uint32_t OVR1:1;			/*!< ޯ     1: 1ް݊荞݋ */
    uint32_t OVR2:1;			/*!< ޯ     2: 2ް݊荞݋ */
    uint32_t OVR3:1;			/*!< ޯ     3: 3ް݊荞݋ */
    uint32_t OVR4:1;			/*!< ޯ     4: 4ް݊荞݋ */
    uint32_t OVR5:1;			/*!< ޯ     5: 5ް݊荞݋ */
    uint32_t OVR6:1;			/*!< ޯ     6: 6ް݊荞݋ */
    uint32_t OVR7:1;			/*!< ޯ     7: 7ް݊荞݋ */
    uint32_t EVD0:1;			/*!< ޯ     8: 0یo荞݋ */
    uint32_t EVD1:1;			/*!< ޯ     9: 1یo荞݋ */
    uint32_t EVD2:1;			/*!< ޯ    10: 2یo荞݋ */
    uint32_t EVD3:1;			/*!< ޯ    11: 3یo荞݋ */
    uint32_t EVD4:1;			/*!< ޯ    12: 4یo荞݋ */
    uint32_t EVD5:1;			/*!< ޯ    13: 5یo荞݋ */
    uint32_t EVD6:1;			/*!< ޯ    14: 6یo荞݋ */
    uint32_t EVD7:1;			/*!< ޯ    15: 7یo荞݋ */
    uint32_t OVR8:1;			/*!< ޯ    16: 8ް݊荞݋ */
    uint32_t OVR9:1;			/*!< ޯ    17: 9ް݊荞݋ */
    uint32_t OVR10:1;			/*!< ޯ    18: 10ް݊荞݋ */
    uint32_t OVR11:1;			/*!< ޯ    19: 11ް݊荞݋ */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t EVD8:1;			/*!< ޯ    24: 8یo荞݋ */
    uint32_t EVD9:1;			/*!< ޯ    25: 9یo荞݋ */
    uint32_t EVD10:1;			/*!< ޯ    26: 10یo荞݋ */
    uint32_t EVD11:1;			/*!< ޯ    27: 11یo荞݋ */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t OVR:8;				/*!< ޯ 0` 7: xް݊荞݋ */
    uint32_t EVD:8;				/*!< ޯ 8`15: xیo荞݋ */
    uint32_t OVRp8:4;			/*!< ޯ16`19: x+8ް݊荞݋ */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t EVDp8:4;			/*!< ޯ24`27: x+8یo荞݋ */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_INTENSET_OFFSET					0x14			/**< \brief (EVSYS_INTENSET offset)荞݋ݒ */
#define EVSYS_INTENSET_RESETVALUE				0x00000000			/**< \brief (EVSYS_INTENSET reset_value)荞݋ݒ */

#define EVSYS_INTENSET_OVR0_Pos					0				/**< \brief (EVSYS_INTENSET)0ް݊荞݋ */
#define EVSYS_INTENSET_OVR0						(1 << EVSYS_INTENSET_OVR0_Pos)
#define EVSYS_INTENSET_OVR1_Pos					1				/**< \brief (EVSYS_INTENSET)1ް݊荞݋ */
#define EVSYS_INTENSET_OVR1						(1 << EVSYS_INTENSET_OVR1_Pos)
#define EVSYS_INTENSET_OVR2_Pos					2				/**< \brief (EVSYS_INTENSET)2ް݊荞݋ */
#define EVSYS_INTENSET_OVR2						(1 << EVSYS_INTENSET_OVR2_Pos)
#define EVSYS_INTENSET_OVR3_Pos					3				/**< \brief (EVSYS_INTENSET)3ް݊荞݋ */
#define EVSYS_INTENSET_OVR3						(1 << EVSYS_INTENSET_OVR3_Pos)
#define EVSYS_INTENSET_OVR4_Pos					4				/**< \brief (EVSYS_INTENSET)4ް݊荞݋ */
#define EVSYS_INTENSET_OVR4						(1 << EVSYS_INTENSET_OVR4_Pos)
#define EVSYS_INTENSET_OVR5_Pos					5				/**< \brief (EVSYS_INTENSET)5ް݊荞݋ */
#define EVSYS_INTENSET_OVR5						(1 << EVSYS_INTENSET_OVR5_Pos)
#define EVSYS_INTENSET_OVR6_Pos					6				/**< \brief (EVSYS_INTENSET)6ް݊荞݋ */
#define EVSYS_INTENSET_OVR6						(1 << EVSYS_INTENSET_OVR6_Pos)
#define EVSYS_INTENSET_OVR7_Pos					7				/**< \brief (EVSYS_INTENSET)7ް݊荞݋ */
#define EVSYS_INTENSET_OVR7						(1 << EVSYS_INTENSET_OVR7_Pos)
#define EVSYS_INTENSET_OVR_Pos					0				/**< \brief (EVSYS_INTENSET)xް݊荞݋ */
#define EVSYS_INTENSET_OVR_Msk					(0xFFu << EVSYS_INTENSET_OVR_Pos)
#define EVSYS_INTENSET_OVR(value)				((EVSYS_INTENSET_OVR_Msk & ((value) << EVSYS_INTENSET_OVR_Pos)))
#define EVSYS_INTENSET_EVD0_Pos					8				/**< \brief (EVSYS_INTENSET)0یo荞݋ */
#define EVSYS_INTENSET_EVD0						(1 << EVSYS_INTENSET_EVD0_Pos)
#define EVSYS_INTENSET_EVD1_Pos					9				/**< \brief (EVSYS_INTENSET)1یo荞݋ */
#define EVSYS_INTENSET_EVD1						(1 << EVSYS_INTENSET_EVD1_Pos)
#define EVSYS_INTENSET_EVD2_Pos					10				/**< \brief (EVSYS_INTENSET)2یo荞݋ */
#define EVSYS_INTENSET_EVD2						(1 << EVSYS_INTENSET_EVD2_Pos)
#define EVSYS_INTENSET_EVD3_Pos					11				/**< \brief (EVSYS_INTENSET)3یo荞݋ */
#define EVSYS_INTENSET_EVD3						(1 << EVSYS_INTENSET_EVD3_Pos)
#define EVSYS_INTENSET_EVD4_Pos					12				/**< \brief (EVSYS_INTENSET)4یo荞݋ */
#define EVSYS_INTENSET_EVD4						(1 << EVSYS_INTENSET_EVD4_Pos)
#define EVSYS_INTENSET_EVD5_Pos					13				/**< \brief (EVSYS_INTENSET)5یo荞݋ */
#define EVSYS_INTENSET_EVD5						(1 << EVSYS_INTENSET_EVD5_Pos)
#define EVSYS_INTENSET_EVD6_Pos					14				/**< \brief (EVSYS_INTENSET)6یo荞݋ */
#define EVSYS_INTENSET_EVD6						(1 << EVSYS_INTENSET_EVD6_Pos)
#define EVSYS_INTENSET_EVD7_Pos					15				/**< \brief (EVSYS_INTENSET)7یo荞݋ */
#define EVSYS_INTENSET_EVD7						(1 << EVSYS_INTENSET_EVD7_Pos)
#define EVSYS_INTENSET_EVD_Pos					8				/**< \brief (EVSYS_INTENSET)xیo荞݋ */
#define EVSYS_INTENSET_EVD_Msk					(0xFFu << EVSYS_INTENSET_EVD_Pos)
#define EVSYS_INTENSET_EVD(value)				((EVSYS_INTENSET_EVD_Msk & ((value) << EVSYS_INTENSET_EVD_Pos)))
#define EVSYS_INTENSET_OVR8_Pos					16				/**< \brief (EVSYS_INTENSET)8ް݊荞݋ */
#define EVSYS_INTENSET_OVR8						(1 << EVSYS_INTENSET_OVR8_Pos)
#define EVSYS_INTENSET_OVR9_Pos					17				/**< \brief (EVSYS_INTENSET)9ް݊荞݋ */
#define EVSYS_INTENSET_OVR9						(1 << EVSYS_INTENSET_OVR9_Pos)
#define EVSYS_INTENSET_OVR10_Pos				18				/**< \brief (EVSYS_INTENSET)10ް݊荞݋ */
#define EVSYS_INTENSET_OVR10					(1 << EVSYS_INTENSET_OVR10_Pos)
#define EVSYS_INTENSET_OVR11_Pos				19				/**< \brief (EVSYS_INTENSET)11ް݊荞݋ */
#define EVSYS_INTENSET_OVR11					(1 << EVSYS_INTENSET_OVR11_Pos)
#define EVSYS_INTENSET_OVRp8_Pos				16				/**< \brief (EVSYS_INTENSET)x+8ް݊荞݋ */
#define EVSYS_INTENSET_OVRp8_Msk				(0xFu << EVSYS_INTENSET_OVRp8_Pos)
#define EVSYS_INTENSET_OVRp8(value)				((EVSYS_INTENSET_OVRp8_Msk & ((value) << EVSYS_INTENSET_OVRp8_Pos)))
#define EVSYS_INTENSET_EVD8_Pos					24				/**< \brief (EVSYS_INTENSET)8یo荞݋ */
#define EVSYS_INTENSET_EVD8						(1 << EVSYS_INTENSET_EVD8_Pos)
#define EVSYS_INTENSET_EVD9_Pos					25				/**< \brief (EVSYS_INTENSET)9یo荞݋ */
#define EVSYS_INTENSET_EVD9						(1 << EVSYS_INTENSET_EVD9_Pos)
#define EVSYS_INTENSET_EVD10_Pos				26				/**< \brief (EVSYS_INTENSET)10یo荞݋ */
#define EVSYS_INTENSET_EVD10					(1 << EVSYS_INTENSET_EVD10_Pos)
#define EVSYS_INTENSET_EVD11_Pos				27				/**< \brief (EVSYS_INTENSET)11یo荞݋ */
#define EVSYS_INTENSET_EVD11					(1 << EVSYS_INTENSET_EVD11_Pos)
#define EVSYS_INTENSET_EVDp8_Pos				24				/**< \brief (EVSYS_INTENSET)x+8یo荞݋ */
#define EVSYS_INTENSET_EVDp8_Msk				(0xFu << EVSYS_INTENSET_EVDp8_Pos)
#define EVSYS_INTENSET_EVDp8(value)				((EVSYS_INTENSET_EVDp8_Msk & ((value) << EVSYS_INTENSET_EVDp8_Pos)))
#define EVSYS_INTENSET_MASK						0x0F0FFFFFu			/**< \brief (EVSYS_INTENSET)Օڼ޽ */

/* -------- EVSYS_INTFLAG : (EVSYSψ:0x18) (R/W 32)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t OVR0:1;			/*!< ޯ     0: 0ް */
    uint32_t OVR1:1;			/*!< ޯ     1: 1ް */
    uint32_t OVR2:1;			/*!< ޯ     2: 2ް */
    uint32_t OVR3:1;			/*!< ޯ     3: 3ް */
    uint32_t OVR4:1;			/*!< ޯ     4: 4ް */
    uint32_t OVR5:1;			/*!< ޯ     5: 5ް */
    uint32_t OVR6:1;			/*!< ޯ     6: 6ް */
    uint32_t OVR7:1;			/*!< ޯ     7: 7ް */
    uint32_t EVD0:1;			/*!< ޯ     8: 0یo */
    uint32_t EVD1:1;			/*!< ޯ     9: 1یo */
    uint32_t EVD2:1;			/*!< ޯ    10: 2یo */
    uint32_t EVD3:1;			/*!< ޯ    11: 3یo */
    uint32_t EVD4:1;			/*!< ޯ    12: 4یo */
    uint32_t EVD5:1;			/*!< ޯ    13: 5یo */
    uint32_t EVD6:1;			/*!< ޯ    14: 6یo */
    uint32_t EVD7:1;			/*!< ޯ    15: 7یo */
    uint32_t OVR8:1;			/*!< ޯ    16: 8ް */
    uint32_t OVR9:1;			/*!< ޯ    17: 9ް */
    uint32_t OVR10:1;			/*!< ޯ    18: 10ް */
    uint32_t OVR11:1;			/*!< ޯ    19: 11ް */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t EVD8:1;			/*!< ޯ    24: 8یo */
    uint32_t EVD9:1;			/*!< ޯ    25: 9یo */
    uint32_t EVD10:1;			/*!< ޯ    26: 10یo */
    uint32_t EVD11:1;			/*!< ޯ    27: 11یo */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t OVR:8;				/*!< ޯ 0` 7: xް */
    uint32_t EVD:8;				/*!< ޯ 8`15: xیo */
    uint32_t OVRp8:4;			/*!< ޯ16`19: x+8ް */
    uint32_t :4;				/*!< ޯ20`23: \ */
    uint32_t EVDp8:4;			/*!< ޯ24`27: x+8یo */
    uint32_t :4;				/*!< ޯ28`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EVSYS_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EVSYS_INTFLAG_OFFSET					0x18			/**< \brief (EVSYS_INTFLAG offset)荞׸ޏ/ */
#define EVSYS_INTFLAG_RESETVALUE				0x00000000		/**< \brief (EVSYS_INTFLAG reset_value)荞׸ޏ/ */

#define EVSYS_INTFLAG_OVR0_Pos					0				/**< \brief (EVSYS_INTFLAG)0ް */
#define EVSYS_INTFLAG_OVR0						(1 << EVSYS_INTFLAG_OVR0_Pos)
#define EVSYS_INTFLAG_OVR1_Pos					1				/**< \brief (EVSYS_INTFLAG)1ް */
#define EVSYS_INTFLAG_OVR1						(1 << EVSYS_INTFLAG_OVR1_Pos)
#define EVSYS_INTFLAG_OVR2_Pos					2				/**< \brief (EVSYS_INTFLAG)2ް */
#define EVSYS_INTFLAG_OVR2						(1 << EVSYS_INTFLAG_OVR2_Pos)
#define EVSYS_INTFLAG_OVR3_Pos					3				/**< \brief (EVSYS_INTFLAG)3ް */
#define EVSYS_INTFLAG_OVR3						(1 << EVSYS_INTFLAG_OVR3_Pos)
#define EVSYS_INTFLAG_OVR4_Pos					4				/**< \brief (EVSYS_INTFLAG)4ް */
#define EVSYS_INTFLAG_OVR4						(1 << EVSYS_INTFLAG_OVR4_Pos)
#define EVSYS_INTFLAG_OVR5_Pos					5				/**< \brief (EVSYS_INTFLAG)5ް */
#define EVSYS_INTFLAG_OVR5						(1 << EVSYS_INTFLAG_OVR5_Pos)
#define EVSYS_INTFLAG_OVR6_Pos					6				/**< \brief (EVSYS_INTFLAG)6ް */
#define EVSYS_INTFLAG_OVR6						(1 << EVSYS_INTFLAG_OVR6_Pos)
#define EVSYS_INTFLAG_OVR7_Pos					7				/**< \brief (EVSYS_INTFLAG)7ް */
#define EVSYS_INTFLAG_OVR7						(1 << EVSYS_INTFLAG_OVR7_Pos)
#define EVSYS_INTFLAG_OVR_Pos					0				/**< \brief (EVSYS_INTFLAG)xް */
#define EVSYS_INTFLAG_OVR_Msk					(0xFFu << EVSYS_INTFLAG_OVR_Pos)
#define EVSYS_INTFLAG_OVR(value)				((EVSYS_INTFLAG_OVR_Msk & ((value) << EVSYS_INTFLAG_OVR_Pos)))
#define EVSYS_INTFLAG_EVD0_Pos					8				/**< \brief (EVSYS_INTFLAG)0یo */
#define EVSYS_INTFLAG_EVD0						(1 << EVSYS_INTFLAG_EVD0_Pos)
#define EVSYS_INTFLAG_EVD1_Pos					9				/**< \brief (EVSYS_INTFLAG)1یo */
#define EVSYS_INTFLAG_EVD1						(1 << EVSYS_INTFLAG_EVD1_Pos)
#define EVSYS_INTFLAG_EVD2_Pos					10				/**< \brief (EVSYS_INTFLAG)2یo */
#define EVSYS_INTFLAG_EVD2						(1 << EVSYS_INTFLAG_EVD2_Pos)
#define EVSYS_INTFLAG_EVD3_Pos					11				/**< \brief (EVSYS_INTFLAG)3یo */
#define EVSYS_INTFLAG_EVD3						(1 << EVSYS_INTFLAG_EVD3_Pos)
#define EVSYS_INTFLAG_EVD4_Pos					12				/**< \brief (EVSYS_INTFLAG)4یo */
#define EVSYS_INTFLAG_EVD4						(1 << EVSYS_INTFLAG_EVD4_Pos)
#define EVSYS_INTFLAG_EVD5_Pos					13				/**< \brief (EVSYS_INTFLAG)5یo */
#define EVSYS_INTFLAG_EVD5						(1 << EVSYS_INTFLAG_EVD5_Pos)
#define EVSYS_INTFLAG_EVD6_Pos					14				/**< \brief (EVSYS_INTFLAG)6یo */
#define EVSYS_INTFLAG_EVD6						(1 << EVSYS_INTFLAG_EVD6_Pos)
#define EVSYS_INTFLAG_EVD7_Pos					15				/**< \brief (EVSYS_INTFLAG)7یo */
#define EVSYS_INTFLAG_EVD7						(1 << EVSYS_INTFLAG_EVD7_Pos)
#define EVSYS_INTFLAG_EVD_Pos					8				/**< \brief (EVSYS_INTFLAG)xیo */
#define EVSYS_INTFLAG_EVD_Msk					(0xFFu << EVSYS_INTFLAG_EVD_Pos)
#define EVSYS_INTFLAG_EVD(value)				((EVSYS_INTFLAG_EVD_Msk & ((value) << EVSYS_INTFLAG_EVD_Pos)))
#define EVSYS_INTFLAG_OVR8_Pos					16				/**< \brief (EVSYS_INTFLAG)8ް */
#define EVSYS_INTFLAG_OVR8						(1 << EVSYS_INTFLAG_OVR8_Pos)
#define EVSYS_INTFLAG_OVR9_Pos					17				/**< \brief (EVSYS_INTFLAG)9ް */
#define EVSYS_INTFLAG_OVR9						(1 << EVSYS_INTFLAG_OVR9_Pos)
#define EVSYS_INTFLAG_OVR10_Pos					18				/**< \brief (EVSYS_INTFLAG)10ް */
#define EVSYS_INTFLAG_OVR10						(1 << EVSYS_INTFLAG_OVR10_Pos)
#define EVSYS_INTFLAG_OVR11_Pos					19				/**< \brief (EVSYS_INTFLAG)11ް */
#define EVSYS_INTFLAG_OVR11						(1 << EVSYS_INTFLAG_OVR11_Pos)
#define EVSYS_INTFLAG_OVRp8_Pos					16				/**< \brief (EVSYS_INTFLAG)x+8ް */
#define EVSYS_INTFLAG_OVRp8_Msk					(0xFu << EVSYS_INTFLAG_OVRp8_Pos)
#define EVSYS_INTFLAG_OVRp8(value)				((EVSYS_INTFLAG_OVRp8_Msk & ((value) << EVSYS_INTFLAG_OVRp8_Pos)))
#define EVSYS_INTFLAG_EVD8_Pos					24				/**< \brief (EVSYS_INTFLAG)8یo */
#define EVSYS_INTFLAG_EVD8						(1 << EVSYS_INTFLAG_EVD8_Pos)
#define EVSYS_INTFLAG_EVD9_Pos					25				/**< \brief (EVSYS_INTFLAG)9یo */
#define EVSYS_INTFLAG_EVD9						(1 << EVSYS_INTFLAG_EVD9_Pos)
#define EVSYS_INTFLAG_EVD10_Pos					26				/**< \brief (EVSYS_INTFLAG)10یo */
#define EVSYS_INTFLAG_EVD10						(1 << EVSYS_INTFLAG_EVD10_Pos)
#define EVSYS_INTFLAG_EVD11_Pos					27				/**< \brief (EVSYS_INTFLAG)11یo */
#define EVSYS_INTFLAG_EVD11						(1 << EVSYS_INTFLAG_EVD11_Pos)
#define EVSYS_INTFLAG_EVDp8_Pos					24				/**< \brief (EVSYS_INTFLAG)x+8یo */
#define EVSYS_INTFLAG_EVDp8_Msk					(0xFu << EVSYS_INTFLAG_EVDp8_Pos)
#define EVSYS_INTFLAG_EVDp8(value)				((EVSYS_INTFLAG_EVDp8_Msk & ((value) << EVSYS_INTFLAG_EVDp8_Pos)))
#define EVSYS_INTFLAG_MASK						0x0F0FFFFFu			/**< \brief (EVSYS_INTFLAG)Օڼ޽ */

/** \brief EVSYSʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __O  EVSYS_CTRL_Type		CTRL;			/**< \briefψ:0x00 ( /W  8) */
	   RoReg8				Reserved1[0x3];
  __IO EVSYS_CHANNEL_Type	CHANNEL;		/**< \briefψ:0x04 (R/W 32) */
  __IO EVSYS_USER_Type		USER;			/**< \briefψ:0x08 (R/W 16)gpd */
	   RoReg8				Reserved2[0x2];
  __I  EVSYS_CHSTATUS_Type	CHSTATUS;		/**< \briefψ:0x0C (R/  32)ُ */
  __IO EVSYS_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x10 (R/W 32)荞݋ */
  __IO EVSYS_INTENSET_Type	INTENSET;		/**< \briefψ:0x14 (R/W 32)荞݋ݒ */
  __IO EVSYS_INTFLAG_Type	INTFLAG;		/**< \briefψ:0x18 (R/W 32)荞׸ޏ/ */
} Evsys;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_EVSYS_COMPONENT_ */
