/**
 * \file
 *
 * \brief PMp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_PM_COMPONENT_
#define _SAMD21_PM_COMPONENT_

/* ========================================================================== */
/** PMpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_PM d͊Ǘ */
/*@{*/

#define PM_U2206
#define REV_PM						0x201

/* -------- PM_CTRL : (PMψ:0x00) (R/W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :2;				/*!< ޯ0`1: \ */
    uint8_t  CFDEN:1;			/*!< ޯ   2: ۯQo */
    uint8_t  :1;				/*!< ޯ   3: \ */
    uint8_t  BKUPCLK:1;			/*!< ޯ   4: ָۯI */
    uint8_t  :3;				/*!< ޯ5`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_CTRL_OFFSET				0x00			/**< \brief (PM_CTRL offset) */
#define PM_CTRL_RESETVALUE			0x00			/**< \brief (PM_CTRL reset_value) */

#define PM_CTRL_CFDEN_Pos			2				/**< \brief (PM_CTRL)ۯQo */
#define PM_CTRL_CFDEN				(0x1u << PM_CTRL_CFDEN_Pos)
#define PM_CTRL_BKUPCLK_Pos			4				/**< \brief (PM_CTRL)ָۯI */
#define PM_CTRL_BKUPCLK				(0x1u << PM_CTRL_BKUPCLK_Pos)
#define PM_CTRL_MASK				0x14u			/**< \brief (PM_CTRL)Օڼ޽ */

/* -------- PM_SLEEP : (PMψ:0x01) (R/W  8)x~ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  IDLE:2;			/*!< ޯ0`1: ٓ`Ԑݒ */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_SLEEP_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_SLEEP_OFFSET				0x01			/**< \brief (PM_SLEEP offset)x~ */
#define PM_SLEEP_RESETVALUE			0x00			/**< \brief (PM_SLEEP reset_value)x~ */

#define PM_SLEEP_IDLE_Pos			0				/**< \brief (PM_SLEEP)ٓ`Ԑݒ */
#define PM_SLEEP_IDLE_Msk			(0x3u << PM_SLEEP_IDLE_Pos)
#define PM_SLEEP_IDLE(value)		((PM_SLEEP_IDLE_Msk & ((value) << PM_SLEEP_IDLE_Pos)))
#define   PM_SLEEP_IDLE_CPU_Val			0x0u		/**< \brief (PM_SLEEP)CPUۯ̈~ */
#define   PM_SLEEP_IDLE_AHB_Val			0x1u		/**< \brief (PM_SLEEP)CPUAHBۯ̈~ */
#define   PM_SLEEP_IDLE_APB_Val			0x2u		/**< \brief (PM_SLEEP)CPU,AHB,APBۯ̈~ */
#define PM_SLEEP_IDLE_CPU			(PM_SLEEP_IDLE_CPU_Val << PM_SLEEP_IDLE_Pos)
#define PM_SLEEP_IDLE_AHB			(PM_SLEEP_IDLE_AHB_Val << PM_SLEEP_IDLE_Pos)
#define PM_SLEEP_IDLE_APB			(PM_SLEEP_IDLE_APB_Val << PM_SLEEP_IDLE_Pos)
#define PM_SLEEP_MASK				0x03u			/**< \brief (PM_SLEEP)Օڼ޽ */

/* -------- PM_CPUSEL : (PMψ:0x08) (R/W  8)CPUۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CPUDIV:3;			/*!< ޯ0`2: CPUOuI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_CPUSEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_CPUSEL_OFFSET			0x08			/**< \brief (PM_CPUSEL offset)CPUۯI */
#define PM_CPUSEL_RESETVALUE		0x00			/**< \brief (PM_CPUSEL reset_value)CPUۯI */

#define PM_CPUSEL_CPUDIV_Pos		0				/**< \brief (PM_CPUSEL)CPUOuI */
#define PM_CPUSEL_CPUDIV_Msk		(0x7u << PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV(value)		((PM_CPUSEL_CPUDIV_Msk & ((value) << PM_CPUSEL_CPUDIV_Pos)))
#define   PM_CPUSEL_CPUDIV_DIV1_Val		0x0u		/**< \brief (PM_CPUSEL)1 */
#define   PM_CPUSEL_CPUDIV_DIV2_Val		0x1u		/**< \brief (PM_CPUSEL)2 */
#define   PM_CPUSEL_CPUDIV_DIV4_Val		0x2u		/**< \brief (PM_CPUSEL)4 */
#define   PM_CPUSEL_CPUDIV_DIV8_Val		0x3u		/**< \brief (PM_CPUSEL)8 */
#define   PM_CPUSEL_CPUDIV_DIV16_Val	0x4u		/**< \brief (PM_CPUSEL)16 */
#define   PM_CPUSEL_CPUDIV_DIV32_Val	0x5u		/**< \brief (PM_CPUSEL)32 */
#define   PM_CPUSEL_CPUDIV_DIV64_Val	0x6u		/**< \brief (PM_CPUSEL)64 */
#define   PM_CPUSEL_CPUDIV_DIV128_Val	0x7u		/**< \brief (PM_CPUSEL)128 */
#define PM_CPUSEL_CPUDIV_DIV1		(PM_CPUSEL_CPUDIV_DIV1_Val		<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV_DIV2		(PM_CPUSEL_CPUDIV_DIV2_Val		<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV_DIV4		(PM_CPUSEL_CPUDIV_DIV4_Val		<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV_DIV8		(PM_CPUSEL_CPUDIV_DIV8_Val		<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV_DIV16		(PM_CPUSEL_CPUDIV_DIV16_Val		<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV_DIV32		(PM_CPUSEL_CPUDIV_DIV32_Val		<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV_DIV64		(PM_CPUSEL_CPUDIV_DIV64_Val		<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_CPUDIV_DIV128		(PM_CPUSEL_CPUDIV_DIV128_Val	<< PM_CPUSEL_CPUDIV_Pos)
#define PM_CPUSEL_MASK				0x07u			/**< \brief (PM_CPUSEL)Օڼ޽ */

/* -------- PM_APBASEL : (PMψ:0x09) (R/W  8)APBAۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  APBADIV:3;			/*!< ޯ0`2: APBAOuI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBASEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBASEL_OFFSET			0x09			/**< \brief (PM_APBASEL offset)APBAۯI */
#define PM_APBASEL_RESETVALUE		0x00			/**< \brief (PM_APBASEL reset_value)APBAۯI */

#define PM_APBASEL_APBADIV_Pos		0				/**< \brief (PM_APBASEL)APBAOuI */
#define PM_APBASEL_APBADIV_Msk		(0x7u << PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV(value)	((PM_APBASEL_APBADIV_Msk & ((value) << PM_APBASEL_APBADIV_Pos)))
#define   PM_APBASEL_APBADIV_DIV1_Val	0x0u		/**< \brief (PM_APBASEL)1 */
#define   PM_APBASEL_APBADIV_DIV2_Val	0x1u		/**< \brief (PM_APBASEL)2 */
#define   PM_APBASEL_APBADIV_DIV4_Val	0x2u		/**< \brief (PM_APBASEL)4 */
#define   PM_APBASEL_APBADIV_DIV8_Val	0x3u		/**< \brief (PM_APBASEL)8 */
#define   PM_APBASEL_APBADIV_DIV16_Val	0x4u		/**< \brief (PM_APBASEL)16 */
#define   PM_APBASEL_APBADIV_DIV32_Val	0x5u		/**< \brief (PM_APBASEL)32 */
#define   PM_APBASEL_APBADIV_DIV64_Val	0x6u		/**< \brief (PM_APBASEL)64 */
#define   PM_APBASEL_APBADIV_DIV128_Val	0x7u		/**< \brief (PM_APBASEL)128 */
#define PM_APBASEL_APBADIV_DIV1		(PM_APBASEL_APBADIV_DIV1_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV_DIV2		(PM_APBASEL_APBADIV_DIV2_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV_DIV4		(PM_APBASEL_APBADIV_DIV4_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV_DIV8		(PM_APBASEL_APBADIV_DIV8_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV_DIV16	(PM_APBASEL_APBADIV_DIV16_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV_DIV32	(PM_APBASEL_APBADIV_DIV32_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV_DIV64	(PM_APBASEL_APBADIV_DIV64_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_APBADIV_DIV128	(PM_APBASEL_APBADIV_DIV128_Val	<< PM_APBASEL_APBADIV_Pos)
#define PM_APBASEL_MASK				0x07u			/**< \brief (PM_APBASEL)Օڼ޽ */

/* -------- PM_APBBSEL : (PMψ:0x0A) (R/W  8)APBBۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  APBBDIV:3;			/*!< ޯ0`2: APBBOuI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBBSEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBBSEL_OFFSET			0x0A			/**< \brief (PM_APBBSEL offset)APBBۯI */
#define PM_APBBSEL_RESETVALUE		0x00			/**< \brief (PM_APBBSEL reset_value)APBBۯI */

#define PM_APBBSEL_APBBDIV_Pos		0				/**< \brief (PM_APBBSEL)APBBOuI */
#define PM_APBBSEL_APBBDIV_Msk		(0x7u << PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV(value)	((PM_APBBSEL_APBBDIV_Msk & ((value) << PM_APBBSEL_APBBDIV_Pos)))
#define   PM_APBBSEL_APBBDIV_DIV1_Val	0x0u		/**< \brief (PM_APBBSEL)1 */
#define   PM_APBBSEL_APBBDIV_DIV2_Val	0x1u		/**< \brief (PM_APBBSEL)2 */
#define   PM_APBBSEL_APBBDIV_DIV4_Val	0x2u		/**< \brief (PM_APBBSEL)4 */
#define   PM_APBBSEL_APBBDIV_DIV8_Val	0x3u		/**< \brief (PM_APBBSEL)8 */
#define   PM_APBBSEL_APBBDIV_DIV16_Val	0x4u		/**< \brief (PM_APBBSEL)16 */
#define   PM_APBBSEL_APBBDIV_DIV32_Val	0x5u		/**< \brief (PM_APBBSEL)32 */
#define   PM_APBBSEL_APBBDIV_DIV64_Val	0x6u		/**< \brief (PM_APBBSEL)64 */
#define   PM_APBBSEL_APBBDIV_DIV128_Val	0x7u		/**< \brief (PM_APBBSEL)128 */
#define PM_APBBSEL_APBBDIV_DIV1		(PM_APBBSEL_APBBDIV_DIV1_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV_DIV2		(PM_APBBSEL_APBBDIV_DIV2_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV_DIV4		(PM_APBBSEL_APBBDIV_DIV4_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV_DIV8		(PM_APBBSEL_APBBDIV_DIV8_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV_DIV16	(PM_APBBSEL_APBBDIV_DIV16_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV_DIV32	(PM_APBBSEL_APBBDIV_DIV32_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV_DIV64	(PM_APBBSEL_APBBDIV_DIV64_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_APBBDIV_DIV128	(PM_APBBSEL_APBBDIV_DIV128_Val	<< PM_APBBSEL_APBBDIV_Pos)
#define PM_APBBSEL_MASK				0x07u			/**< \brief (PM_APBBSEL)Օڼ޽ */

/* -------- PM_APBCSEL : (PMψ:0x0B) (R/W  8)APBCۯI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  APBCDIV:3;			/*!< ޯ0`2: APBCOuI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBCSEL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBCSEL_OFFSET			0x0B			/**< \brief (PM_APBCSEL offset)APBCۯI */
#define PM_APBCSEL_RESETVALUE		0x00			/**< \brief (PM_APBCSEL reset_value)APBCۯI */

#define PM_APBCSEL_APBCDIV_Pos		0				/**< \brief (PM_APBCSEL)APBCOuI */
#define PM_APBCSEL_APBCDIV_Msk		(0x7u << PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV(value)	((PM_APBCSEL_APBCDIV_Msk & ((value) << PM_APBCSEL_APBCDIV_Pos)))
#define   PM_APBCSEL_APBCDIV_DIV1_Val	0x0u		/**< \brief (PM_APBCSEL)1 */
#define   PM_APBCSEL_APBCDIV_DIV2_Val	0x1u		/**< \brief (PM_APBCSEL)2 */
#define   PM_APBCSEL_APBCDIV_DIV4_Val	0x2u		/**< \brief (PM_APBCSEL)4 */
#define   PM_APBCSEL_APBCDIV_DIV8_Val	0x3u		/**< \brief (PM_APBCSEL)8 */
#define   PM_APBCSEL_APBCDIV_DIV16_Val	0x4u		/**< \brief (PM_APBCSEL)16 */
#define   PM_APBCSEL_APBCDIV_DIV32_Val	0x5u		/**< \brief (PM_APBCSEL)32 */
#define   PM_APBCSEL_APBCDIV_DIV64_Val	0x6u		/**< \brief (PM_APBCSEL)64 */
#define   PM_APBCSEL_APBCDIV_DIV128_Val	0x7u		/**< \brief (PM_APBCSEL)128 */
#define PM_APBCSEL_APBCDIV_DIV1		(PM_APBCSEL_APBCDIV_DIV1_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV_DIV2		(PM_APBCSEL_APBCDIV_DIV2_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV_DIV4		(PM_APBCSEL_APBCDIV_DIV4_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV_DIV8		(PM_APBCSEL_APBCDIV_DIV8_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV_DIV16	(PM_APBCSEL_APBCDIV_DIV16_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV_DIV32	(PM_APBCSEL_APBCDIV_DIV32_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV_DIV64	(PM_APBCSEL_APBCDIV_DIV64_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_APBCDIV_DIV128	(PM_APBCSEL_APBCDIV_DIV128_Val	<< PM_APBCSEL_APBCDIV_Pos)
#define PM_APBCSEL_MASK				0x07u			/**< \brief (PM_APBCSEL)Օڼ޽ */

/* -------- PM_AHBMASK : (PMψ:0x14) (R/W 32)AHBՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t HPB0:1;			/*!< ޯ    0: HPB0 AHBۯ */
    uint32_t HPB1:1;			/*!< ޯ    1: HPB1 AHBۯ */
    uint32_t HPB2:1;			/*!< ޯ    2: HPB2 AHBۯ */
    uint32_t DSU:1;				/*!< ޯ    3: DSU AHBۯ */
    uint32_t NVMCTRL:1;			/*!< ޯ    4: NVMCTRL AHBۯ */
    uint32_t DMAC:1;			/*!< ޯ    5: DMAC AHBۯ */
    uint32_t USB:1;				/*!< ޯ    6: USB AHBۯ */
    uint32_t :25;				/*!< ޯ7`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_AHBMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_AHBMASK_OFFSET			0x14			/**< \brief (PM_AHBMASK offset)AHBՕ */
#define PM_AHBMASK_RESETVALUE		0x0000007F		/**< \brief (PM_AHBMASK reset_value)AHBՕ */

#define PM_AHBMASK_HPB0_Pos			0				/**< \brief (PM_AHBMASK)HPB0 AHBۯ */
#define PM_AHBMASK_HPB0				(0x1u << PM_AHBMASK_HPB0_Pos)
#define PM_AHBMASK_HPB1_Pos			1				/**< \brief (PM_AHBMASK)HPB1 AHBۯ */
#define PM_AHBMASK_HPB1				(0x1u << PM_AHBMASK_HPB1_Pos)
#define PM_AHBMASK_HPB2_Pos			2				/**< \brief (PM_AHBMASK)HPB2 AHBۯ */
#define PM_AHBMASK_HPB2				(0x1u << PM_AHBMASK_HPB2_Pos)
#define PM_AHBMASK_DSU_Pos			3				/**< \brief (PM_AHBMASK)DSU AHBۯ */
#define PM_AHBMASK_DSU				(0x1u << PM_AHBMASK_DSU_Pos)
#define PM_AHBMASK_NVMCTRL_Pos		4				/**< \brief (PM_AHBMASK)NVMCTRL AHBۯ */
#define PM_AHBMASK_NVMCTRL			(0x1u << PM_AHBMASK_NVMCTRL_Pos)
#define PM_AHBMASK_DMAC_Pos			5				/**< \brief (PM_AHBMASK)DMAC AHBۯ */
#define PM_AHBMASK_DMAC				(0x1u << PM_AHBMASK_DMAC_Pos)
#define PM_AHBMASK_USB_Pos			6				/**< \brief (PM_AHBMASK)USB AHBۯ */
#define PM_AHBMASK_USB				(0x1u << PM_AHBMASK_USB_Pos)
#define PM_AHBMASK_MASK				0x0000007Fu		/**< \brief (PM_AHBMASK)Օڼ޽ */

/* -------- PM_APBAMASK : (PMψ:0x18) (R/W 32)APBAՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PAC0:1;			/*!< ޯ    0: PAC0 APBۯ */
    uint32_t PM:1;				/*!< ޯ    1: PM APBۯ */
    uint32_t SYSCTRL:1;			/*!< ޯ    2: SYSCTRL APBۯ */
    uint32_t GCLK:1;			/*!< ޯ    3: GCLK APBۯ */
    uint32_t WDT:1;				/*!< ޯ    4: WDT APBۯ */
    uint32_t RTC:1;				/*!< ޯ    5: RTC APBۯ */
    uint32_t EIC:1;				/*!< ޯ    6: EIC APBۯ */
    uint32_t :25;				/*!< ޯ7`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBAMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBAMASK_OFFSET			0x18			/**< \brief (PM_APBAMASK offset)APBAՕ */
#define PM_APBAMASK_RESETVALUE		0x0000007F		/**< \brief (PM_APBAMASK reset_value)APBAՕ */

#define PM_APBAMASK_PAC0_Pos		0				/**< \brief (PM_APBAMASK)PAC0 APBۯ */
#define PM_APBAMASK_PAC0			(0x1u << PM_APBAMASK_PAC0_Pos)
#define PM_APBAMASK_PM_Pos			1				/**< \brief (PM_APBAMASK)PM APBۯ */
#define PM_APBAMASK_PM				(0x1u << PM_APBAMASK_PM_Pos)
#define PM_APBAMASK_SYSCTRL_Pos		2				/**< \brief (PM_APBAMASK)SYSCTRL APBۯ */
#define PM_APBAMASK_SYSCTRL			(0x1u << PM_APBAMASK_SYSCTRL_Pos)
#define PM_APBAMASK_GCLK_Pos		3				/**< \brief (PM_APBAMASK)GCLK APBۯ */
#define PM_APBAMASK_GCLK			(0x1u << PM_APBAMASK_GCLK_Pos)
#define PM_APBAMASK_WDT_Pos			4				/**< \brief (PM_APBAMASK)WDT APBۯ */
#define PM_APBAMASK_WDT				(0x1u << PM_APBAMASK_WDT_Pos)
#define PM_APBAMASK_RTC_Pos			5				/**< \brief (PM_APBAMASK)RTC APBۯ */
#define PM_APBAMASK_RTC				(0x1u << PM_APBAMASK_RTC_Pos)
#define PM_APBAMASK_EIC_Pos			6				/**< \brief (PM_APBAMASK)EIC APBۯ */
#define PM_APBAMASK_EIC				(0x1u << PM_APBAMASK_EIC_Pos)
#define PM_APBAMASK_MASK			0x0000007Fu		/**< \brief (PM_APBAMASK)Օڼ޽ */

/* -------- PM_APBBMASK : (PMψ:0x1C) (R/W 32)APBBՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PAC1:1;			/*!< ޯ    0: PAC1 APBۯ */
    uint32_t DSU:1;				/*!< ޯ    1: DSU APBۯ */
    uint32_t NVMCTRL:1;			/*!< ޯ    2: NVMCTRL APBۯ */
    uint32_t PORT:1;			/*!< ޯ    3: PORT APBۯ */
    uint32_t DMAC:1;			/*!< ޯ    4: DMAC APBۯ */
    uint32_t USB:1;				/*!< ޯ    5: USB APBۯ */
    uint32_t :26;				/*!< ޯ6`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBBMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBBMASK_OFFSET			0x1C			/**< \brief (PM_APBBMASK offset)APBBՕ */
#define PM_APBBMASK_RESETVALUE		0x0000007F		/**< \brief (PM_APBBMASK reset_value)APBBՕ */

#define PM_APBBMASK_PAC1_Pos		0				/**< \brief (PM_APBBMASK)PAC1 APBۯ */
#define PM_APBBMASK_PAC1			(0x1u << PM_APBBMASK_PAC1_Pos)
#define PM_APBBMASK_DSU_Pos			1				/**< \brief (PM_APBBMASK)DSU APBۯ */
#define PM_APBBMASK_DSU				(0x1u << PM_APBBMASK_DSU_Pos)
#define PM_APBBMASK_NVMCTRL_Pos		2				/**< \brief (PM_APBBMASK)NVMCTRL APBۯ */
#define PM_APBBMASK_NVMCTRL			(0x1u << PM_APBBMASK_NVMCTRL_Pos)
#define PM_APBBMASK_PORT_Pos		3				/**< \brief (PM_APBBMASK)PORT APBۯ */
#define PM_APBBMASK_PORT			(0x1u << PM_APBBMASK_PORT_Pos)
#define PM_APBBMASK_DMAC_Pos		4				/**< \brief (PM_APBBMASK)DMAC APBۯ */
#define PM_APBBMASK_DMAC			(0x1u << PM_APBBMASK_DMAC_Pos)
#define PM_APBBMASK_USB_Pos			5				/**< \brief (PM_APBBMASK)USB APBۯ */
#define PM_APBBMASK_USB				(0x1u << PM_APBBMASK_USB_Pos)
#define PM_APBBMASK_MASK			0x0000003Fu		/**< \brief (PM_APBBMASK)Օڼ޽ */

/* -------- PM_APBCMASK : (PMψ:0x20) (R/W 32)APBCՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PAC2:1;			/*!< ޯ     0: PAC2 APBۯ */
    uint32_t EVSYS:1;			/*!< ޯ     1: EVSYS APBۯ */
    uint32_t SERCOM0:1;			/*!< ޯ     2: SERCOM0 APBۯ */
    uint32_t SERCOM1:1;			/*!< ޯ     3: SERCOM1 APBۯ */
    uint32_t SERCOM2:1;			/*!< ޯ     4: SERCOM2 APBۯ */
    uint32_t SERCOM3:1;			/*!< ޯ     5: SERCOM3 APBۯ */
    uint32_t SERCOM4:1;			/*!< ޯ     6: SERCOM4 APBۯ */
    uint32_t SERCOM5:1;			/*!< ޯ     7: SERCOM5 APBۯ */
    uint32_t TCC0:1;			/*!< ޯ     8: TCC0 APBۯ */
    uint32_t TCC1:1;			/*!< ޯ     9: TCC1 APBۯ */
    uint32_t TCC2:1;			/*!< ޯ    10: TCC2 APBۯ */
    uint32_t TC3:1;				/*!< ޯ    11: TC3 APBۯ */
    uint32_t TC4:1;				/*!< ޯ    12: TC4 APBۯ */
    uint32_t TC5:1;				/*!< ޯ    13: TC5 APBۯ */
    uint32_t TC6:1;				/*!< ޯ    14: TC6 APBۯ */
    uint32_t TC7:1;				/*!< ޯ    15: TC7 APBۯ */
    uint32_t ADC:1;				/*!< ޯ    16: ADC APBۯ */
    uint32_t AC:1;				/*!< ޯ    17: AC APBۯ */
    uint32_t DAC:1;				/*!< ޯ    18: DAC APBۯ */
    uint32_t :1;				/*!< ޯ    19: \ */
    uint32_t I2S:1;				/*!< ޯ    20: I2S APBۯ */
    uint32_t :11;				/*!< ޯ21`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_APBCMASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_APBCMASK_OFFSET			0x20			/**< \brief (PM_APBCMASK offset)APBCՕ */
#define PM_APBCMASK_RESETVALUE		0x00010000		/**< \brief (PM_APBCMASK reset_value)APBCՕ */

#define PM_APBCMASK_PAC2_Pos		0				/**< \brief (PM_APBCMASK)PAC2 APBۯ */
#define PM_APBCMASK_PAC2			(0x1u << PM_APBCMASK_PAC2_Pos)
#define PM_APBCMASK_EVSYS_Pos		1				/**< \brief (PM_APBCMASK)EVSYS APBۯ */
#define PM_APBCMASK_EVSYS			(0x1u << PM_APBCMASK_EVSYS_Pos)
#define PM_APBCMASK_SERCOM0_Pos		2				/**< \brief (PM_APBCMASK)SERCOM0 APBۯ */
#define PM_APBCMASK_SERCOM0			(0x1u << PM_APBCMASK_SERCOM0_Pos)
#define PM_APBCMASK_SERCOM1_Pos		3				/**< \brief (PM_APBCMASK)SERCOM1 APBۯ */
#define PM_APBCMASK_SERCOM1			(0x1u << PM_APBCMASK_SERCOM1_Pos)
#define PM_APBCMASK_SERCOM2_Pos		4				/**< \brief (PM_APBCMASK)SERCOM2 APBۯ */
#define PM_APBCMASK_SERCOM2			(0x1u << PM_APBCMASK_SERCOM2_Pos)
#define PM_APBCMASK_SERCOM3_Pos		5				/**< \brief (PM_APBCMASK)SERCOM3 APBۯ */
#define PM_APBCMASK_SERCOM3			(0x1u << PM_APBCMASK_SERCOM3_Pos)
#define PM_APBCMASK_SERCOM4_Pos		6				/**< \brief (PM_APBCMASK)SERCOM4 APBۯ */
#define PM_APBCMASK_SERCOM4			(0x1u << PM_APBCMASK_SERCOM4_Pos)
#define PM_APBCMASK_SERCOM5_Pos		7				/**< \brief (PM_APBCMASK)SERCOM5 APBۯ */
#define PM_APBCMASK_SERCOM5			(0x1u << PM_APBCMASK_SERCOM5_Pos)
#define PM_APBCMASK_TCC0_Pos		8				/**< \brief (PM_APBCMASK)TCC0 APBۯ */
#define PM_APBCMASK_TCC0			(0x1u << PM_APBCMASK_TCC0_Pos)
#define PM_APBCMASK_TCC1_Pos		9				/**< \brief (PM_APBCMASK)TCC1 APBۯ */
#define PM_APBCMASK_TCC1			(0x1u << PM_APBCMASK_TCC1_Pos)
#define PM_APBCMASK_TCC2_Pos		10				/**< \brief (PM_APBCMASK)TCC2 APBۯ */
#define PM_APBCMASK_TCC2			(0x1u << PM_APBCMASK_TCC2_Pos)
#define PM_APBCMASK_TC3_Pos			11				/**< \brief (PM_APBCMASK)TC3 APBۯ */
#define PM_APBCMASK_TC3				(0x1u << PM_APBCMASK_TC3_Pos)
#define PM_APBCMASK_TC4_Pos			12				/**< \brief (PM_APBCMASK)TC4 APBۯ */
#define PM_APBCMASK_TC4				(0x1u << PM_APBCMASK_TC4_Pos)
#define PM_APBCMASK_TC5_Pos			13				/**< \brief (PM_APBCMASK)TC5 APBۯ */
#define PM_APBCMASK_TC5				(0x1u << PM_APBCMASK_TC5_Pos)
#define PM_APBCMASK_TC6_Pos			14				/**< \brief (PM_APBCMASK)TC6 APBۯ */
#define PM_APBCMASK_TC6				(0x1u << PM_APBCMASK_TC6_Pos)
#define PM_APBCMASK_TC7_Pos			15				/**< \brief (PM_APBCMASK)TC7 APBۯ */
#define PM_APBCMASK_TC7				(0x1u << PM_APBCMASK_TC7_Pos)
#define PM_APBCMASK_ADC_Pos			16				/**< \brief (PM_APBCMASK)ADC APBۯ */
#define PM_APBCMASK_ADC				(0x1u << PM_APBCMASK_ADC_Pos)
#define PM_APBCMASK_AC_Pos			17				/**< \brief (PM_APBCMASK)AC APBۯ */
#define PM_APBCMASK_AC				(0x1u << PM_APBCMASK_AC_Pos)
#define PM_APBCMASK_DAC_Pos			18				/**< \brief (PM_APBCMASK)DAC APBۯ */
#define PM_APBCMASK_DAC				(0x1u << PM_APBCMASK_DAC_Pos)
#define PM_APBCMASK_I2S_Pos			20				/**< \brief (PM_APBCMASK)I2S APBۯ */
#define PM_APBCMASK_I2S				(0x1u << PM_APBCMASK_I2S_Pos)
#define PM_APBCMASK_MASK			0x0017FFFFu		/**< \brief (PM_APBCMASK)Օڼ޽ */

/* -------- PM_INTENCLR : (PMψ:0x34) (R/W  8)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CKRDY:1;			/*!< ޯ   0: ۯ荞݋ */
    uint8_t  CFD:1;				/*!< ޯ   1: ۯQo荞݋ */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_INTENCLR_OFFSET			0x34			/**< \brief (PM_INTENCLR offset)荞݋ */
#define PM_INTENCLR_RESETVALUE		0x00			/**< \brief (PM_INTENCLR reset_value)荞݋ */

#define PM_INTENCLR_CKRDY_Pos		0				/**< \brief (PM_INTENCLR)ۯ荞݋ */
#define PM_INTENCLR_CKRDY			(0x1u << PM_INTENCLR_CKRDY_Pos)
#define PM_INTENCLR_CFD_Pos			1				/**< \brief (PM_INTENCLR)ۯQo荞݋ */
#define PM_INTENCLR_CFD				(0x1u << PM_INTENCLR_CFD_Pos)
#define PM_INTENCLR_MASK			0x03u			/**< \brief (PM_INTENCLR)Օڼ޽ */

/* -------- PM_INTENSET : (PMψ:0x35) (R/W  8)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CKRDY:1;			/*!< ޯ   0: ۯ荞݋ */
    uint8_t  CFD:1;				/*!< ޯ   1: ۯQo荞݋ */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_INTENSET_OFFSET			0x35			/**< \brief (PM_INTENSET offset)荞݋ݒ */
#define PM_INTENSET_RESETVALUE		0x00			/**< \brief (PM_INTENSET reset_value)荞݋ݒ */

#define PM_INTENSET_CKRDY_Pos		0				/**< \brief (PM_INTENSET)ۯ荞݋ */
#define PM_INTENSET_CKRDY			(0x1u << PM_INTENSET_CKRDY_Pos)
#define PM_INTENSET_CFD_Pos			1				/**< \brief (PM_INTENSET)ۯQo荞݋ */
#define PM_INTENSET_CFD				(0x1u << PM_INTENSET_CFD_Pos)
#define PM_INTENSET_MASK			0x03u			/**< \brief (PM_INTENSET)Օڼ޽ */

/* -------- PM_INTFLAG : (PMψ:0x36) (R/W  8)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CKRDY:1;			/*!< ޯ   0: ۯ */
    uint8_t  CFD:1;				/*!< ޯ   1: ۯQo */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_INTFLAG_OFFSET			0x36			/**< \brief (PM_INTFLAG offset)荞׸ޏ/ */
#define PM_INTFLAG_RESETVALUE		0x00			/**< \brief (PM_INTFLAG reset_value)荞׸ޏ/ */

#define PM_INTFLAG_CKRDY_Pos		0				/**< \brief (PM_INTFLAG)ۯ */
#define PM_INTFLAG_CKRDY			(0x1u << PM_INTFLAG_CKRDY_Pos)
#define PM_INTFLAG_CFD_Pos			1				/**< \brief (PM_INTFLAG)ۯQo */
#define PM_INTFLAG_CFD				(0x1u << PM_INTFLAG_CFD_Pos)
#define PM_INTFLAG_MASK				0x03u			/**< \brief (PM_INTFLAG)Օڼ޽ */

/* -------- PM_RCAUSE : (PMψ:0x38) (R/   8)ؾČ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  POR:1;				/*!< ޯ0: dONؾ */
    uint8_t  BOD12:1;			/*!< ޯ1: d12oؾ */
    uint8_t  BOD33:1;			/*!< ޯ2: d33oؾ */
    uint8_t  :1;				/*!< ޯ3: \ */
    uint8_t  EXT:1;				/*!< ޯ4: Oؾ */
    uint8_t  WDT:1;				/*!< ޯ5: ޯ ؾ */
    uint8_t  SYST:1;			/*!< ޯ6:  ؾėv */
    uint8_t  :1;				/*!< ޯ7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} PM_RCAUSE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define PM_RCAUSE_OFFSET			0x38			/**< \brief (PM_RCAUSE offset)ؾČ */
#define PM_RCAUSE_RESETVALUE		0x01			/**< \brief (PM_RCAUSE reset_value)ؾČ */

#define PM_RCAUSE_POR_Pos			0				/**< \brief (PM_RCAUSE)dONؾ */
#define PM_RCAUSE_POR				(0x1u << PM_RCAUSE_POR_Pos)
#define PM_RCAUSE_BOD12_Pos			1				/**< \brief (PM_RCAUSE)d12oؾ */
#define PM_RCAUSE_BOD12				(0x1u << PM_RCAUSE_BOD12_Pos)
#define PM_RCAUSE_BOD33_Pos			2				/**< \brief (PM_RCAUSE)d33oؾ */
#define PM_RCAUSE_BOD33				(0x1u << PM_RCAUSE_BOD33_Pos)
#define PM_RCAUSE_EXT_Pos			4				/**< \brief (PM_RCAUSE)Oؾ */
#define PM_RCAUSE_EXT				(0x1u << PM_RCAUSE_EXT_Pos)
#define PM_RCAUSE_WDT_Pos			5				/**< \brief (PM_RCAUSE)ޯ ؾ */
#define PM_RCAUSE_WDT				(0x1u << PM_RCAUSE_WDT_Pos)
#define PM_RCAUSE_SYST_Pos			6				/**< \brief (PM_RCAUSE) ؾėv */
#define PM_RCAUSE_SYST				(0x1u << PM_RCAUSE_SYST_Pos)
#define PM_RCAUSE_MASK				0x77u			/**< \brief (PM_RCAUSE)Օڼ޽ */

/** \brief PMʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO PM_CTRL_Type			CTRL;			/**< \briefψ:0x00 (R/W  8) */
  __IO PM_SLEEP_Type		SLEEP;			/**< \briefψ:0x01 (R/W  8)x~ */
	   RoReg8				Reserved1[0x6];
  __IO PM_CPUSEL_Type		CPUSEL;			/**< \briefψ:0x08 (R/W  8)CPUۯI */
  __IO PM_APBASEL_Type		APBASEL;		/**< \briefψ:0x09 (R/W  8)APBAۯI */
  __IO PM_APBBSEL_Type		APBBSEL;		/**< \briefψ:0x0A (R/W  8)APBBۯI */
  __IO PM_APBCSEL_Type		APBCSEL;		/**< \briefψ:0x0B (R/W  8)APBCۯI */
	   RoReg8				Reserved2[0x8];
  __IO PM_AHBMASK_Type		AHBMASK;		/**< \briefψ:0x14 (R/W 32)AHBՕ */
  __IO PM_APBAMASK_Type		APBAMASK;		/**< \briefψ:0x18 (R/W 32)APBAՕ */
  __IO PM_APBBMASK_Type		APBBMASK;		/**< \briefψ:0x1C (R/W 32)APBBՕ */
  __IO PM_APBCMASK_Type		APBCMASK;		/**< \briefψ:0x20 (R/W 32)APBCՕ */
	   RoReg8				Reserved3[0x10];
  __IO PM_INTENCLR_Type		INTENCLR;		/**< \briefψ:0x34 (R/W  8)荞݋ */
  __IO PM_INTENSET_Type		INTENSET;		/**< \briefψ:0x35 (R/W  8)荞݋ݒ */
  __IO PM_INTFLAG_Type		INTFLAG;		/**< \briefψ:0x36 (R/W  8)荞׸ޏ/ */
	   RoReg8				Reserved4[0x1];
  __I  PM_RCAUSE_Type		RCAUSE;			/**< \briefψ:0x38 (R/   8)ؾČ */
} Pm;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_PM_COMPONENT_ */
