/**
 * \file
 *
 * \brief SAM D20/D21/R21 ۯ ײޑJn
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 */

/**
 * \page asfdoc_sam0_system_clock_basic_use_case SYSTEM CLOCKpJ̎ - {
 *
 * ̏ꍇȉ̌`ԐݒKp܂B:
 * - RC8MHz(8MHz RCU)
 *  - 2MHz̎g^4
 * - DFLL(޼َgŒ艻H)
 *  - JH
 *  - 48MHzg
 * - CPUۯ
 *  - ׯ ؂̓ǂގ2҂Ԃgp
 *  - 48MHzɌ`Ԑݒ肵DFLLgp
 *
 * \section asfdoc_sam0_system_clock_basic_use_case_setup \ݒ
 *
 * \subsection asfdoc_sam0_system_clock_basic_use_case_setup_prereq OKv
 * ̎gpʂɑ΂ēʂȏ̕Kv͂܂B
 *
 * \subsection asfdoc_sam0_system_clock_basic_use_case_setup_code 
 * ȉ̍\ݒ躰ނgp҉pɕ/\t܂B:
 * \snippet qs_clock_source.c setup
 *
 * \subsection asfdoc_sam0_system_clock_basic_use_case_setup_flow Ƃ̗
 * -# O32kHzUق̌`Ԑݒ𒲐̂ɋL邱ƂłEXTOSC32K
 *    Pʕ`Ԑݒ\̂쐬܂B
 *    \snippet qs_clock_source.c config_extosc32k_config
 *
 * -# Pʕ̊lŔU`Ԑݒ\̂܂B
 *    \snippet qs_clock_source.c config_extosc32k_get_defaults
 *    \note ͑SĂ̒lm̊lɏ̂ۏ؂邽߂Ɍ`Ԑ
 *          \̂gp̂ɐ旧ďɎsׂłB
 *
 * -# 4096ۯ̎nԂKvƂ悤EXTOSC32KPʕ`Ԑݒ\̂
 *    ܂B
 *    \snippet qs_clock_source.c config_extosc32k_change_defaults
 *
 * -# V`ԐݒEXTOSC32KPʕɏ܂B
 *    \snippet qs_clock_source.c config_extosc32k_set_config
 *
 * -# O32kHzUق̌`Ԑݒ𒲐̂ɖƂłDFLLPʕ`
 *    Ԑݒ\̂쐬܂B
 *    \snippet qs_clock_source.c config_dfll_config
 *
 * -# Pʕ̊lDFLLU`Ԑݒ\̂܂B
 *    \snippet qs_clock_source.c config_dfll_get_defaults
 *    \note SĂ̒lm̊ݒɏ邱Ƃۏ؂邽߂ɂ̌`
 *          ݒ\̂gp̂ɐ旧ďɂꂪsׂłB
 *
 * -# V`ԐݒDFLLPʕɏ܂B
 *    \snippet qs_clock_source.c config_dfll_set_config
 *
 *
 * \section asfdoc_sam0_system_clock_basic_use_case_use_main gp
 *
 * \subsection asfdoc_sam0_system_clock_basic_use_case_code 
 *
 * ȉ̺ނgp҉pɕ/\t܂B:
 * \snippet qs_clock_source.c main
 *
 * \subsection asfdoc_sam0_system_clock_basic_use_case_flow Ƃ̗
 * -# ɒ`\ݒ֐pĊO32kHzU틟`Ԑݒ肵܂B
 *    \snippet qs_clock_source.c config_extosc32k_main
 *
 * -# `Ԑݒ肵O32kHzU틟܂B
 *    \snippet qs_clock_source.c enable_extosc32k_main
 *
 * -# ɒ`\ݒ֐pDFLLU틟`Ԑݒ肵܂B
 *    function.
 *    \snippet qs_clock_source.c config_dfll_main
 *
 * -# `Ԑݒ肵DFLLU틟܂B
 *    \snippet qs_clock_source.c enable_dfll_main
 *
 * -#  ۯƂčDFLLgp邽߁Aǂݍݖ2҂Ԃ悤
 *    ׯ҂Ԃ`Ԑݒ肵܂Bs[ȑ҂ԂgpꂽꍇAǂ
 *    ߂̂߂޲͎蓖莟ɓȂȂ邩܂B
 *    \snippet qs_clock_source.c set_sys_wait_states
 *
 * -# ۯČ`Ԑݒ肷邱Ƃɂļ ۯDFLLɐ؂ւ܂B
 *    \snippet qs_clock_source.c set_sys_clk_src
 */
