/**
 * \file
 *
 * \brief SAM TCCײ2dɏՑJn
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

/**
 * \page asfdoc_sam0_tcc_buffering_use_case TCCpJn̎ - 2dɏՂƏz
 *
 * xꗗ:
 *    - SAM D21/R21 Xplained Pro
 *
 * ̎gpʂŁATCCPWMM𐶐̂Ɏgp܂Bٽ͎
 * 1/4ɐݒ肳܂BPWMo͂LEDɐڑƁALED_܂Bg`ɂ
 * ۽߂Kv܂B
 *
 * PWMo͎̗͂lɍ\ݒ肳܂B:
 * <table>
 *  <tr><th>       </td><th> </td><th>ڑ</td></tr>
 *  <tr><td>SAMD21 Xpro</td><td>PB30</td><td> LED0 </td></tr>
 *  <tr><td>SAMR21 Xpro</td><td>PA19</td><td> LED0 </td></tr>
 * </table>
 *
 * TCCPʕ͎̗lɍ\ݒ肳܂B:
 * - GCLK0(GCLK)ۯ
 * - APIʂTOPArAlݒ肷鎞2dɏՏ݂gp
 * - v܂͔rłިނȂ
 * - Ou1024ɐݒ
 * - PXPWMg`
 * - GCLKĐݒ芈
 * - ޲ősȂB
 * - Q܂͔g`gȂ
 * - g`o͂̔]Ȃ
 * - ߊlȂ
 * - ㏸v
 * - PsȂ
 * - ۓ͂Ȃ
 * - ۊȂ
 * - ېȂ
 * - 0ŌvJn
 * - vTOP8000ɐݒ
 * - r/ߊlق8000/4ɐݒ
 * - r/ߊlيɏՕ8000*3/4ɐݒ
 * - rlXVŐ؂ւۂ悤ɔrقɑ΂zCӑI
 *   ܂B
 *
 * \section asfdoc_sam0_tcc_buffering_use_case_setup ʊJn
 *
 * \subsection asfdoc_sam0_tcc_buffering_use_case_prereq OKv
 * ̎gpʂɑ΂鎖OKv͂܂B
 *
 * \subsection asfdoc_sam0_tcc_buffering_use_case_setup_code 
 *
 * ǂ̊֐ɂ旧Ď剞p ̧Ɉȉǉ܂B:
 * \snippet conf_quick_start_buffering.h definition_pwm
 *
 * ̊֐̊Oňȉ剞p ̧قɒǉ܂B:
 * \snippet qs_tcc_buffering.c module_inst
 *
 * ȉ̍\ݒ躰ނgp҉pɕ/\t܂B:
 * \snippet qs_tcc_buffering.c setup
 *
 * gp҉p(ʓI\c main()̎n)ɒǉ܂B
 * \snippet qs_tcc_buffering.c setup_init
 *
 * \subsection asfdoc_sam0_tcc_buffering_use_case_setup_flow Ƃ̗
 * -# ꂪgpԂTCCײނ̏Ԃi[邽߂TCCPʕpPʕĳ
 *    ̍\̂쐬܂B
 *    \snippet qs_tcc_buffering.c module_inst
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 *
 * -# TCCPʕ`Ԑݒ肵܂B
 *  -# ITCCӋ@\̌`Ԑݒ𒲐邽߂ɋL邱ƂłTCCP
 *     `Ԑݒ\̂쐬܂B
 *     \snippet qs_tcc_buffering.c setup_config
 *  -# Pʕ̊lTCC`Ԑݒ\̂܂B
 *     \snippet qs_tcc_buffering.c setup_config_defaults
 *     \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *           ݒ\̂ĝɐ旧ďɎsׂłB
 *
 *  -# v핝Ag`Ar0l`Ԑݒ肷悤TCCݒς
 *     B
 *     \snippet qs_tcc_buffering.c setup_change_config
 *  -# ޲ ݂łPWMo͂`Ԑݒ肷悤TCCݒς܂B
 *     \snippet qs_tcc_buffering.c setup_change_config_pwm
 *  -# ]ސݒTCCPʕ`Ԑݒ肵܂B
 *     \snippet qs_tcc_buffering.c setup_set_config
 *  -# rɏՒlݒ肵2dɏՂrl̏z܂B
 *     \snippet qs_tcc_buffering.c setup_set_buffering
 *  -# vJnPWMMn߂邽߂TCCPʕ܂B
 *     \snippet qs_tcc_buffering.c setup_enable
 *
 *
 * \section asfdoc_sam0_tcc_buffering_use_case_main gp
 *
 * \subsection asfdoc_sam0_tcc_buffering_use_case_main_code 
 * ȉ̺ނgp҉pɕ/\t܂B
 * \snippet qs_tcc_buffering.c main
 *
 * \subsection asfdoc_sam0_tcc_buffering_use_case_main_flow Ƃ̗
 * -# TCCPʕoRPWMg`ԖJԂɈڍs܂B
 *  \snippet qs_tcc_buffering.c main_loop
 */