/**
 * \file
 *
 * \brief RTCp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_RTC_COMPONENT_
#define _SAMD21_RTC_COMPONENT_

/* ========================================================================== */
/** RTCpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_RTC Ԍv */
/*@{*/

#define RTC_U2202
#define REV_RTC								0x101

/* -------- RTC_MODE0_CTRL : (RTCψ:0x00) (R/W 16) MODE0 MODE0 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t MODE:2;			/*!< ޯ 2` 3: ` */
    uint16_t :3;				/*!< ޯ 4` 6: \ */
    uint16_t MATCHCLR:1;		/*!< ޯ     7: vŉ */
    uint16_t PRESCALER:4;		/*!< ޯ 8`11: Ou */
    uint16_t :4;				/*!< ޯ12`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE0_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE0_CTRL_OFFSET				0x00			/**< \brief (RTC_MODE0_CTRL offset)MODE0 */
#define RTC_MODE0_CTRL_RESETVALUE			0x0000			/**< \brief (RTC_MODE0_CTRL reset_value)MODE0 */

#define RTC_MODE0_CTRL_SWRST_Pos			0				/**< \brief (RTC_MODE0_CTRL)ĳ ؾ */
#define RTC_MODE0_CTRL_SWRST				(0x1u << RTC_MODE0_CTRL_SWRST_Pos)
#define RTC_MODE0_CTRL_ENABLE_Pos			1				/**< \brief (RTC_MODE0_CTRL) */
#define RTC_MODE0_CTRL_ENABLE				(0x1u << RTC_MODE0_CTRL_ENABLE_Pos)
#define RTC_MODE0_CTRL_MODE_Pos				2				/**< \brief (RTC_MODE0_CTRL)` */
#define RTC_MODE0_CTRL_MODE_Msk				(0x3u << RTC_MODE0_CTRL_MODE_Pos)
#define RTC_MODE0_CTRL_MODE(value)			((RTC_MODE0_CTRL_MODE_Msk & ((value) << RTC_MODE0_CTRL_MODE_Pos)))
#define   RTC_MODE0_CTRL_MODE_COUNT32_Val		0x0u		/**< \brief (RTC_MODE0_CTRL)`0:32ޯČv */
#define   RTC_MODE0_CTRL_MODE_COUNT16_Val		0x1u		/**< \brief (RTC_MODE0_CTRL)`1:16ޯČv */
#define   RTC_MODE0_CTRL_MODE_CLOCK_Val			0x2u		/**< \brief (RTC_MODE0_CTRL)`2:v/ */
#define RTC_MODE0_CTRL_MODE_COUNT32			(RTC_MODE0_CTRL_MODE_COUNT32_Val	<< RTC_MODE0_CTRL_MODE_Pos)
#define RTC_MODE0_CTRL_MODE_COUNT16			(RTC_MODE0_CTRL_MODE_COUNT16_Val	<< RTC_MODE0_CTRL_MODE_Pos)
#define RTC_MODE0_CTRL_MODE_CLOCK			(RTC_MODE0_CTRL_MODE_CLOCK_Val		<< RTC_MODE0_CTRL_MODE_Pos)
#define RTC_MODE0_CTRL_MATCHCLR_Pos			7				/**< \brief (RTC_MODE0_CTRL)vŉ */
#define RTC_MODE0_CTRL_MATCHCLR				(0x1u << RTC_MODE0_CTRL_MATCHCLR_Pos)
#define RTC_MODE0_CTRL_PRESCALER_Pos		8				/**< \brief (RTC_MODE0_CTRL)Ou */
#define RTC_MODE0_CTRL_PRESCALER_Msk		(0xFu << RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER(value)		((RTC_MODE0_CTRL_PRESCALER_Msk & ((value) << RTC_MODE0_CTRL_PRESCALER_Pos)))
#define   RTC_MODE0_CTRL_PRESCALER_DIV1_Val		0x0u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/1 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV2_Val		0x1u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/2 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV4_Val		0x2u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/4 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV8_Val		0x3u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/8 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV16_Val	0x4u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/16 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV32_Val	0x5u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/32 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV64_Val	0x6u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/64 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV128_Val	0x7u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/128 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV256_Val	0x8u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/256 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV512_Val	0x9u		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/512 */
#define   RTC_MODE0_CTRL_PRESCALER_DIV1024_Val	0xAu		/**< \brief (RTC_MODE0_CTRL)CLK_RTC_CNT=GCLK_RTC/1024 */
#define RTC_MODE0_CTRL_PRESCALER_DIV1		(RTC_MODE0_CTRL_PRESCALER_DIV1_Val		<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV2		(RTC_MODE0_CTRL_PRESCALER_DIV2_Val		<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV4		(RTC_MODE0_CTRL_PRESCALER_DIV4_Val		<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV8		(RTC_MODE0_CTRL_PRESCALER_DIV8_Val		<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV16		(RTC_MODE0_CTRL_PRESCALER_DIV16_Val		<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV32		(RTC_MODE0_CTRL_PRESCALER_DIV32_Val		<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV64		(RTC_MODE0_CTRL_PRESCALER_DIV64_Val		<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV128		(RTC_MODE0_CTRL_PRESCALER_DIV128_Val	<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV256		(RTC_MODE0_CTRL_PRESCALER_DIV256_Val	<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV512		(RTC_MODE0_CTRL_PRESCALER_DIV512_Val	<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_PRESCALER_DIV1024	(RTC_MODE0_CTRL_PRESCALER_DIV1024_Val	<< RTC_MODE0_CTRL_PRESCALER_Pos)
#define RTC_MODE0_CTRL_MASK					0x0F8Fu			/**< \brief (RTC_MODE0_CTRL)Օڼ޽ */

/* -------- RTC_MODE1_CTRL : (RTCψ:0x00) (R/W 16) MODE1 MODE1 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t MODE:2;			/*!< ޯ 2` 3: ` */
    uint16_t :4;				/*!< ޯ 4` 7: \ */
    uint16_t PRESCALER:4;		/*!< ޯ 8`11: Ou */
    uint16_t :4;				/*!< ޯ12`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_CTRL_OFFSET				0x00			/**< \brief (RTC_MODE1_CTRL offset)MODE1 */
#define RTC_MODE1_CTRL_RESETVALUE			0x0000			/**< \brief (RTC_MODE1_CTRL reset_value)MODE1 */

#define RTC_MODE1_CTRL_SWRST_Pos			0				/**< \brief (RTC_MODE1_CTRL)ĳ ؾ */
#define RTC_MODE1_CTRL_SWRST				(0x1u << RTC_MODE1_CTRL_SWRST_Pos)
#define RTC_MODE1_CTRL_ENABLE_Pos			1				/**< \brief (RTC_MODE1_CTRL) */
#define RTC_MODE1_CTRL_ENABLE				(0x1u << RTC_MODE1_CTRL_ENABLE_Pos)
#define RTC_MODE1_CTRL_MODE_Pos				2				/**< \brief (RTC_MODE1_CTRL)` */
#define RTC_MODE1_CTRL_MODE_Msk				(0x3u << RTC_MODE1_CTRL_MODE_Pos)
#define RTC_MODE1_CTRL_MODE(value)			((RTC_MODE1_CTRL_MODE_Msk & ((value) << RTC_MODE1_CTRL_MODE_Pos)))
#define   RTC_MODE1_CTRL_MODE_COUNT32_Val		0x0u		/**< \brief (RTC_MODE1_CTRL)`0:32ޯČv */
#define   RTC_MODE1_CTRL_MODE_COUNT16_Val		0x1u		/**< \brief (RTC_MODE1_CTRL)`1:16ޯČv */
#define   RTC_MODE1_CTRL_MODE_CLOCK_Val			0x2u		/**< \brief (RTC_MODE1_CTRL)`2:v/ */
#define RTC_MODE1_CTRL_MODE_COUNT32			(RTC_MODE1_CTRL_MODE_COUNT32_Val	<< RTC_MODE1_CTRL_MODE_Pos)
#define RTC_MODE1_CTRL_MODE_COUNT16			(RTC_MODE1_CTRL_MODE_COUNT16_Val	<< RTC_MODE1_CTRL_MODE_Pos)
#define RTC_MODE1_CTRL_MODE_CLOCK			(RTC_MODE1_CTRL_MODE_CLOCK_Val		<< RTC_MODE1_CTRL_MODE_Pos)
#define RTC_MODE1_CTRL_PRESCALER_Pos		8				/**< \brief (RTC_MODE1_CTRL)Ou */
#define RTC_MODE1_CTRL_PRESCALER_Msk		(0xFu << RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER(value)		((RTC_MODE1_CTRL_PRESCALER_Msk & ((value) << RTC_MODE1_CTRL_PRESCALER_Pos)))
#define   RTC_MODE1_CTRL_PRESCALER_DIV1_Val		0x0u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/1 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV2_Val		0x1u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/2 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV4_Val		0x2u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/4 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV8_Val		0x3u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/8 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV16_Val	0x4u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/16 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV32_Val	0x5u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/32 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV64_Val	0x6u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/64 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV128_Val	0x7u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/128 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV256_Val	0x8u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/256 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV512_Val	0x9u		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/512 */
#define   RTC_MODE1_CTRL_PRESCALER_DIV1024_Val	0xAu		/**< \brief (RTC_MODE1_CTRL)CLK_RTC_CNT=GCLK_RTC/1024 */
#define RTC_MODE1_CTRL_PRESCALER_DIV1		(RTC_MODE1_CTRL_PRESCALER_DIV1_Val		<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV2		(RTC_MODE1_CTRL_PRESCALER_DIV2_Val		<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV4		(RTC_MODE1_CTRL_PRESCALER_DIV4_Val		<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV8		(RTC_MODE1_CTRL_PRESCALER_DIV8_Val		<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV16		(RTC_MODE1_CTRL_PRESCALER_DIV16_Val		<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV32		(RTC_MODE1_CTRL_PRESCALER_DIV32_Val		<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV64		(RTC_MODE1_CTRL_PRESCALER_DIV64_Val		<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV128		(RTC_MODE1_CTRL_PRESCALER_DIV128_Val	<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV256		(RTC_MODE1_CTRL_PRESCALER_DIV256_Val	<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV512		(RTC_MODE1_CTRL_PRESCALER_DIV512_Val	<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_PRESCALER_DIV1024	(RTC_MODE1_CTRL_PRESCALER_DIV1024_Val	<< RTC_MODE1_CTRL_PRESCALER_Pos)
#define RTC_MODE1_CTRL_MASK					0x0F0Fu			/**< \brief (RTC_MODE1_CTRL)Օڼ޽ */

/* -------- RTC_MODE2_CTRL : (RTCψ:0x00) (R/W 16) MODE2 MODE2 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint16_t ENABLE:1;			/*!< ޯ     1:  */
    uint16_t MODE:2;			/*!< ޯ 2` 3: ` */
    uint16_t :2;				/*!< ޯ 4` 5: \ */
    uint16_t CLKREP:1;			/*!< ޯ     6: ۯ\ */
    uint16_t MATCHCLR:1;		/*!< ޯ     7: vŉ */
    uint16_t PRESCALER:4;		/*!< ޯ 8`11: Ou */
    uint16_t :4;				/*!< ޯ12`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_CTRL_OFFSET				0x00			/**< \brief (RTC_MODE2_CTRL offset)MODE2 */
#define RTC_MODE2_CTRL_RESETVALUE			0x0000			/**< \brief (RTC_MODE2_CTRL reset_value)MODE2 */

#define RTC_MODE2_CTRL_SWRST_Pos			0				/**< \brief (RTC_MODE2_CTRL)ĳ ؾ */
#define RTC_MODE2_CTRL_SWRST				(0x1u << RTC_MODE2_CTRL_SWRST_Pos)
#define RTC_MODE2_CTRL_ENABLE_Pos			1				/**< \brief (RTC_MODE2_CTRL) */
#define RTC_MODE2_CTRL_ENABLE				(0x1u << RTC_MODE2_CTRL_ENABLE_Pos)
#define RTC_MODE2_CTRL_MODE_Pos				2				/**< \brief (RTC_MODE2_CTRL)` */
#define RTC_MODE2_CTRL_MODE_Msk				(0x3u << RTC_MODE2_CTRL_MODE_Pos)
#define RTC_MODE2_CTRL_MODE(value)			((RTC_MODE2_CTRL_MODE_Msk & ((value) << RTC_MODE2_CTRL_MODE_Pos)))
#define   RTC_MODE2_CTRL_MODE_COUNT32_Val		0x0u		/**< \brief (RTC_MODE2_CTRL)`0:32ޯČv */
#define   RTC_MODE2_CTRL_MODE_COUNT16_Val		0x1u		/**< \brief (RTC_MODE2_CTRL)`1:16ޯČv */
#define   RTC_MODE2_CTRL_MODE_CLOCK_Val			0x2u		/**< \brief (RTC_MODE2_CTRL)`2:v/ */
#define RTC_MODE2_CTRL_MODE_COUNT32			(RTC_MODE2_CTRL_MODE_COUNT32_Val	<< RTC_MODE2_CTRL_MODE_Pos)
#define RTC_MODE2_CTRL_MODE_COUNT16			(RTC_MODE2_CTRL_MODE_COUNT16_Val	<< RTC_MODE2_CTRL_MODE_Pos)
#define RTC_MODE2_CTRL_MODE_CLOCK			(RTC_MODE2_CTRL_MODE_CLOCK_Val		<< RTC_MODE2_CTRL_MODE_Pos)
#define RTC_MODE2_CTRL_CLKREP_Pos			6				/**< \brief (RTC_MODE2_CTRL)ۯ\ */
#define RTC_MODE2_CTRL_CLKREP				(0x1u << RTC_MODE2_CTRL_CLKREP_Pos)
#define RTC_MODE2_CTRL_MATCHCLR_Pos			7				/**< \brief (RTC_MODE2_CTRL)vŉ */
#define RTC_MODE2_CTRL_MATCHCLR				(0x1u << RTC_MODE2_CTRL_MATCHCLR_Pos)
#define RTC_MODE2_CTRL_PRESCALER_Pos		8				/**< \brief (RTC_MODE2_CTRL)Ou */
#define RTC_MODE2_CTRL_PRESCALER_Msk		(0xFu << RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER(value)		((RTC_MODE2_CTRL_PRESCALER_Msk & ((value) << RTC_MODE2_CTRL_PRESCALER_Pos)))
#define   RTC_MODE2_CTRL_PRESCALER_DIV1_Val		0x0u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/1 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV2_Val		0x1u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/2 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV4_Val		0x2u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/4 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV8_Val		0x3u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/8 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV16_Val	0x4u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/16 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV32_Val	0x5u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/32 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV64_Val	0x6u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/64 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV128_Val	0x7u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/128 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV256_Val	0x8u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/256 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV512_Val	0x9u		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/512 */
#define   RTC_MODE2_CTRL_PRESCALER_DIV1024_Val	0xAu		/**< \brief (RTC_MODE2_CTRL)CLK_RTC_CNT=GCLK_RTC/1024 */
#define RTC_MODE2_CTRL_PRESCALER_DIV1		(RTC_MODE2_CTRL_PRESCALER_DIV1_Val		<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV2		(RTC_MODE2_CTRL_PRESCALER_DIV2_Val		<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV4		(RTC_MODE2_CTRL_PRESCALER_DIV4_Val		<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV8		(RTC_MODE2_CTRL_PRESCALER_DIV8_Val		<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV16		(RTC_MODE2_CTRL_PRESCALER_DIV16_Val		<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV32		(RTC_MODE2_CTRL_PRESCALER_DIV32_Val		<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV64		(RTC_MODE2_CTRL_PRESCALER_DIV64_Val		<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV128		(RTC_MODE2_CTRL_PRESCALER_DIV128_Val	<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV256		(RTC_MODE2_CTRL_PRESCALER_DIV256_Val	<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV512		(RTC_MODE2_CTRL_PRESCALER_DIV512_Val	<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_PRESCALER_DIV1024	(RTC_MODE2_CTRL_PRESCALER_DIV1024_Val	<< RTC_MODE2_CTRL_PRESCALER_Pos)
#define RTC_MODE2_CTRL_MASK					0x0FCFu			/**< \brief (RTC_MODE2_CTRL)Օڼ޽ */

/* -------- RTC_READREQ : (RTCψ:0x02) (R/W 16)ǂݍݗv -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t ADDR:6;			/*!< ޯ0` 5: ڽ */
    uint16_t :8;				/*!< ޯ6`13: \ */
    uint16_t RCONT:1;			/*!< ޯ   14: Aǂݍ */
    uint16_t RREQ:1;			/*!< ޯ   15: ǂݍݗv */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_READREQ_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_READREQ_OFFSET					0x02			/**< \brief (RTC_READREQ offset)ǂݍݗv */
#define RTC_READREQ_RESETVALUE				0x0010			/**< \brief (RTC_READREQ reset_value)ǂݍݗv */

#define RTC_READREQ_ADDR_Pos				0				/**< \brief (RTC_READREQ)ڽ */
#define RTC_READREQ_ADDR_Msk				(0x3Fu << RTC_READREQ_ADDR_Pos)
#define RTC_READREQ_ADDR(value)				((RTC_READREQ_ADDR_Msk & ((value) << RTC_READREQ_ADDR_Pos)))
#define RTC_READREQ_RCONT_Pos				14				/**< \brief (RTC_READREQ)Aǂݍ */
#define RTC_READREQ_RCONT					(0x1u << RTC_READREQ_RCONT_Pos)
#define RTC_READREQ_RREQ_Pos				15				/**< \brief (RTC_READREQ)ǂݍݗv */
#define RTC_READREQ_RREQ					(0x1u << RTC_READREQ_RREQ_Pos)
#define RTC_READREQ_MASK					0xC03Fu			/**< \brief (RTC_READREQ)Օڼ޽ */

/* -------- RTC_MODE0_EVCTRL : (RTCψ:0x04) (R/W 16) MODE0 MODE0ې -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t PEREO0:1;			/*!< ޯ    0: IԊu0ۏo͋ */
    uint16_t PEREO1:1;			/*!< ޯ    1: IԊu1ۏo͋ */
    uint16_t PEREO2:1;			/*!< ޯ    2: IԊu2ۏo͋ */
    uint16_t PEREO3:1;			/*!< ޯ    3: IԊu3ۏo͋ */
    uint16_t PEREO4:1;			/*!< ޯ    4: IԊu4ۏo͋ */
    uint16_t PEREO5:1;			/*!< ޯ    5: IԊu5ۏo͋ */
    uint16_t PEREO6:1;			/*!< ޯ    6: IԊu6ۏo͋ */
    uint16_t PEREO7:1;			/*!< ޯ    7: IԊu7ۏo͋ */
    uint16_t CMPEO0:1;			/*!< ޯ    8: r0ۏo͋					*/
    uint16_t :6;				/*!< ޯ9`14: \ */
    uint16_t OVFEO:1;			/*!< ޯ   15: ꎖۏo͋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t PEREO:8;			/*!< ޯ0` 7: IԊuxۏo͋ */
    uint16_t CMPEO:1;			/*!< ޯ    8: rxۏo͋ */
    uint16_t :7;				/*!< ޯ9`15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE0_EVCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE0_EVCTRL_OFFSET				0x04			/**< \brief (RTC_MODE0_EVCTRL offset)MODE0ې */
#define RTC_MODE0_EVCTRL_RESETVALUE			0x0000			/**< \brief (RTC_MODE0_EVCTRL reset_value)MODE0ې */

#define RTC_MODE0_EVCTRL_PEREO0_Pos			0				/**< \brief (RTC_MODE0_EVCTRL)IԊu0ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO0				(1 << RTC_MODE0_EVCTRL_PEREO0_Pos)
#define RTC_MODE0_EVCTRL_PEREO1_Pos			1				/**< \brief (RTC_MODE0_EVCTRL)IԊu1ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO1				(1 << RTC_MODE0_EVCTRL_PEREO1_Pos)
#define RTC_MODE0_EVCTRL_PEREO2_Pos			2				/**< \brief (RTC_MODE0_EVCTRL)IԊu2ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO2				(1 << RTC_MODE0_EVCTRL_PEREO2_Pos)
#define RTC_MODE0_EVCTRL_PEREO3_Pos			3				/**< \brief (RTC_MODE0_EVCTRL)IԊu3ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO3				(1 << RTC_MODE0_EVCTRL_PEREO3_Pos)
#define RTC_MODE0_EVCTRL_PEREO4_Pos			4				/**< \brief (RTC_MODE0_EVCTRL)IԊu4ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO4				(1 << RTC_MODE0_EVCTRL_PEREO4_Pos)
#define RTC_MODE0_EVCTRL_PEREO5_Pos			5				/**< \brief (RTC_MODE0_EVCTRL)IԊu5ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO5				(1 << RTC_MODE0_EVCTRL_PEREO5_Pos)
#define RTC_MODE0_EVCTRL_PEREO6_Pos			6				/**< \brief (RTC_MODE0_EVCTRL)IԊu6ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO6				(1 << RTC_MODE0_EVCTRL_PEREO6_Pos)
#define RTC_MODE0_EVCTRL_PEREO7_Pos			7				/**< \brief (RTC_MODE0_EVCTRL)IԊu7ۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO7				(1 << RTC_MODE0_EVCTRL_PEREO7_Pos)
#define RTC_MODE0_EVCTRL_PEREO_Pos			0				/**< \brief (RTC_MODE0_EVCTRL)IԊuxۏo͋ */
#define RTC_MODE0_EVCTRL_PEREO_Msk			(0xFFu << RTC_MODE0_EVCTRL_PEREO_Pos)
#define RTC_MODE0_EVCTRL_PEREO(value)		((RTC_MODE0_EVCTRL_PEREO_Msk & ((value) << RTC_MODE0_EVCTRL_PEREO_Pos)))
#define RTC_MODE0_EVCTRL_CMPEO0_Pos			8				/**< \brief (RTC_MODE0_EVCTRL)r0ۏo͋ */
#define RTC_MODE0_EVCTRL_CMPEO0				(1 << RTC_MODE0_EVCTRL_CMPEO0_Pos)
#define RTC_MODE0_EVCTRL_CMPEO_Pos			8				/**< \brief (RTC_MODE0_EVCTRL)rxۏo͋ */
#define RTC_MODE0_EVCTRL_CMPEO_Msk			(0x1u << RTC_MODE0_EVCTRL_CMPEO_Pos)
#define RTC_MODE0_EVCTRL_CMPEO(value)		((RTC_MODE0_EVCTRL_CMPEO_Msk & ((value) << RTC_MODE0_EVCTRL_CMPEO_Pos)))
#define RTC_MODE0_EVCTRL_OVFEO_Pos			15				/**< \brief (RTC_MODE0_EVCTRL)ꎖۏo͋ */
#define RTC_MODE0_EVCTRL_OVFEO				(0x1u << RTC_MODE0_EVCTRL_OVFEO_Pos)
#define RTC_MODE0_EVCTRL_MASK				0x81FFu			/**< \brief (RTC_MODE0_EVCTRL)Օڼ޽ */

/* -------- RTC_MODE1_EVCTRL : (RTCψ:0x04) (R/W 16) MODE1 MODE1ې -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t PEREO0:1;			/*!< ޯ     0: IԊu0ۏo͋ */
    uint16_t PEREO1:1;			/*!< ޯ     1: IԊu1ۏo͋ */
    uint16_t PEREO2:1;			/*!< ޯ     2: IԊu2ۏo͋ */
    uint16_t PEREO3:1;			/*!< ޯ     3: IԊu3ۏo͋ */
    uint16_t PEREO4:1;			/*!< ޯ     4: IԊu4ۏo͋ */
    uint16_t PEREO5:1;			/*!< ޯ     5: IԊu5ۏo͋ */
    uint16_t PEREO6:1;			/*!< ޯ     6: IԊu6ۏo͋ */
    uint16_t PEREO7:1;			/*!< ޯ     7: IԊu7ۏo͋ */
    uint16_t CMPEO0:1;			/*!< ޯ     8: r0ۏo͋ */
    uint16_t CMPEO1:1;			/*!< ޯ     9: r1ۏo͋ */
    uint16_t :5;				/*!< ޯ10`14: \ */
    uint16_t OVFEO:1;			/*!< ޯ    15: ꎖۏo͋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t PEREO:8;			/*!< ޯ 0` 7: IԊuxۏo͋ */
    uint16_t CMPEO:2;			/*!< ޯ 8` 9: rxۏo͋ */
    uint16_t :6;				/*!< ޯ10`15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_EVCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_EVCTRL_OFFSET				0x04			/**< \brief (RTC_MODE1_EVCTRL offset)MODE1ې */
#define RTC_MODE1_EVCTRL_RESETVALUE			0x0000			/**< \brief (RTC_MODE1_EVCTRL reset_value)MODE1ې */

#define RTC_MODE1_EVCTRL_PEREO0_Pos			0				/**< \brief (RTC_MODE1_EVCTRL)IԊu0ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO0				(1 << RTC_MODE1_EVCTRL_PEREO0_Pos)
#define RTC_MODE1_EVCTRL_PEREO1_Pos			1				/**< \brief (RTC_MODE1_EVCTRL)IԊu1ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO1				(1 << RTC_MODE1_EVCTRL_PEREO1_Pos)
#define RTC_MODE1_EVCTRL_PEREO2_Pos			2				/**< \brief (RTC_MODE1_EVCTRL)IԊu2ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO2				(1 << RTC_MODE1_EVCTRL_PEREO2_Pos)
#define RTC_MODE1_EVCTRL_PEREO3_Pos			3				/**< \brief (RTC_MODE1_EVCTRL)IԊu3ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO3				(1 << RTC_MODE1_EVCTRL_PEREO3_Pos)
#define RTC_MODE1_EVCTRL_PEREO4_Pos			4				/**< \brief (RTC_MODE1_EVCTRL)IԊu4ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO4				(1 << RTC_MODE1_EVCTRL_PEREO4_Pos)
#define RTC_MODE1_EVCTRL_PEREO5_Pos			5				/**< \brief (RTC_MODE1_EVCTRL)IԊu5ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO5				(1 << RTC_MODE1_EVCTRL_PEREO5_Pos)
#define RTC_MODE1_EVCTRL_PEREO6_Pos			6				/**< \brief (RTC_MODE1_EVCTRL)IԊu6ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO6				(1 << RTC_MODE1_EVCTRL_PEREO6_Pos)
#define RTC_MODE1_EVCTRL_PEREO7_Pos			7				/**< \brief (RTC_MODE1_EVCTRL)IԊu7ۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO7				(1 << RTC_MODE1_EVCTRL_PEREO7_Pos)
#define RTC_MODE1_EVCTRL_PEREO_Pos			0				/**< \brief (RTC_MODE1_EVCTRL)IԊuxۏo͋ */
#define RTC_MODE1_EVCTRL_PEREO_Msk			(0xFFu << RTC_MODE1_EVCTRL_PEREO_Pos)
#define RTC_MODE1_EVCTRL_PEREO(value)		((RTC_MODE1_EVCTRL_PEREO_Msk & ((value) << RTC_MODE1_EVCTRL_PEREO_Pos)))
#define RTC_MODE1_EVCTRL_CMPEO0_Pos			8				/**< \brief (RTC_MODE1_EVCTRL)r0ۏo͋ */
#define RTC_MODE1_EVCTRL_CMPEO0				(1 << RTC_MODE1_EVCTRL_CMPEO0_Pos)
#define RTC_MODE1_EVCTRL_CMPEO1_Pos			9				/**< \brief (RTC_MODE1_EVCTRL)r1ۏo͋ */
#define RTC_MODE1_EVCTRL_CMPEO1				(1 << RTC_MODE1_EVCTRL_CMPEO1_Pos)
#define RTC_MODE1_EVCTRL_CMPEO_Pos			8				/**< \brief (RTC_MODE1_EVCTRL)rxۏo͋ */
#define RTC_MODE1_EVCTRL_CMPEO_Msk			(0x3u << RTC_MODE1_EVCTRL_CMPEO_Pos)
#define RTC_MODE1_EVCTRL_CMPEO(value)		((RTC_MODE1_EVCTRL_CMPEO_Msk & ((value) << RTC_MODE1_EVCTRL_CMPEO_Pos)))
#define RTC_MODE1_EVCTRL_OVFEO_Pos			15				/**< \brief (RTC_MODE1_EVCTRL)ꎖۏo͋ */
#define RTC_MODE1_EVCTRL_OVFEO				(0x1u << RTC_MODE1_EVCTRL_OVFEO_Pos)
#define RTC_MODE1_EVCTRL_MASK				0x83FFu			/**< \brief (RTC_MODE1_EVCTRL)Օڼ޽ */

/* -------- RTC_MODE2_EVCTRL : (RTCψ:0x04) (R/W 16) MODE2 MODE2ې -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t PEREO0:1;			/*!< ޯ    0: IԊu0ۏo͋ */
    uint16_t PEREO1:1;			/*!< ޯ    1: IԊu1ۏo͋ */
    uint16_t PEREO2:1;			/*!< ޯ    2: IԊu2ۏo͋ */
    uint16_t PEREO3:1;			/*!< ޯ    3: IԊu3ۏo͋ */
    uint16_t PEREO4:1;			/*!< ޯ    4: IԊu4ۏo͋ */
    uint16_t PEREO5:1;			/*!< ޯ    5: IԊu5ۏo͋ */
    uint16_t PEREO6:1;			/*!< ޯ    6: IԊu6ۏo͋ */
    uint16_t PEREO7:1;			/*!< ޯ    7: IԊu7ۏo͋ */
    uint16_t ALARMEO0:1;		/*!< ޯ    8: x0ۏo͋ */
    uint16_t :6;				/*!< ޯ9`14: \ */
    uint16_t OVFEO:1;			/*!< ޯ   15: ꎖۏo͋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t PEREO:8;			/*!< ޯ0` 7: IԊuxۏo͋ */
    uint16_t ALARMEO:1;			/*!< ޯ    8: xxۏo͋ */
    uint16_t :7;				/*!< ޯ9`15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_EVCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_EVCTRL_OFFSET				0x04			/**< \brief (RTC_MODE2_EVCTRL offset)MODE2ې */
#define RTC_MODE2_EVCTRL_RESETVALUE			0x0000			/**< \brief (RTC_MODE2_EVCTRL reset_value)MODE2ې */

#define RTC_MODE2_EVCTRL_PEREO0_Pos			0				/**< \brief (RTC_MODE2_EVCTRL)IԊu0ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO0				(1 << RTC_MODE2_EVCTRL_PEREO0_Pos)
#define RTC_MODE2_EVCTRL_PEREO1_Pos			1				/**< \brief (RTC_MODE2_EVCTRL)IԊu1ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO1				(1 << RTC_MODE2_EVCTRL_PEREO1_Pos)
#define RTC_MODE2_EVCTRL_PEREO2_Pos			2				/**< \brief (RTC_MODE2_EVCTRL)IԊu2ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO2				(1 << RTC_MODE2_EVCTRL_PEREO2_Pos)
#define RTC_MODE2_EVCTRL_PEREO3_Pos			3				/**< \brief (RTC_MODE2_EVCTRL)IԊu3ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO3				(1 << RTC_MODE2_EVCTRL_PEREO3_Pos)
#define RTC_MODE2_EVCTRL_PEREO4_Pos			4				/**< \brief (RTC_MODE2_EVCTRL)IԊu4ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO4				(1 << RTC_MODE2_EVCTRL_PEREO4_Pos)
#define RTC_MODE2_EVCTRL_PEREO5_Pos			5				/**< \brief (RTC_MODE2_EVCTRL)IԊu5ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO5				(1 << RTC_MODE2_EVCTRL_PEREO5_Pos)
#define RTC_MODE2_EVCTRL_PEREO6_Pos			6				/**< \brief (RTC_MODE2_EVCTRL)IԊu6ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO6				(1 << RTC_MODE2_EVCTRL_PEREO6_Pos)
#define RTC_MODE2_EVCTRL_PEREO7_Pos			7				/**< \brief (RTC_MODE2_EVCTRL)IԊu7ۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO7				(1 << RTC_MODE2_EVCTRL_PEREO7_Pos)
#define RTC_MODE2_EVCTRL_PEREO_Pos			0				/**< \brief (RTC_MODE2_EVCTRL)IԊuxۏo͋ */
#define RTC_MODE2_EVCTRL_PEREO_Msk			(0xFFu << RTC_MODE2_EVCTRL_PEREO_Pos)
#define RTC_MODE2_EVCTRL_PEREO(value)		((RTC_MODE2_EVCTRL_PEREO_Msk & ((value) << RTC_MODE2_EVCTRL_PEREO_Pos)))
#define RTC_MODE2_EVCTRL_ALARMEO0_Pos		8				/**< \brief (RTC_MODE2_EVCTRL)x0ۏo͋ */
#define RTC_MODE2_EVCTRL_ALARMEO0			(1 << RTC_MODE2_EVCTRL_ALARMEO0_Pos)
#define RTC_MODE2_EVCTRL_ALARMEO_Pos		8				/**< \brief (RTC_MODE2_EVCTRL)xxۏo͋ */
#define RTC_MODE2_EVCTRL_ALARMEO_Msk		(0x1u << RTC_MODE2_EVCTRL_ALARMEO_Pos)
#define RTC_MODE2_EVCTRL_ALARMEO(value)		((RTC_MODE2_EVCTRL_ALARMEO_Msk & ((value) << RTC_MODE2_EVCTRL_ALARMEO_Pos)))
#define RTC_MODE2_EVCTRL_OVFEO_Pos			15				/**< \brief (RTC_MODE2_EVCTRL)ꎖۏo͋ */
#define RTC_MODE2_EVCTRL_OVFEO				(0x1u << RTC_MODE2_EVCTRL_OVFEO_Pos)
#define RTC_MODE2_EVCTRL_MASK				0x81FFu			/**< \brief (RTC_MODE2_EVCTRL)Օڼ޽ */

/* -------- RTC_MODE0_INTENCLR : (RTCψ:0x06) (R/W  8) MODE0 MODE0荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CMP0:1;			/*!< ޯ   0: r0荞݋ */
    uint8_t  :5;				/*!< ޯ1`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6: 荞݋ */
    uint8_t  OVF:1;				/*!< ޯ   7: ꊄ荞݋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  CMP:1;				/*!< ޯ   0: rx荞݋ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE0_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE0_INTENCLR_OFFSET			0x06			/**< \brief (RTC_MODE0_INTENCLR offset)MODE0荞݋ */
#define RTC_MODE0_INTENCLR_RESETVALUE		0x00			/**< \brief (RTC_MODE0_INTENCLR reset_value)MODE0荞݋ */

#define RTC_MODE0_INTENCLR_CMP0_Pos			0				/**< \brief (RTC_MODE0_INTENCLR)r0荞݋ */
#define RTC_MODE0_INTENCLR_CMP0				(1 << RTC_MODE0_INTENCLR_CMP0_Pos)
#define RTC_MODE0_INTENCLR_CMP_Pos			0				/**< \brief (RTC_MODE0_INTENCLR)rx荞݋ */
#define RTC_MODE0_INTENCLR_CMP_Msk			(0x1u << RTC_MODE0_INTENCLR_CMP_Pos)
#define RTC_MODE0_INTENCLR_CMP(value)		((RTC_MODE0_INTENCLR_CMP_Msk & ((value) << RTC_MODE0_INTENCLR_CMP_Pos)))
#define RTC_MODE0_INTENCLR_SYNCRDY_Pos		6				/**< \brief (RTC_MODE0_INTENCLR)荞݋ */
#define RTC_MODE0_INTENCLR_SYNCRDY			(0x1u << RTC_MODE0_INTENCLR_SYNCRDY_Pos)
#define RTC_MODE0_INTENCLR_OVF_Pos			7				/**< \brief (RTC_MODE0_INTENCLR)ꊄ荞݋ */
#define RTC_MODE0_INTENCLR_OVF				(0x1u << RTC_MODE0_INTENCLR_OVF_Pos)
#define RTC_MODE0_INTENCLR_MASK				0xC1u			/**< \brief (RTC_MODE0_INTENCLR)Օڼ޽ */

/* -------- RTC_MODE1_INTENCLR : (RTCψ:0x06) (R/W  8) MODE1 MODE1荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CMP0:1;			/*!< ޯ   0: r0荞݋ */
    uint8_t  CMP1:1;			/*!< ޯ   1: r1荞݋ */
    uint8_t  :4;				/*!< ޯ2`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6: 荞݋ */
    uint8_t  OVF:1;				/*!< ޯ   7: ꊄ荞݋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  CMP:2;				/*!< ޯ0`1: rx荞݋  */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_INTENCLR_OFFSET			0x06			/**< \brief (RTC_MODE1_INTENCLR offset)MODE1荞݋ */
#define RTC_MODE1_INTENCLR_RESETVALUE		0x00			/**< \brief (RTC_MODE1_INTENCLR reset_value)MODE1荞݋ */

#define RTC_MODE1_INTENCLR_CMP0_Pos			0				/**< \brief (RTC_MODE1_INTENCLR)r0荞݋ */
#define RTC_MODE1_INTENCLR_CMP0				(1 << RTC_MODE1_INTENCLR_CMP0_Pos)
#define RTC_MODE1_INTENCLR_CMP1_Pos			1				/**< \brief (RTC_MODE1_INTENCLR)r1荞݋ */
#define RTC_MODE1_INTENCLR_CMP1				(1 << RTC_MODE1_INTENCLR_CMP1_Pos)
#define RTC_MODE1_INTENCLR_CMP_Pos			0				/**< \brief (RTC_MODE1_INTENCLR)rx荞݋ */
#define RTC_MODE1_INTENCLR_CMP_Msk			(0x3u << RTC_MODE1_INTENCLR_CMP_Pos)
#define RTC_MODE1_INTENCLR_CMP(value)		((RTC_MODE1_INTENCLR_CMP_Msk & ((value) << RTC_MODE1_INTENCLR_CMP_Pos)))
#define RTC_MODE1_INTENCLR_SYNCRDY_Pos		6				/**< \brief (RTC_MODE1_INTENCLR)荞݋ */
#define RTC_MODE1_INTENCLR_SYNCRDY			(0x1u << RTC_MODE1_INTENCLR_SYNCRDY_Pos)
#define RTC_MODE1_INTENCLR_OVF_Pos			7				/**< \brief (RTC_MODE1_INTENCLR)ꊄ荞݋ */
#define RTC_MODE1_INTENCLR_OVF				(0x1u << RTC_MODE1_INTENCLR_OVF_Pos)
#define RTC_MODE1_INTENCLR_MASK				0xC3u			/**< \brief (RTC_MODE1_INTENCLR)Օڼ޽ */

/* -------- RTC_MODE2_INTENCLR : (RTCψ:0x06) (R/W  8) MODE2 MODE2荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  ALARM0:1;			/*!< ޯ   0: x0荞݋ */
    uint8_t  :5;				/*!< ޯ1`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6: 荞݋ */
    uint8_t  OVF:1;				/*!< ޯ   7: ꊄ荞݋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  ALARM:1;			/*!< ޯ   0: xx荞݋֎~ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_INTENCLR_OFFSET			0x06			/**< \brief (RTC_MODE2_INTENCLR offset)MODE2荞݋ */
#define RTC_MODE2_INTENCLR_RESETVALUE		0x00			/**< \brief (RTC_MODE2_INTENCLR reset_value)MODE2荞݋ */

#define RTC_MODE2_INTENCLR_ALARM0_Pos		0				/**< \brief (RTC_MODE2_INTENCLR)x0荞݋ */
#define RTC_MODE2_INTENCLR_ALARM0			(1 << RTC_MODE2_INTENCLR_ALARM0_Pos)
#define RTC_MODE2_INTENCLR_ALARM_Pos		0				/**< \brief (RTC_MODE2_INTENCLR)xx荞݋֎~ */
#define RTC_MODE2_INTENCLR_ALARM_Msk		(0x1u << RTC_MODE2_INTENCLR_ALARM_Pos)
#define RTC_MODE2_INTENCLR_ALARM(value)		((RTC_MODE2_INTENCLR_ALARM_Msk & ((value) << RTC_MODE2_INTENCLR_ALARM_Pos)))
#define RTC_MODE2_INTENCLR_SYNCRDY_Pos		6				/**< \brief (RTC_MODE2_INTENCLR)荞݋ */
#define RTC_MODE2_INTENCLR_SYNCRDY			(0x1u << RTC_MODE2_INTENCLR_SYNCRDY_Pos)
#define RTC_MODE2_INTENCLR_OVF_Pos			7				/**< \brief (RTC_MODE2_INTENCLR)ꊄ荞݋ */
#define RTC_MODE2_INTENCLR_OVF				(0x1u << RTC_MODE2_INTENCLR_OVF_Pos)
#define RTC_MODE2_INTENCLR_MASK				0xC1u			/**< \brief (RTC_MODE2_INTENCLR)Օڼ޽ */

/* -------- RTC_MODE0_INTENSET : (RTCψ:0x07) (R/W  8) MODE0 MODE0荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CMP0:1;			/*!< ޯ   0: r0荞݋ */
    uint8_t  :5;				/*!< ޯ1`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6: 荞݋ */
    uint8_t  OVF:1;				/*!< ޯ   7: ꊄ荞݋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  CMP:1;				/*!< ޯ   0: rx荞݋ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE0_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE0_INTENSET_OFFSET			0x07			/**< \brief (RTC_MODE0_INTENSET offset)MODE0荞݋ݒ */
#define RTC_MODE0_INTENSET_RESETVALUE		0x00			/**< \brief (RTC_MODE0_INTENSET reset_value)MODE0荞݋ݒ */

#define RTC_MODE0_INTENSET_CMP0_Pos			0				/**< \brief (RTC_MODE0_INTENSET)r0荞݋ */
#define RTC_MODE0_INTENSET_CMP0				(1 << RTC_MODE0_INTENSET_CMP0_Pos)
#define RTC_MODE0_INTENSET_CMP_Pos			0				/**< \brief (RTC_MODE0_INTENSET)rx荞݋ */
#define RTC_MODE0_INTENSET_CMP_Msk			(0x1u << RTC_MODE0_INTENSET_CMP_Pos)
#define RTC_MODE0_INTENSET_CMP(value)		((RTC_MODE0_INTENSET_CMP_Msk & ((value) << RTC_MODE0_INTENSET_CMP_Pos)))
#define RTC_MODE0_INTENSET_SYNCRDY_Pos		6				/**< \brief (RTC_MODE0_INTENSET)荞݋ */
#define RTC_MODE0_INTENSET_SYNCRDY			(0x1u << RTC_MODE0_INTENSET_SYNCRDY_Pos)
#define RTC_MODE0_INTENSET_OVF_Pos			7				/**< \brief (RTC_MODE0_INTENSET)ꊄ荞݋ */
#define RTC_MODE0_INTENSET_OVF				(0x1u << RTC_MODE0_INTENSET_OVF_Pos)
#define RTC_MODE0_INTENSET_MASK				0xC1u			/**< \brief (RTC_MODE0_INTENSET)Օڼ޽ */

/* -------- RTC_MODE1_INTENSET : (RTCψ:0x07) (R/W  8) MODE1 MODE1荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CMP0:1;			/*!< ޯ   0: r0荞݋ */
    uint8_t  CMP1:1;			/*!< ޯ   1: r1荞݋ */
    uint8_t  :4;				/*!< ޯ2`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6: 荞݋ */
    uint8_t  OVF:1;				/*!< ޯ   7: ꊄ荞݋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  CMP:2;				/*!< ޯ0`1: rx荞݋ */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_INTENSET_OFFSET			0x07			/**< \brief (RTC_MODE1_INTENSET offset)MODE1荞݋ݒ */
#define RTC_MODE1_INTENSET_RESETVALUE		0x00			/**< \brief (RTC_MODE1_INTENSET reset_value)MODE1荞݋ݒ */

#define RTC_MODE1_INTENSET_CMP0_Pos			0				/**< \brief (RTC_MODE1_INTENSET)r0荞݋ */
#define RTC_MODE1_INTENSET_CMP0				(1 << RTC_MODE1_INTENSET_CMP0_Pos)
#define RTC_MODE1_INTENSET_CMP1_Pos			1				/**< \brief (RTC_MODE1_INTENSET)r1荞݋ */
#define RTC_MODE1_INTENSET_CMP1				(1 << RTC_MODE1_INTENSET_CMP1_Pos)
#define RTC_MODE1_INTENSET_CMP_Pos			0				/**< \brief (RTC_MODE1_INTENSET)rx荞݋ */
#define RTC_MODE1_INTENSET_CMP_Msk			(0x3u << RTC_MODE1_INTENSET_CMP_Pos)
#define RTC_MODE1_INTENSET_CMP(value)		((RTC_MODE1_INTENSET_CMP_Msk & ((value) << RTC_MODE1_INTENSET_CMP_Pos)))
#define RTC_MODE1_INTENSET_SYNCRDY_Pos		6				/**< \brief (RTC_MODE1_INTENSET)荞݋ */
#define RTC_MODE1_INTENSET_SYNCRDY			(0x1u << RTC_MODE1_INTENSET_SYNCRDY_Pos)
#define RTC_MODE1_INTENSET_OVF_Pos			7				/**< \brief (RTC_MODE1_INTENSET)ꊄ荞݋ */
#define RTC_MODE1_INTENSET_OVF				(0x1u << RTC_MODE1_INTENSET_OVF_Pos)
#define RTC_MODE1_INTENSET_MASK				0xC3u			/**< \brief (RTC_MODE1_INTENSET)Օڼ޽ */

/* -------- RTC_MODE2_INTENSET : (RTCψ:0x07) (R/W  8) MODE2 MODE2荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  ALARM0:1;			/*!< ޯ   0: x0荞݋ */
    uint8_t  :5;				/*!< ޯ1`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6: 荞݋ */
    uint8_t  OVF:1;				/*!< ޯ   7: ꊄ荞݋ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  ALARM:1;			/*!< ޯ   0: xx荞݋֎~ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_INTENSET_OFFSET			0x07			/**< \brief (RTC_MODE2_INTENSET offset)MODE2荞݋ݒ */
#define RTC_MODE2_INTENSET_RESETVALUE		0x00			/**< \brief (RTC_MODE2_INTENSET reset_value)MODE2荞݋ݒ */

#define RTC_MODE2_INTENSET_ALARM0_Pos		0				/**< \brief (RTC_MODE2_INTENSET)x0荞݋ */
#define RTC_MODE2_INTENSET_ALARM0			(1 << RTC_MODE2_INTENSET_ALARM0_Pos)
#define RTC_MODE2_INTENSET_ALARM_Pos		0				/**< \brief (RTC_MODE2_INTENSET)xx荞݋֎~ */
#define RTC_MODE2_INTENSET_ALARM_Msk		(0x1u << RTC_MODE2_INTENSET_ALARM_Pos)
#define RTC_MODE2_INTENSET_ALARM(value)		((RTC_MODE2_INTENSET_ALARM_Msk & ((value) << RTC_MODE2_INTENSET_ALARM_Pos)))
#define RTC_MODE2_INTENSET_SYNCRDY_Pos		6				/**< \brief (RTC_MODE2_INTENSET)荞݋ */
#define RTC_MODE2_INTENSET_SYNCRDY			(0x1u << RTC_MODE2_INTENSET_SYNCRDY_Pos)
#define RTC_MODE2_INTENSET_OVF_Pos			7				/**< \brief (RTC_MODE2_INTENSET)ꊄ荞݋ */
#define RTC_MODE2_INTENSET_OVF				(0x1u << RTC_MODE2_INTENSET_OVF_Pos)
#define RTC_MODE2_INTENSET_MASK				0xC1u			/**< \brief (RTC_MODE2_INTENSET)Օڼ޽ */

/* -------- RTC_MODE0_INTFLAG : (RTCψ:0x08) (R/W  8) MODE0 MODE0荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CMP0:1;			/*!< ޯ   0: r0 */
    uint8_t  :5;				/*!< ޯ1`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6:  */
    uint8_t  OVF:1;				/*!< ޯ   7:  */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  CMP:1;				/*!< ޯ   0: rx */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE0_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE0_INTFLAG_OFFSET			0x08			/**< \brief (RTC_MODE0_INTFLAG offset)MODE0荞׸ޏ/ */
#define RTC_MODE0_INTFLAG_RESETVALUE		0x00			/**< \brief (RTC_MODE0_INTFLAG reset_value)MODE0荞׸ޏ/ */

#define RTC_MODE0_INTFLAG_CMP0_Pos			0				/**< \brief (RTC_MODE0_INTFLAG)r0 */
#define RTC_MODE0_INTFLAG_CMP0				(1 << RTC_MODE0_INTFLAG_CMP0_Pos)
#define RTC_MODE0_INTFLAG_CMP_Pos			0				/**< \brief (RTC_MODE0_INTFLAG)rx */
#define RTC_MODE0_INTFLAG_CMP_Msk			(0x1u << RTC_MODE0_INTFLAG_CMP_Pos)
#define RTC_MODE0_INTFLAG_CMP(value)		((RTC_MODE0_INTFLAG_CMP_Msk & ((value) << RTC_MODE0_INTFLAG_CMP_Pos)))
#define RTC_MODE0_INTFLAG_SYNCRDY_Pos		6				/**< \brief (RTC_MODE0_INTFLAG) */
#define RTC_MODE0_INTFLAG_SYNCRDY			(0x1u << RTC_MODE0_INTFLAG_SYNCRDY_Pos)
#define RTC_MODE0_INTFLAG_OVF_Pos			7				/**< \brief (RTC_MODE0_INTFLAG) */
#define RTC_MODE0_INTFLAG_OVF				(0x1u << RTC_MODE0_INTFLAG_OVF_Pos)
#define RTC_MODE0_INTFLAG_MASK				0xC1u			/**< \brief (RTC_MODE0_INTFLAG)Օڼ޽ */

/* -------- RTC_MODE1_INTFLAG : (RTCψ:0x08) (R/W  8) MODE1 MODE1荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CMP0:1;			/*!< ޯ   0: r0 */
    uint8_t  CMP1:1;			/*!< ޯ   1: r1 */
    uint8_t  :4;				/*!< ޯ2`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6:  */
    uint8_t  OVF:1;				/*!< ޯ   7:  */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  CMP:2;				/*!< ޯ0`1: rx */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_INTFLAG_OFFSET			0x08			/**< \brief (RTC_MODE1_INTFLAG offset)MODE1荞׸ޏ/ */
#define RTC_MODE1_INTFLAG_RESETVALUE		0x00			/**< \brief (RTC_MODE1_INTFLAG reset_value)MODE1荞׸ޏ/ */

#define RTC_MODE1_INTFLAG_CMP0_Pos			0				/**< \brief (RTC_MODE1_INTFLAG)r0 */
#define RTC_MODE1_INTFLAG_CMP0				(1 << RTC_MODE1_INTFLAG_CMP0_Pos)
#define RTC_MODE1_INTFLAG_CMP1_Pos			1				/**< \brief (RTC_MODE1_INTFLAG)r1 */
#define RTC_MODE1_INTFLAG_CMP1				(1 << RTC_MODE1_INTFLAG_CMP1_Pos)
#define RTC_MODE1_INTFLAG_CMP_Pos			0				/**< \brief (RTC_MODE1_INTFLAG)rx */
#define RTC_MODE1_INTFLAG_CMP_Msk			(0x3u << RTC_MODE1_INTFLAG_CMP_Pos)
#define RTC_MODE1_INTFLAG_CMP(value)		((RTC_MODE1_INTFLAG_CMP_Msk & ((value) << RTC_MODE1_INTFLAG_CMP_Pos)))
#define RTC_MODE1_INTFLAG_SYNCRDY_Pos		6				/**< \brief (RTC_MODE1_INTFLAG) */
#define RTC_MODE1_INTFLAG_SYNCRDY			(0x1u << RTC_MODE1_INTFLAG_SYNCRDY_Pos)
#define RTC_MODE1_INTFLAG_OVF_Pos			7				/**< \brief (RTC_MODE1_INTFLAG) */
#define RTC_MODE1_INTFLAG_OVF				(0x1u << RTC_MODE1_INTFLAG_OVF_Pos)
#define RTC_MODE1_INTFLAG_MASK				0xC3u			/**< \brief (RTC_MODE1_INTFLAG)Օڼ޽ */

/* -------- RTC_MODE2_INTFLAG : (RTCψ:0x08) (R/W  8) MODE2 MODE2荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  ALARM0:1;			/*!< ޯ   0: x0 */
    uint8_t  :5;				/*!< ޯ1`5: \ */
    uint8_t  SYNCRDY:1;			/*!< ޯ   6:  */
    uint8_t  OVF:1;				/*!< ޯ   7:  */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  ALARM:1;			/*!< ޯ   0: xx */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_INTFLAG_OFFSET			0x08			/**< \brief (RTC_MODE2_INTFLAG offset)MODE2荞׸ޏ/ */
#define RTC_MODE2_INTFLAG_RESETVALUE		0x00			/**< \brief (RTC_MODE2_INTFLAG reset_value)MODE2荞׸ޏ/ */

#define RTC_MODE2_INTFLAG_ALARM0_Pos		0				/**< \brief (RTC_MODE2_INTFLAG)x0 */
#define RTC_MODE2_INTFLAG_ALARM0			(1 << RTC_MODE2_INTFLAG_ALARM0_Pos)
#define RTC_MODE2_INTFLAG_ALARM_Pos			0				/**< \brief (RTC_MODE2_INTFLAG)xx */
#define RTC_MODE2_INTFLAG_ALARM_Msk			(0x1u << RTC_MODE2_INTFLAG_ALARM_Pos)
#define RTC_MODE2_INTFLAG_ALARM(value)		((RTC_MODE2_INTFLAG_ALARM_Msk & ((value) << RTC_MODE2_INTFLAG_ALARM_Pos)))
#define RTC_MODE2_INTFLAG_SYNCRDY_Pos		6				/**< \brief (RTC_MODE2_INTFLAG) */
#define RTC_MODE2_INTFLAG_SYNCRDY			(0x1u << RTC_MODE2_INTFLAG_SYNCRDY_Pos)
#define RTC_MODE2_INTFLAG_OVF_Pos			7				/**< \brief (RTC_MODE2_INTFLAG) */
#define RTC_MODE2_INTFLAG_OVF				(0x1u << RTC_MODE2_INTFLAG_OVF_Pos)
#define RTC_MODE2_INTFLAG_MASK				0xC1u			/**< \brief (RTC_MODE2_INTFLAG)Օڼ޽ */

/* -------- RTC_STATUS : (RTCψ:0x0A) (R/W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :7;				/*!< ޯ0`6: \ */
    uint8_t  SYNCBUSY:1;		/*!< ޯ   7: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_STATUS_OFFSET					0x0A			/**< \brief (RTC_STATUS offset) */
#define RTC_STATUS_RESETVALUE				0x00			/**< \brief (RTC_STATUS reset_value) */

#define RTC_STATUS_SYNCBUSY_Pos				7				/**< \brief (RTC_STATUS)Z */
#define RTC_STATUS_SYNCBUSY					(0x1u << RTC_STATUS_SYNCBUSY_Pos)
#define RTC_STATUS_MASK						0x80u			/**< \brief (RTC_STATUS)Օڼ޽ */

/* -------- RTC_DBGCTRL : (RTCψ:0x0B) (R/W  8)ޯސ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DBGRUN:1;			/*!< ޯ   0: ޯޒs */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_DBGCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_DBGCTRL_OFFSET					0x0B			/**< \brief (RTC_DBGCTRL offset)ޯސ */
#define RTC_DBGCTRL_RESETVALUE				0x00			/**< \brief (RTC_DBGCTRL reset_value)ޯސ */

#define RTC_DBGCTRL_DBGRUN_Pos				0				/**< \brief (RTC_DBGCTRL)ޯޒs */
#define RTC_DBGCTRL_DBGRUN					(0x1u << RTC_DBGCTRL_DBGRUN_Pos)
#define RTC_DBGCTRL_MASK					0x01u			/**< \brief (RTC_DBGCTRL)Օڼ޽ */

/* -------- RTC_FREQCORR : (RTCψ:0x0C) (R/W  8)g␳ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  VALUE:7;			/*!< ޯ0`6: ␳l */
    uint8_t  SIGN:1;			/*!< ޯ   7: ␳ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_FREQCORR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_FREQCORR_OFFSET					0x0C			/**< \brief (RTC_FREQCORR offset)g␳ */
#define RTC_FREQCORR_RESETVALUE				0x00			/**< \brief (RTC_FREQCORR reset_value)g␳ */

#define RTC_FREQCORR_VALUE_Pos				0				/**< \brief (RTC_FREQCORR)␳l */
#define RTC_FREQCORR_VALUE_Msk				(0x7Fu << RTC_FREQCORR_VALUE_Pos)
#define RTC_FREQCORR_VALUE(value)			((RTC_FREQCORR_VALUE_Msk & ((value) << RTC_FREQCORR_VALUE_Pos)))
#define RTC_FREQCORR_SIGN_Pos				7				/**< \brief (RTC_FREQCORR)␳ */
#define RTC_FREQCORR_SIGN					(0x1u << RTC_FREQCORR_SIGN_Pos)
#define RTC_FREQCORR_MASK					0xFFu			/**< \brief (RTC_FREQCORR)Օڼ޽ */

/* -------- RTC_MODE0_COUNT : (RTCψ:0x10) (R/W 32) MODE0 MODE0vl -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t COUNT:32;			/*!< ޯ0`31: vl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE0_COUNT_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE0_COUNT_OFFSET				0x10			/**< \brief (RTC_MODE0_COUNT offset)MODE0vl */
#define RTC_MODE0_COUNT_RESETVALUE			0x00000000		/**< \brief (RTC_MODE0_COUNT reset_value)MODE0vl */

#define RTC_MODE0_COUNT_COUNT_Pos			0				/**< \brief (RTC_MODE0_COUNT)vl */
#define RTC_MODE0_COUNT_COUNT_Msk			(0xFFFFFFFFu << RTC_MODE0_COUNT_COUNT_Pos)
#define RTC_MODE0_COUNT_COUNT(value)		((RTC_MODE0_COUNT_COUNT_Msk & ((value) << RTC_MODE0_COUNT_COUNT_Pos)))
#define RTC_MODE0_COUNT_MASK				0xFFFFFFFFu		/**< \brief (RTC_MODE0_COUNT)Օڼ޽ */

/* -------- RTC_MODE1_COUNT : (RTCψ:0x10) (R/W 16) MODE1 MODE1vl -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t COUNT:16;			/*!< ޯ0`15: vl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_COUNT_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_COUNT_OFFSET				0x10			/**< \brief (RTC_MODE1_COUNT offset)MODE1vl */
#define RTC_MODE1_COUNT_RESETVALUE			0x0000			/**< \brief (RTC_MODE1_COUNT reset_value)MODE1vl */

#define RTC_MODE1_COUNT_COUNT_Pos			0				/**< \brief (RTC_MODE1_COUNT)vl */
#define RTC_MODE1_COUNT_COUNT_Msk			(0xFFFFu << RTC_MODE1_COUNT_COUNT_Pos)
#define RTC_MODE1_COUNT_COUNT(value)		((RTC_MODE1_COUNT_COUNT_Msk & ((value) << RTC_MODE1_COUNT_COUNT_Pos)))
#define RTC_MODE1_COUNT_MASK				0xFFFFu			/**< \brief (RTC_MODE1_COUNT)Օڼ޽ */

/* -------- RTC_MODE2_CLOCK : (RTCψ:0x10) (R/W 32) MODE2 MODE2ۯl -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SECOND:6;			/*!< ޯ 0` 5: b */
    uint32_t MINUTE:6;			/*!< ޯ 6`11:  */
    uint32_t HOUR:5;			/*!< ޯ12`16:  */
    uint32_t DAY:5;				/*!< ޯ17`21:  */
    uint32_t MONTH:4;			/*!< ޯ22`25:  */
    uint32_t YEAR:6;			/*!< ޯ26`31: N */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_CLOCK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_CLOCK_OFFSET				0x10			/**< \brief (RTC_MODE2_CLOCK offset)MODE2ۯl */
#define RTC_MODE2_CLOCK_RESETVALUE			0x00000000		/**< \brief (RTC_MODE2_CLOCK reset_value)MODE2ۯl */

#define RTC_MODE2_CLOCK_SECOND_Pos			0				/**< \brief (RTC_MODE2_CLOCK)b */
#define RTC_MODE2_CLOCK_SECOND_Msk			(0x3Fu << RTC_MODE2_CLOCK_SECOND_Pos)
#define RTC_MODE2_CLOCK_SECOND(value)		((RTC_MODE2_CLOCK_SECOND_Msk & ((value) << RTC_MODE2_CLOCK_SECOND_Pos)))
#define RTC_MODE2_CLOCK_MINUTE_Pos			6				/**< \brief (RTC_MODE2_CLOCK) */
#define RTC_MODE2_CLOCK_MINUTE_Msk			(0x3Fu << RTC_MODE2_CLOCK_MINUTE_Pos)
#define RTC_MODE2_CLOCK_MINUTE(value)		((RTC_MODE2_CLOCK_MINUTE_Msk & ((value) << RTC_MODE2_CLOCK_MINUTE_Pos)))
#define RTC_MODE2_CLOCK_HOUR_Pos			12				/**< \brief (RTC_MODE2_CLOCK) */
#define RTC_MODE2_CLOCK_HOUR_Msk			(0x1Fu << RTC_MODE2_CLOCK_HOUR_Pos)
#define RTC_MODE2_CLOCK_HOUR(value)			((RTC_MODE2_CLOCK_HOUR_Msk & ((value) << RTC_MODE2_CLOCK_HOUR_Pos)))
#define   RTC_MODE2_CLOCK_HOUR_PM_Val			0x10u		/**< \brief (RTC_MODE2_CLOCK) ߌ㎞ */
#define RTC_MODE2_CLOCK_HOUR_PM				(RTC_MODE2_CLOCK_HOUR_PM_Val   << RTC_MODE2_CLOCK_HOUR_Pos)
#define RTC_MODE2_CLOCK_DAY_Pos				17				/**< \brief (RTC_MODE2_CLOCK) */
#define RTC_MODE2_CLOCK_DAY_Msk				(0x1Fu << RTC_MODE2_CLOCK_DAY_Pos)
#define RTC_MODE2_CLOCK_DAY(value)			((RTC_MODE2_CLOCK_DAY_Msk & ((value) << RTC_MODE2_CLOCK_DAY_Pos)))
#define RTC_MODE2_CLOCK_MONTH_Pos			22				/**< \brief (RTC_MODE2_CLOCK) */
#define RTC_MODE2_CLOCK_MONTH_Msk			(0xFu << RTC_MODE2_CLOCK_MONTH_Pos)
#define RTC_MODE2_CLOCK_MONTH(value)		((RTC_MODE2_CLOCK_MONTH_Msk & ((value) << RTC_MODE2_CLOCK_MONTH_Pos)))
#define RTC_MODE2_CLOCK_YEAR_Pos			26				/**< \brief (RTC_MODE2_CLOCK)N */
#define RTC_MODE2_CLOCK_YEAR_Msk			(0x3Fu << RTC_MODE2_CLOCK_YEAR_Pos)
#define RTC_MODE2_CLOCK_YEAR(value)			((RTC_MODE2_CLOCK_YEAR_Msk & ((value) << RTC_MODE2_CLOCK_YEAR_Pos)))
#define RTC_MODE2_CLOCK_MASK				0xFFFFFFFFu		/**< \brief (RTC_MODE2_CLOCK)Օڼ޽ */

/* -------- RTC_MODE1_PER : (RTCψ:0x14) (R/W 16) MODE1 MODE1v -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t PER:16;			/*!< ޯ0`15: v */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_PER_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_PER_OFFSET				0x14			/**< \brief (RTC_MODE1_PER offset)MODE1v */
#define RTC_MODE1_PER_RESETVALUE			0x0000			/**< \brief (RTC_MODE1_PER reset_value)MODE1v */

#define RTC_MODE1_PER_PER_Pos				0				/**< \brief (RTC_MODE1_PER)v */
#define RTC_MODE1_PER_PER_Msk				(0xFFFFu << RTC_MODE1_PER_PER_Pos)
#define RTC_MODE1_PER_PER(value)			((RTC_MODE1_PER_PER_Msk & ((value) << RTC_MODE1_PER_PER_Pos)))
#define RTC_MODE1_PER_MASK					0xFFFFu			/**< \brief (RTC_MODE1_PER)Օڼ޽ */

/* -------- RTC_MODE0_COMP : (RTCψ:0x18) (R/W 32) MODE0 MODE0rnl -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t COMP:32;			/*!< ޯ0`31: rl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE0_COMP_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE0_COMP_OFFSET				0x18			/**< \brief (RTC_MODE0_COMP offset)MODE0rnl */
#define RTC_MODE0_COMP_RESETVALUE			0x00000000		/**< \brief (RTC_MODE0_COMP reset_value)MODE0rnl */

#define RTC_MODE0_COMP_COMP_Pos				0				/**< \brief (RTC_MODE0_COMP)rl */
#define RTC_MODE0_COMP_COMP_Msk				(0xFFFFFFFFu << RTC_MODE0_COMP_COMP_Pos)
#define RTC_MODE0_COMP_COMP(value)			((RTC_MODE0_COMP_COMP_Msk & ((value) << RTC_MODE0_COMP_COMP_Pos)))
#define RTC_MODE0_COMP_MASK					0xFFFFFFFFu		/**< \brief (RTC_MODE0_COMP)Օڼ޽ */

/* -------- RTC_MODE1_COMP : (RTCψ:0x18) (R/W 16) MODE1 MODE1rnl -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t COMP:16;			/*!< ޯ0`15: rl */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE1_COMP_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE1_COMP_OFFSET				0x18			/**< \brief (RTC_MODE1_COMP offset)MODE1rnl */
#define RTC_MODE1_COMP_RESETVALUE			0x0000			/**< \brief (RTC_MODE1_COMP reset_value)MODE1rnl */

#define RTC_MODE1_COMP_COMP_Pos				0				/**< \brief (RTC_MODE1_COMP)rl */
#define RTC_MODE1_COMP_COMP_Msk				(0xFFFFu << RTC_MODE1_COMP_COMP_Pos)
#define RTC_MODE1_COMP_COMP(value)			((RTC_MODE1_COMP_COMP_Msk & ((value) << RTC_MODE1_COMP_COMP_Pos)))
#define RTC_MODE1_COMP_MASK					0xFFFFu			/**< \brief (RTC_MODE1_COMP)Օڼ޽ */

/* -------- RTC_MODE2_ALARM : (RTCψ:0x18) (R/W 32) MODE2 MODE2_ALARMxnl -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SECOND:6;			/*!< ޯ 0` 5: b */
    uint32_t MINUTE:6;			/*!< ޯ 6`11:  */
    uint32_t HOUR:5;			/*!< ޯ12`16:  */
    uint32_t DAY:5;				/*!< ޯ17`21:  */
    uint32_t MONTH:4;			/*!< ޯ22`25:  */
    uint32_t YEAR:6;			/*!< ޯ26`31: N */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_ALARM_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_ALARM_OFFSET				0x18			/**< \brief (RTC_MODE2_ALARM offset)MODE2_ALARMxnl */
#define RTC_MODE2_ALARM_RESETVALUE			0x00000000		/**< \brief (RTC_MODE2_ALARM reset_value)MODE2_ALARMxnl */

#define RTC_MODE2_ALARM_SECOND_Pos			0				/**< \brief (RTC_MODE2_ALARM)b */
#define RTC_MODE2_ALARM_SECOND_Msk			(0x3Fu << RTC_MODE2_ALARM_SECOND_Pos)
#define RTC_MODE2_ALARM_SECOND(value)		((RTC_MODE2_ALARM_SECOND_Msk & ((value) << RTC_MODE2_ALARM_SECOND_Pos)))
#define RTC_MODE2_ALARM_MINUTE_Pos			6				/**< \brief (RTC_MODE2_ALARM) */
#define RTC_MODE2_ALARM_MINUTE_Msk			(0x3Fu << RTC_MODE2_ALARM_MINUTE_Pos)
#define RTC_MODE2_ALARM_MINUTE(value)		((RTC_MODE2_ALARM_MINUTE_Msk & ((value) << RTC_MODE2_ALARM_MINUTE_Pos)))
#define RTC_MODE2_ALARM_HOUR_Pos			12				/**< \brief (RTC_MODE2_ALARM) */
#define RTC_MODE2_ALARM_HOUR_Msk			(0x1Fu << RTC_MODE2_ALARM_HOUR_Pos)
#define RTC_MODE2_ALARM_HOUR(value)			((RTC_MODE2_ALARM_HOUR_Msk & ((value) << RTC_MODE2_ALARM_HOUR_Pos)))
#define RTC_MODE2_ALARM_DAY_Pos				17				/**< \brief (RTC_MODE2_ALARM) */
#define RTC_MODE2_ALARM_DAY_Msk				(0x1Fu << RTC_MODE2_ALARM_DAY_Pos)
#define RTC_MODE2_ALARM_DAY(value)			((RTC_MODE2_ALARM_DAY_Msk & ((value) << RTC_MODE2_ALARM_DAY_Pos)))
#define RTC_MODE2_ALARM_MONTH_Pos			22				/**< \brief (RTC_MODE2_ALARM) */
#define RTC_MODE2_ALARM_MONTH_Msk			(0xFu << RTC_MODE2_ALARM_MONTH_Pos)
#define RTC_MODE2_ALARM_MONTH(value)		((RTC_MODE2_ALARM_MONTH_Msk & ((value) << RTC_MODE2_ALARM_MONTH_Pos)))
#define RTC_MODE2_ALARM_YEAR_Pos			26				/**< \brief (RTC_MODE2_ALARM)N */
#define RTC_MODE2_ALARM_YEAR_Msk			(0x3Fu << RTC_MODE2_ALARM_YEAR_Pos)
#define RTC_MODE2_ALARM_YEAR(value)			((RTC_MODE2_ALARM_YEAR_Msk & ((value) << RTC_MODE2_ALARM_YEAR_Pos)))
#define RTC_MODE2_ALARM_MASK				0xFFFFFFFFu		/**< \brief (RTC_MODE2_ALARM)Օڼ޽ */

/* -------- RTC_MODE2_MASK : (RTCψ:0x1C) (R/W  8) MODE2 MODE2_ALARMxnՕ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SEL:3;				/*!< ޯ0`2: xՕI */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} RTC_MODE2_MASK_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define RTC_MODE2_MASK_OFFSET				0x1C			/**< \brief (RTC_MODE2_MASK offset)MODE2_ALARMxnՕ */
#define RTC_MODE2_MASK_RESETVALUE			0x00			/**< \brief (RTC_MODE2_MASK reset_value)MODE2_ALARMxnՕ */

#define RTC_MODE2_MASK_SEL_Pos				0				/**< \brief (RTC_MODE2_MASK)xՕI */
#define RTC_MODE2_MASK_SEL_Msk				(0x7u << RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_SEL(value)			((RTC_MODE2_MASK_SEL_Msk & ((value) << RTC_MODE2_MASK_SEL_Pos)))
#define   RTC_MODE2_MASK_SEL_OFF_Val			0x0u		/**< \brief (RTC_MODE2_MASK) Alarm Disabled */
#define   RTC_MODE2_MASK_SEL_SS_Val				0x1u		/**< \brief (RTC_MODE2_MASK) Match seconds only */
#define   RTC_MODE2_MASK_SEL_MMSS_Val			0x2u		/**< \brief (RTC_MODE2_MASK) Match seconds and minutes only */
#define   RTC_MODE2_MASK_SEL_HHMMSS_Val			0x3u		/**< \brief (RTC_MODE2_MASK) Match seconds, minutes, and hours only */
#define   RTC_MODE2_MASK_SEL_DDHHMMSS_Val		0x4u		/**< \brief (RTC_MODE2_MASK) Match seconds, minutes, hours, and days only */
#define   RTC_MODE2_MASK_SEL_MMDDHHMMSS_Val		0x5u		/**< \brief (RTC_MODE2_MASK) Match seconds, minutes, hours, days, and months only */
#define   RTC_MODE2_MASK_SEL_YYMMDDHHMMSS_Val	0x6u		/**< \brief (RTC_MODE2_MASK) Match seconds, minutes, hours, days, months, and years */
#define RTC_MODE2_MASK_SEL_OFF				(RTC_MODE2_MASK_SEL_OFF_Val				<< RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_SEL_SS				(RTC_MODE2_MASK_SEL_SS_Val				<< RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_SEL_MMSS				(RTC_MODE2_MASK_SEL_MMSS_Val			<< RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_SEL_HHMMSS			(RTC_MODE2_MASK_SEL_HHMMSS_Val			<< RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_SEL_DDHHMMSS			(RTC_MODE2_MASK_SEL_DDHHMMSS_Val		<< RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_SEL_MMDDHHMMSS		(RTC_MODE2_MASK_SEL_MMDDHHMMSS_Val		<< RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_SEL_YYMMDDHHMMSS		(RTC_MODE2_MASK_SEL_YYMMDDHHMMSS_Val	<< RTC_MODE2_MASK_SEL_Pos)
#define RTC_MODE2_MASK_MASK					0x07u			/**< \brief (RTC_MODE2_MASK)Օڼ޽ */

/** \brief RtcMode2Alarmʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO RTC_MODE2_ALARM_Type		ALARM;			/**< \briefψ:0x00 (R/W 32)MODE2_ALARMxnl */
  __IO RTC_MODE2_MASK_Type		MASK;			/**< \briefψ:0x04 (R/W  8)MODE2_ALARMxnՕ */
	   RoReg8					Reserved1[0x3];
} RtcMode2Alarm;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief RTC_MODE0ʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* P32ޯĔr32ޯČv */
  __IO RTC_MODE0_CTRL_Type		CTRL;			/**< \briefψ:0x00 (R/W 16)MODE0 */
  __IO RTC_READREQ_Type			READREQ;		/**< \briefψ:0x02 (R/W 16)ǂݍݗv */
  __IO RTC_MODE0_EVCTRL_Type	EVCTRL;			/**< \briefψ:0x04 (R/W 16)MODE0ې */
  __IO RTC_MODE0_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x06 (R/W  8)MODE0荞݋ */
  __IO RTC_MODE0_INTENSET_Type	INTENSET;		/**< \briefψ:0x07 (R/W  8)MODE0荞݋ݒ */
  __IO RTC_MODE0_INTFLAG_Type	INTFLAG;		/**< \briefψ:0x08 (R/W  8)MODE0荞׸ޏ/ */
	   RoReg8					Reserved1[0x1];
  __IO RTC_STATUS_Type			STATUS;			/**< \briefψ:0x0A (R/W  8) */
  __IO RTC_DBGCTRL_Type			DBGCTRL;		/**< \briefψ:0x0B (R/W  8)ޯސ */
  __IO RTC_FREQCORR_Type		FREQCORR;		/**< \briefψ:0x0C (R/W  8)g␳ */
	   RoReg8					Reserved2[0x3];
  __IO RTC_MODE0_COUNT_Type		COUNT;			/**< \briefψ:0x10 (R/W 32)MODE0vl */
	   RoReg8					Reserved3[0x4];
  __IO RTC_MODE0_COMP_Type		COMP[1];		/**< \briefψ:0x18 (R/W 32)MODE0rnl [COMP32_NUM] */
} RtcMode0;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief RTC_MODE1ʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* 216ޯĔr16ޯČv */
  __IO RTC_MODE1_CTRL_Type		CTRL;			/**< \briefψ:0x00 (R/W 16)MODE1 */
  __IO RTC_READREQ_Type			READREQ;		/**< \briefψ:0x02 (R/W 16)ǂݍݗv */
  __IO RTC_MODE1_EVCTRL_Type	EVCTRL;			/**< \briefψ:0x04 (R/W 16)MODE1ې */
  __IO RTC_MODE1_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x06 (R/W  8)MODE1荞݋ */
  __IO RTC_MODE1_INTENSET_Type	INTENSET;		/**< \briefψ:0x07 (R/W  8)MODE1荞݋ݒ */
  __IO RTC_MODE1_INTFLAG_Type	INTFLAG;		/**< \briefψ:0x08 (R/W  8)MODE1荞׸ޏ/ */
	   RoReg8					Reserved1[0x1];
  __IO RTC_STATUS_Type			STATUS;			/**< \briefψ:0x0A (R/W  8) */
  __IO RTC_DBGCTRL_Type			DBGCTRL;		/**< \briefψ:0x0B (R/W  8)ޯސ */
  __IO RTC_FREQCORR_Type		FREQCORR;		/**< \briefψ:0x0C (R/W  8)g␳ */
	   RoReg8					Reserved2[0x3];
  __IO RTC_MODE1_COUNT_Type		COUNT;			/**< \briefψ:0x10 (R/W 16)MODE1vl */
	   RoReg8					Reserved3[0x2];
  __IO RTC_MODE1_PER_Type		PER;			/**< \briefψ:0x14 (R/W 16)MODE1v */
	   RoReg8					Reserved4[0x2];
  __IO RTC_MODE1_COMP_Type		COMP[2];		/**< \briefψ:0x18 (R/W 16)MODE1rnl [COMP16_NUM] */
} RtcMode1;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief RTC_MODE2ʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct { /* xv/ */
  __IO RTC_MODE2_CTRL_Type		CTRL;			/**< \briefψ:0x00 (R/W 16)MODE2 */
  __IO RTC_READREQ_Type			READREQ;		/**< \briefψ:0x02 (R/W 16)ǂݍݗv */
  __IO RTC_MODE2_EVCTRL_Type	EVCTRL;			/**< \briefψ:0x04 (R/W 16)MODE2ې */
  __IO RTC_MODE2_INTENCLR_Type	INTENCLR;		/**< \briefψ:0x06 (R/W  8)MODE2荞݋ */
  __IO RTC_MODE2_INTENSET_Type	INTENSET;		/**< \briefψ:0x07 (R/W  8)MODE2荞݋ݒ */
  __IO RTC_MODE2_INTFLAG_Type	INTFLAG;		/**< \briefψ:0x08 (R/W  8)MODE2荞׸ޏ/ */
	   RoReg8					Reserved1[0x1];
  __IO RTC_STATUS_Type			STATUS;			/**< \briefψ:0x0A (R/W  8) */
  __IO RTC_DBGCTRL_Type			DBGCTRL;		/**< \briefψ:0x0B (R/W  8)ޯސ */
  __IO RTC_FREQCORR_Type		FREQCORR;		/**< \briefψ:0x0C (R/W  8)g␳ */
	   RoReg8					Reserved2[0x3];
  __IO RTC_MODE2_CLOCK_Type		CLOCK;			/**< \briefψ:0x10 (R/W 32)MODE2ۯl */
	   RoReg8					Reserved3[0x4];
					RtcMode2Alarm			Mode2Alarm[1];	/**< \briefψ:0x18 RtcMode2Alarm groups [ALARM_NUM] */
} RtcMode2;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
	   RtcMode0					MODE0;			/**< \briefψ:0x00 P32ޯĔr32ޯČv */
	   RtcMode1					MODE1;			/**< \briefψ:0x00 216ޯĔr16ޯČv */
	   RtcMode2					MODE2;			/**< \briefψ:0x00 xv/ */
} Rtc;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_RTC_COMPONENT_ */
