/**
 * \file
 *
 * \brief ԕ`
 *
 * ̧ق͐܂͎słȂǂ̎s̎ނA֐ɂĕԂ
 * lXȏԕ`܂B
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef STATUS_CODES_H_INCLUDED
#define STATUS_CODES_H_INCLUDED

#include <stdint.h>

/**
 * \defgroup group_sam0_utils_status_codes ԕ
 *
 * \ingroup group_sam0_utils
 *
 * @{
 */

/** ԕُ̈敪擾邽߂̎Օ */
#define STATUS_CATEGORY_MASK	0xF0

/** ԕ̋敪ُ̈필擾邽߂̎Օ */
#define STATUS_ERROR_MASK		0x0F

/** ԕُ敪 */
enum status_categories {
	STATUS_CATEGORY_OK			= 0x00,
	STATUS_CATEGORY_COMMON		= 0x10,
	STATUS_CATEGORY_ANALOG		= 0x30,
	STATUS_CATEGORY_COM			= 0x40,
	STATUS_CATEGORY_IO			= 0x50,
};

/**
 * ٖ߂ɂĕԂ邩ȂԕƋK
 *
 * \note ̏ԕƑΉү-ޕւ̂ǂ̕ύXɋւ
 *       BVǉ邱Ƃł܂AǂAꂩүޕ
 *       \ɍXV邱ƂmɂĂB
 */
enum status_code {
	STATUS_OK							= STATUS_CATEGORY_OK     | 0x00,
	STATUS_VALID_DATA					= STATUS_CATEGORY_OK     | 0x01,
	STATUS_NO_CHANGE					= STATUS_CATEGORY_OK     | 0x02,
	STATUS_ABORTED						= STATUS_CATEGORY_OK     | 0x04,
	STATUS_BUSY							= STATUS_CATEGORY_OK     | 0x05,
	STATUS_SUSPEND						= STATUS_CATEGORY_OK     | 0x06,

	STATUS_ERR_IO						= STATUS_CATEGORY_COMMON | 0x00,
	STATUS_ERR_REQ_FLUSHED				= STATUS_CATEGORY_COMMON | 0x01,
	STATUS_ERR_TIMEOUT					= STATUS_CATEGORY_COMMON | 0x02,
	STATUS_ERR_BAD_DATA					= STATUS_CATEGORY_COMMON | 0x03,
	STATUS_ERR_NOT_FOUND				= STATUS_CATEGORY_COMMON | 0x04,
	STATUS_ERR_UNSUPPORTED_DEV			= STATUS_CATEGORY_COMMON | 0x05,
	STATUS_ERR_NO_MEMORY				= STATUS_CATEGORY_COMMON | 0x06,
	STATUS_ERR_INVALID_ARG				= STATUS_CATEGORY_COMMON | 0x07,
	STATUS_ERR_BAD_ADDRESS				= STATUS_CATEGORY_COMMON | 0x08,
	STATUS_ERR_BAD_FORMAT				= STATUS_CATEGORY_COMMON | 0x0A,
	STATUS_ERR_BAD_FRQ					= STATUS_CATEGORY_COMMON | 0x0B,
	STATUS_ERR_DENIED					= STATUS_CATEGORY_COMMON | 0x0c,
	STATUS_ERR_ALREADY_INITIALIZED		= STATUS_CATEGORY_COMMON | 0x0d,
	STATUS_ERR_OVERFLOW					= STATUS_CATEGORY_COMMON | 0x0e,
	STATUS_ERR_NOT_INITIALIZED			= STATUS_CATEGORY_COMMON | 0x0f,

	STATUS_ERR_SAMPLERATE_UNAVAILABLE	= STATUS_CATEGORY_ANALOG | 0x00,
	STATUS_ERR_RESOLUTION_UNAVAILABLE	= STATUS_CATEGORY_ANALOG | 0x01,

	STATUS_ERR_BAUDRATE_UNAVAILABLE		= STATUS_CATEGORY_COM    | 0x00,
	STATUS_ERR_PACKET_COLLISION			= STATUS_CATEGORY_COM    | 0x01,
	STATUS_ERR_PROTOCOL					= STATUS_CATEGORY_COM    | 0x02,

	STATUS_ERR_PIN_MUX_INVALID			= STATUS_CATEGORY_IO     | 0x00,
};
typedef enum status_code status_code_genare_t;

/**
  MACɂĎgpԕ
 */
enum status_code_wireless {
//	STATUS_OK					=   0,	//!< 
	ERR_IO_ERROR				=  -1,	//!< I/Oُ
	ERR_FLUSHED					=  -2,	//!< ҂s񂩂vj
	ERR_TIMEOUT					=  -3,	//!< 쐧Ԓ
	ERR_BAD_DATA				=  -4,	//!< ްSs
	ERR_PROTOCOL				=  -5,	//!< K
	ERR_UNSUPPORTED_DEV			=  -6,	//!< x޲
	ERR_NO_MEMORY				=  -7,	//!< s[
	ERR_INVALID_ARG				=  -8,	//!< Ȉ
	ERR_BAD_ADDRESS				=  -9,	//!< Ԉڽ
	ERR_BUSY					= -10,	//!< Z
	ERR_BAD_FORMAT				= -11,	//!< F؂Ȃް`
	ERR_NO_TIMER				= -12,	//!< p\ȌvȂ
	ERR_TIMER_ALREADY_RUNNING	= -13,	//!< vɑs
	ERR_TIMER_NOT_RUNNING		= -14,	//!< v푖sȂ

	/**
	 * \brief is
	 *
	 * ̏ԕ͑삪ݎs鎞ײޓgppłB
	 *
	 * \note ײނ͂ǂ̌Ăяoɑ΂Ă̏ԕĕԂׂł͂
	 *       ܂B͌ɓgppłB
	 */
	OPERATION_IN_PROGRESS		= -128,
};

typedef enum status_code_wireless status_code_t;

/** @} */

#endif /* STATUS_CODES_H_INCLUDED */
